!+
      SUBROUTINE CH4
! ---------------------------------------------------------------------------
! PURPOSE - Load the common block /FLUDPC/
!.....METHANE TABLES FOR FLUID SUBPROGRAM.                              

!      WRITTEN BY: THEODORE E. FESSLER, NASA TM X-3572, AUGUST 1977
!      REWRITTEN BY: LT. MARK D. KLEM & MARGARET P. PROCTOR, JANUARY 198
!                                                                       
!      THE ORIGINAL PROGRAM WAS WRITTEN IN SFTRAN, BUT THIS PROGRAM IS  
!      REWRITTEN IN STANDARD FORTRAN 77 TO RUN PRIMARILY ON PERSONAL    
!      COMPUTERS AND CAN ALSO RUN ON MAINFRAMES. MUCH OF THE OLD CODE WA
!      COMMENTED OUT BUT LEFT INTACT FOR DOCUMENTATION AND REFERENCE    
!      PURPOSES.                                                        
!                                                                       
  INTERFACE
    SUBROUTINE Fluid(T,P,RHO,PROPS,NP,ENTRY,VAPOR,ERROR,igoto)
      REAL,INTENT(IN OUT):: t
      REAL,INTENT(IN OUT):: p
      REAL,INTENT(IN OUT):: rho
      REAL,INTENT(OUT),DIMENSION(:):: props
      INTEGER,INTENT(IN):: np
      INTEGER,INTENT(IN):: entry
      LOGICAL,INTENT(OUT):: vapor
      INTEGER,INTENT(OUT):: error
      INTEGER,INTENT(IN):: igoto
    END Subroutine Fluid
  END INTERFACE
                                                                        
!                -- UNITS --                                            
                                                                        
!       R = 0.51825 JOULES / GRAM - DEG. K      C(1)                    
!       TCRIT = 190.77 DEG. K                   C(2)                    
!       PCRIT = 4.627 MEGA-NEWTONS / METER**2   C(3)                    
!       DCRIT = 0.162   GRAMS / CENTIMETER**3   C(4)                    
!       VISCOSITY = GRAMS / CENTIMETER - SEC.        PROP(7)            
!       CONDUCTIVITY = WATTS / CENTIMETER - DEG. K   PROP(8)            
                                                                        
!     DIMENSION G(19,4),TT(21),DD(28),GG(21,28,8),SAT(40,8),C(8),M(4)   
!********************************************************************** 
      DIMENSION G(29,4),TT(27),DD(30),GG(27,30,8),SAT(40,8),C(8),M(4) 
       INTEGER ERROR,ENTRY 
       DIMENSION PROPS(8) 
       LOGICAL VAPOR 
!********************************************************************** 
                                                                        
      DIMENSION X0001(100),X0101(100),X0201(100),X0301(100),X0401(100), &
     &          X0501(100),X0601(100),X0701(100),X0801(100),X0901(100), &
     &          X1001(100),X1101(100),X1201(100),X1301(100),X1401(100), &
     &          X1501(100),X1601(100),X1701(100),X1801(100),X1901(100), &
     &          X2001(100),X2101(100),X2201(100),X2301(100),X2401(100), &
     &          X2501(100),X2601(100),X2701(100),X2801(100),X2901(100), &
     &          X3001(100),X3101(100),X3201(100),X3301(100),X3401(100), &
     &          X3501(100),X3601(100),X3701(100),X3801(100),X3901(100), &
     &          X4001(100),X4101(100),X4201(100),X4301(100),X4401(100), &
     &          X4501(100),X4601(100),X4701(100),X4801(100),X4901(100), &
     &          X5001(100),X5101(57)                                    
                                                                        
      DIMENSION Z(5157) 
!********************************************************************** 
       COMMON /FLUDPC/ G,TT,DD,GG,SAT,C,M,NG,N1,N2,N3,NS 
!********************************************************************** 
      EQUIVALENCE (X0001,Z(0001)), (X0101,Z(0101)), (X0201,Z(0201)),    &
     &            (X0301,Z(0301)), (X0401,Z(0401)), (X0501,Z(0501)),    &
     &            (X0601,Z(0601)), (X0701,Z(0701)), (X0801,Z(0801)),    &
     &            (X0901,Z(0901)), (X1001,Z(1001)), (X1101,Z(1101)),    &
     &            (X1201,Z(1201)), (X1301,Z(1301)), (X1401,Z(1401)),    &
     &            (X1501,Z(1501)), (X1601,Z(1601)), (X1701,Z(1701)),    &
     &            (X1801,Z(1801)), (X1901,Z(1901)), (X2001,Z(2001)),    &
     &            (X2101,Z(2101)), (X2201,Z(2201)), (X2301,Z(2301)),    &
     &            (X2401,Z(2401)), (X2501,Z(2501)), (X2601,Z(2601)),    &
     &            (X2701,Z(2701)), (X2801,Z(2801)), (X2901,Z(2901)),    &
     &            (X3001,Z(3001)), (X3101,Z(3101)), (X3201,Z(3201)),    &
     &            (X3301,Z(3301)), (X3401,Z(3401)), (X3501,Z(3501)),    &
     &            (X3601,Z(3601)), (X3701,Z(3701)), (X3801,Z(3801)),    &
     &            (X3901,Z(3901)), (X4001,Z(4001)), (X4101,Z(4101)),    &
     &            (X4201,Z(4201)), (X4301,Z(4301)), (X4401,Z(4401)),    &
     &            (X4501,Z(4501)), (X4601,Z(4601)), (X4701,Z(4701)),    &
     &            (X4801,Z(4801)), (X4901,Z(4901)), (X5001,Z(5001)),    &
     &            (X5101,Z(5101))                                       
                                                                        
!********************************************************************** 
!********************************************************************** 
                                                                        
      DATA X0001/ 4.8000E-1, 5.0000E-1, 6.0000E-1, 7.0000E-1, 8.0000E-1,&
     & 9.0000E-1, 9.5000E-1, 1.0000E+0, 1.0500E+0, 1.1000E+0, 1.2000E+0,&
     & 1.4000E+0, 1.8000E+0, 2.0000E+0, 2.4000E+0, 2.6000E+0, 2.8000E+0,&
     & 3.0000E+0, 3.1450E+0, 1.5203E+1, 1.5327E+1, 1.5879E+1, 1.6343E+1,&
     & 1.6745E+1, 1.7099E+1, 1.7262E+1, 1.7416E+1, 1.7564E+1, 1.7705E+1,&
     & 1.7970E+1, 1.8451E+1, 1.9287E+1, 1.9671E+1, 2.0405E+1, 2.0758E+1,&
     & 2.1101E+1, 2.1431E+1, 2.1657E+1, 7.0763E+0, 7.1310E+0, 7.4039E+0,&
     & 7.6756E+0, 7.9466E+0, 8.2173E+0, 8.3528E+0, 8.4886E+0, 8.6248E+0,&
     & 8.7615E+0, 9.0371E+0, 9.6012E+0, 1.0816E+1, 1.1486E+1, 1.2979E+1,&
     & 1.3803E+1, 1.4670E+1, 1.5564E+1, 1.6217E+1, 3.0358E+0, 3.0333E+0,&
     & 3.0208E+0, 3.0105E+0, 3.0052E+0, 3.0069E+0, 3.0110E+0, 3.0175E+0,&
     & 3.0267E+0, 3.0386E+0, 3.0712E+0, 3.1740E+0, 3.5292E+0, 3.7685E+0,&
     & 4.2950E+0, 4.5346E+0, 4.7173E+0, 4.8050E+0, 4.7845E+0, 4.8000E-1,&
     & 5.5100E-1, 6.3300E-1, 7.1400E-1, 8.3500E-1, 8.7300E-1, 9.0700E-1,&
     & 9.4200E-1, 9.6300E-1, 9.8200E-1, 9.9500E-1, 9.9800E-1, 1.0300E+0,&
     & 1.0800E+0, 1.1000E+0, 1.4000E+0, 1.8000E+0, 2.2000E+0, 2.4000E+0,&
     & 2.8000E+0, 3.1450E+0, 1.0070E-4, 1.5000E-3, 6.0000E-3/           
      DATA X0101/ 2.0000E-2, 5.0000E-2, 1.5000E-1, 2.0000E-1, 2.7000E-1,&
     & 3.7000E-1, 4.5000E-1, 5.7000E-1, 7.4000E-1, 8.2500E-1, 1.1900E+0,&
     & 1.3000E+0, 1.5000E+0, 1.6500E+0, 1.7200E+0, 1.9000E+0, 2.0000E+0,&
     & 2.1500E+0, 2.4500E+0, 2.6000E+0, 2.7000E+0, 2.7500E+0, 2.8500E+0,&
     & 2.9000E+0, 2.9500E+0, 1.2976E+0, 1.2977E+0, 1.2978E+0, 1.2979E+0,&
     & 1.2979E+0, 1.2980E+0, 1.2980E+0, 1.2980E+0, 1.2980E+0, 1.2980E+0,&
     & 1.2980E+0, 1.2980E+0, 1.2980E+0, 1.2980E+0, 1.2980E+0, 1.2980E+0,&
     & 1.2980E+0, 1.2981E+0, 1.2981E+0, 1.2981E+0, 1.2981E+0, 1.2911E+0,&
     & 1.2930E+0, 1.2945E+0, 1.2954E+0, 1.2962E+0, 1.2964E+0, 1.2966E+0,&
     & 1.2967E+0, 1.2968E+0, 1.2968E+0, 1.2969E+0, 1.2969E+0, 1.2970E+0,&
     & 1.2971E+0, 1.2971E+0, 1.2976E+0, 1.2978E+0, 1.2980E+0, 1.2980E+0,&
     & 1.2981E+0, 1.2981E+0, 1.2715E+0, 1.2781E+0, 1.2837E+0, 1.2873E+0,&
     & 1.2907E+0, 1.2915E+0, 1.2920E+0, 1.2926E+0, 1.2929E+0, 1.2931E+0,&
     & 1.2933E+0, 1.2933E+0, 1.2936E+0, 1.2941E+0, 1.2943E+0, 1.2960E+0,&
     & 1.2971E+0, 1.2977E+0, 1.2979E+0, 1.2982E+0, 1.2983E+0, 1.2187E+0,&
     & 1.2352E+0, 1.2508E+0, 1.2627E+0, 1.2738E+0, 1.2763E+0, 1.2782E+0,&
     & 1.2799E+0, 1.2809E+0, 1.2817E+0, 1.2822E+0, 1.2823E+0/           
      DATA X0201/ 1.2835E+0, 1.2851E+0, 1.2856E+0, 1.2913E+0, 1.2949E+0,&
     & 1.2968E+0, 1.2974E+0, 1.2983E+0, 1.2989E+0, 1.1253E+0, 1.1563E+0,&
     & 1.1870E+0, 1.2118E+0, 1.2389E+0, 1.2449E+0, 1.2496E+0, 1.2538E+0,&
     & 1.2561E+0, 1.2580E+0, 1.2593E+0, 1.2596E+0, 1.2624E+0, 1.2663E+0,&
     & 1.2677E+0, 1.2816E+0, 1.2903E+0, 1.2948E+0, 1.2964E+0, 1.2987E+0,&
     & 1.3001E+0, 8.6906E-1, 9.3794E-1, 1.0076E+0, 1.0661E+0, 1.1341E+0,&
     & 1.1507E+0, 1.1636E+0, 1.1753E+0, 1.1817E+0, 1.1871E+0, 1.1905E+0,&
     & 1.1913E+0, 1.1992E+0, 1.2099E+0, 1.2138E+0, 1.2522E+0, 1.2762E+0,&
     & 1.2888E+0, 1.2932E+0, 1.2996E+0, 1.3036E+0, 7.7805E-1, 8.5715E-1,&
     & 9.3800E-1, 1.0067E+0, 1.0889E+0, 1.1096E+0, 1.1261E+0, 1.1410E+0,&
     & 1.1492E+0, 1.1560E+0, 1.1604E+0, 1.1614E+0, 1.1715E+0, 1.1852E+0,&
     & 1.1901E+0, 1.2393E+0, 1.2700E+0, 1.2862E+0, 1.2918E+0, 1.3001E+0,&
     & 1.3053E+0, 6.6977E-1, 7.6089E-1, 8.5477E-1, 9.3552E-1, 1.0338E+0,&
     & 1.0592E+0, 1.0797E+0, 1.0985E+0, 1.1088E+0, 1.1174E+0, 1.1230E+0,&
     & 1.1243E+0, 1.1370E+0, 1.1544E+0, 1.1606E+0, 1.2231E+0, 1.2623E+0,&
     & 1.2831E+0, 1.2903E+0, 1.3011E+0, 1.3079E+0, 5.7080E-1, 6.6919E-1,&
     & 7.7197E-1, 8.6159E-1, 9.7260E-1, 1.0020E+0, 1.0262E+0/           
      DATA X0301/ 1.0489E+0, 1.0614E+0, 1.0721E+0, 1.0790E+0, 1.0806E+0,&
     & 1.0962E+0, 1.1178E+0, 1.1256E+0, 1.2036E+0, 1.2532E+0, 1.2800E+0,&
     & 1.2893E+0, 1.3033E+0, 1.3122E+0, 4.9780E-1, 6.0449E-1, 7.1606E-1,&
     & 8.1348E-1, 9.3475E-1, 9.6698E-1, 9.9349E-1, 1.0184E+0, 1.0322E+0,&
     & 1.0440E+0, 1.0516E+0, 1.0533E+0, 1.0707E+0, 1.0946E+0, 1.1033E+0,&
     & 1.1908E+0, 1.2476E+0, 1.2786E+0, 1.2894E+0, 1.3059E+0, 1.3165E+0,&
     & 4.6484E-1, 5.7349E-1, 6.7871E-1, 7.7686E-1, 9.0112E-1, 9.3384E-1,&
     & 9.6129E-1, 9.8738E-1, 1.0020E+0, 1.0145E+0, 1.0226E+0, 1.0245E+0,&
     & 1.0431E+0, 1.0691E+0, 1.0785E+0, 1.1759E+0, 1.2415E+0, 1.2784E+0,&
     & 1.2915E+0, 1.3116E+0, 1.3246E+0, 4.9556E-1, 5.8829E-1, 6.8700E-1,&
     & 7.7423E-1, 8.8655E-1, 9.1768E-1, 9.4348E-1, 9.6823E-1, 9.8224E-1,&
     & 9.9436E-1, 1.0023E+0, 1.0042E+0, 1.0226E+0, 1.0487E+0, 1.0583E+0,&
     & 1.1621E+0, 1.2374E+0, 1.2819E+0, 1.2981E+0, 1.3232E+0, 1.3396E+0,&
     & 5.5070E-1, 6.3043E-1, 7.1541E-1, 7.9184E-1, 8.9197E-1, 9.1996E-1,&
     & 9.4361E-1, 9.6657E-1, 9.7968E-1, 9.9110E-1, 9.9868E-1, 1.0004E+0,&
     & 1.0181E+0, 1.0435E+0, 1.0529E+0, 1.1577E+0, 1.2371E+0, 1.2852E+0,&
     & 1.3029E+0, 1.3305E+0, 1.3487E+0, 7.0018E-1, 7.4736E-1/           
      DATA X0401/ 7.9941E-1, 8.4813E-1, 9.1590E-1, 9.3595E-1, 9.5338E-1,&
     & 9.7085E-1, 9.8108E-1, 9.9019E-1, 9.9633E-1, 9.9774E-1, 1.0125E+0,&
     & 1.0348E+0, 1.0434E+0, 1.1509E+0, 1.2457E+0, 1.3081E+0, 1.3318E+0,&
     & 1.3696E+0, 1.3949E+0, 7.0966E-1, 7.5313E-1, 8.0240E-1, 8.4850E-1,&
     & 9.1357E-1, 9.3352E-1, 9.5065E-1, 9.6789E-1, 9.7809E-1, 9.8720E-1,&
     & 9.9336E-1, 9.9477E-1, 1.0097E+0, 1.0323E+0, 1.0410E+0, 1.1515E+0,&
     & 1.2506E+0, 1.3164E+0, 1.3416E+0, 1.3818E+0, 1.4088E+0, 6.5625E-1,&
     & 7.0923E-1, 7.6465E-1, 8.1909E-1, 8.9551E-1, 9.1797E-1, 9.3709E-1,&
     & 9.5651E-1, 9.6787E-1, 9.7796E-1, 9.8477E-1, 9.8633E-1, 1.0027E+0,&
     & 1.0272E+0, 1.0367E+0, 1.1545E+0, 1.2594E+0, 1.3295E+0, 1.3565E+0,&
     & 1.3997E+0, 1.4288E+0, 5.8203E-1, 6.4868E-1, 7.2144E-1, 7.8847E-1,&
     & 8.7798E-1, 9.0382E-1, 9.2605E-1, 9.4795E-1, 9.6064E-1, 9.7183E-1,&
     & 9.7932E-1, 9.8103E-1, 9.9884E-1, 1.0252E+0, 1.0352E+0, 1.1572E+0,&
     & 1.2635E+0, 1.3343E+0, 1.3616E+0, 1.4054E+0, 1.4350E+0, 5.4932E-1,&
     & 6.2305E-1, 7.0239E-1, 7.7539E-1, 8.7155E-1, 8.9900E-1, 9.2245E-1,&
     & 9.4543E-1, 9.5867E-1, 9.7029E-1, 9.7805E-1, 9.7982E-1, 9.9817E-1,&
     & 1.0251E+0, 1.0353E+0, 1.1580E+0, 1.2637E+0, 1.3339E+0/           
      DATA X0501/ 1.3610E+0, 1.4046E+0, 1.4340E+0, 4.7536E-1, 5.6772E-1,&
     & 6.6539E-1, 7.5229E-1, 8.6413E-1, 8.9484E-1, 9.2053E-1, 9.4520E-1,&
     & 9.5915E-1, 9.7125E-1, 9.7927E-1, 9.8109E-1, 9.9986E-1, 1.0270E+0,&
     & 1.0372E+0, 1.1559E+0, 1.2552E+0, 1.3209E+0, 1.3463E+0, 1.3874E+0,&
     & 1.4152E+0, 4.4830E-1, 5.5020E-1, 6.5662E-1, 7.4975E-1, 8.6679E-1,&
     & 8.9809E-1, 9.2389E-1, 9.4826E-1, 9.6194E-1, 9.7376E-1, 9.8157E-1,&
     & 9.8334E-1, 1.0015E+0, 1.0276E+0, 1.0374E+0, 1.1495E+0, 1.2421E+0,&
     & 1.3034E+0, 1.3271E+0, 1.3656E+0, 1.3918E+0, 4.4910E-1, 5.5681E-1,&
     & 6.6743E-1, 7.6227E-1, 8.7701E-1, 9.0642E-1, 9.3004E-1, 9.5211E-1,&
     & 9.6440E-1, 9.7496E-1, 9.8191E-1, 9.8348E-1, 9.9958E-1, 1.0225E+0,&
     & 1.0310E+0, 1.1271E+0, 1.2055E+0, 1.2576E+0, 1.2779E+0, 1.3109E+0,&
     & 1.3335E+0, 5.4843E-1, 6.3422E-1, 7.1912E-1, 7.8808E-1, 8.6349E-1,&
     & 8.8035E-1, 8.9357E-1, 9.0567E-1, 9.1230E-1, 9.1795E-1, 9.2163E-1,&
     & 9.2246E-1, 9.3090E-1, 9.4273E-1, 9.4707E-1, 9.9487E-1, 1.0338E+0,&
     & 1.0607E+0, 1.0715E+0, 1.0895E+0, 1.1022E+0, 5.5753E-1, 6.2986E-1,&
     & 6.9723E-1, 7.4677E-1, 7.8927E-1, 7.9820E-1, 8.0503E-1, 8.1115E-1,&
     & 8.1445E-1, 8.1723E-1, 8.1902E-1, 8.1943E-1, 8.2349E-1/           
      DATA X0601/ 8.2910E-1, 8.3113E-1, 8.5297E-1, 8.7123E-1, 8.8480E-1,&
     & 8.9054E-1, 9.0048E-1, 9.0774E-1, 5.2194E-1, 5.8695E-1, 6.3982E-1,&
     & 6.6866E-1, 6.9088E-1, 6.9507E-1, 6.9813E-1, 7.0074E-1, 7.0210E-1,&
     & 7.0321E-1, 7.0392E-1, 7.0408E-1, 7.0563E-1, 7.0767E-1, 7.0839E-1,&
     & 7.1561E-1, 7.2221E-1, 7.2813E-1, 7.3090E-1, 7.3603E-1, 7.4000E-1,&
     & 5.0218E-1, 5.5042E-1, 5.8880E-1, 6.0848E-1, 6.2204E-1, 6.2426E-1,&
     & 6.2576E-1, 6.2694E-1, 6.2751E-1, 6.2795E-1, 6.2821E-1, 6.2827E-1,&
     & 6.2881E-1, 6.2943E-1, 6.2963E-1, 6.3106E-1, 6.3301E-1, 6.3581E-1,&
     & 6.3735E-1, 6.4044E-1, 6.4300E-1, 3.8676E-1, 4.1436E-1, 4.2903E-1,&
     & 4.3449E-1, 4.3547E-1, 4.3497E-1, 4.3437E-1, 4.3365E-1, 4.3319E-1,&
     & 4.3276E-1, 4.3246E-1, 4.3239E-1, 4.3164E-1, 4.3047E-1, 4.3002E-1,&
     & 4.2438E-1, 4.2050E-1, 4.1912E-1, 4.1893E-1, 4.1909E-1, 4.1953E-1,&
     & 2.9350E-1, 3.0802E-1, 3.1447E-1, 3.1560E-1, 3.1344E-1, 3.1240E-1,&
     & 3.1141E-1, 3.1037E-1, 3.0975E-1, 3.0919E-1, 3.0881E-1, 3.0873E-1,&
     & 3.0781E-1, 3.0643E-1, 3.0591E-1, 2.9962E-1, 2.9506E-1, 2.9294E-1,&
     & 2.9238E-1, 2.9182E-1, 2.9168E-1, 1.6612E-1, 1.7122E-1, 1.7260E-1,&
     & 1.7177E-1, 1.6914E-1, 1.6822E-1, 1.6740E-1, 1.6658E-1/           
      DATA X0701/ 1.6609E-1, 1.6566E-1, 1.6538E-1, 1.6531E-1, 1.6462E-1,&
     & 1.6360E-1, 1.6321E-1, 1.5867E-1, 1.5531E-1, 1.5359E-1, 1.5307E-1,&
     & 1.5241E-1, 1.5210E-1, 1.0000E+0, 1.0000E+0, 9.9998E-1, 9.9999E-1,&
     & 9.9999E-1, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 9.9999E-1, 1.0000E+0, 1.0000E+0, 1.0000E+0, 9.9970E-1,&
     & 9.9980E-1, 9.9982E-1, 9.9988E-1, 9.9991E-1, 9.9993E-1, 9.9994E-1,&
     & 9.9995E-1, 9.9995E-1, 9.9995E-1, 9.9995E-1, 9.9995E-1, 9.9996E-1,&
     & 9.9996E-1, 9.9996E-1, 9.9998E-1, 9.9998E-1, 9.9997E-1, 9.9999E-1,&
     & 9.9999E-1, 9.9999E-1, 9.9880E-1, 9.9905E-1, 9.9929E-1, 9.9948E-1,&
     & 9.9965E-1, 9.9970E-1, 9.9972E-1, 9.9975E-1, 9.9976E-1, 9.9977E-1,&
     & 9.9978E-1, 9.9978E-1, 9.9980E-1, 9.9982E-1, 9.9983E-1, 9.9990E-1,&
     & 9.9993E-1, 9.9993E-1, 9.9995E-1, 9.9995E-1, 9.9995E-1, 9.9572E-1,&
     & 9.9665E-1, 9.9753E-1, 9.9818E-1, 9.9878E-1, 9.9892E-1, 9.9902E-1,&
     & 9.9911E-1, 9.9915E-1, 9.9919E-1, 9.9922E-1, 9.9922E-1, 9.9928E-1,&
     & 9.9936E-1, 9.9938E-1, 9.9963E-1, 9.9975E-1, 9.9978E-1, 9.9981E-1,&
     & 9.9983E-1, 9.9984E-1, 9.9043E-1, 9.9217E-1, 9.9389E-1/           
      DATA X0801/ 9.9530E-1, 9.9684E-1, 9.9719E-1, 9.9745E-1, 9.9768E-1,&
     & 9.9780E-1, 9.9790E-1, 9.9797E-1, 9.9798E-1, 9.9813E-1, 9.9833E-1,&
     & 9.9840E-1, 9.9903E-1, 9.9935E-1, 9.9946E-1, 9.9952E-1, 9.9956E-1,&
     & 9.9959E-1, 9.7227E-1, 9.7704E-1, 9.8183E-1, 9.8580E-1, 9.9024E-1,&
     & 9.9129E-1, 9.9208E-1, 9.9280E-1, 9.9318E-1, 9.9350E-1, 9.9370E-1,&
     & 9.9375E-1, 9.9421E-1, 9.9482E-1, 9.9504E-1, 9.9702E-1, 9.9801E-1,&
     & 9.9838E-1, 9.9851E-1, 9.9865E-1, 9.9873E-1, 9.6645E-1, 9.7173E-1,&
     & 9.7710E-1, 9.8164E-1, 9.8701E-1, 9.8835E-1, 9.8941E-1, 9.9037E-1,&
     & 9.9087E-1, 9.9130E-1, 9.9158E-1, 9.9164E-1, 9.9225E-1, 9.9308E-1,&
     & 9.9337E-1, 9.9602E-1, 9.9734E-1, 9.9784E-1, 9.9801E-1, 9.9819E-1,&
     & 9.9829E-1, 9.5651E-1, 9.6295E-1, 9.6974E-1, 9.7560E-1, 9.8257E-1,&
     & 9.8434E-1, 9.8574E-1, 9.8702E-1, 9.8770E-1, 9.8828E-1, 9.8865E-1,&
     & 9.8873E-1, 9.8956E-1, 9.9067E-1, 9.9106E-1, 9.9464E-1, 9.9641E-1,&
     & 9.9709E-1, 9.9730E-1, 9.9755E-1, 9.9768E-1, 9.4531E-1, 9.5337E-1,&
     & 9.6118E-1, 9.6854E-1, 9.7675E-1, 9.7896E-1, 9.8077E-1, 9.8243E-1,&
     & 9.8335E-1, 9.8412E-1, 9.8462E-1, 9.8473E-1, 9.8584E-1, 9.8734E-1,&
     & 9.8787E-1, 9.9271E-1, 9.9509E-1, 9.9600E-1, 9.9628E-1/           
      DATA X0901/ 9.9661E-1, 9.9679E-1, 9.3555E-1, 9.4458E-1, 9.5410E-1,&
     & 9.6251E-1, 9.7226E-1, 9.7487E-1, 9.7701E-1, 9.7898E-1, 9.8007E-1,&
     & 9.8099E-1, 9.8158E-1, 9.8171E-1, 9.8303E-1, 9.8481E-1, 9.8544E-1,&
     & 9.9120E-1, 9.9404E-1, 9.9513E-1, 9.9546E-1, 9.9585E-1, 9.9605E-1,&
     & 9.1406E-1, 9.2969E-1, 9.3799E-1, 9.5020E-1, 9.6558E-1, 9.6875E-1,&
     & 9.7163E-1, 9.7421E-1, 9.7558E-1, 9.7670E-1, 9.7741E-1, 9.7757E-1,&
     & 9.7915E-1, 9.8129E-1, 9.8205E-1, 9.8902E-1, 9.9246E-1, 9.9378E-1,&
     & 9.9417E-1, 9.9465E-1, 9.9490E-1, 9.1982E-1, 9.2897E-1, 9.4008E-1,&
     & 9.4881E-1, 9.6039E-1, 9.6391E-1, 9.6653E-1, 9.6901E-1, 9.7045E-1,&
     & 9.7167E-1, 9.7247E-1, 9.7265E-1, 9.7449E-1, 9.7699E-1, 9.7787E-1,&
     & 9.8607E-1, 9.9017E-1, 9.9175E-1, 9.9222E-1, 9.9280E-1, 9.9311E-1,&
     & 9.1292E-1, 9.2377E-1, 9.3520E-1, 9.4525E-1, 9.5793E-1, 9.6134E-1,&
     & 9.6417E-1, 9.6684E-1, 9.6834E-1, 9.6962E-1, 9.7046E-1, 9.7065E-1,&
     & 9.7255E-1, 9.7514E-1, 9.7606E-1, 9.8465E-1, 9.8898E-1, 9.9067E-1,&
     & 9.9117E-1, 9.9179E-1, 9.9213E-1, 8.3893E-1, 8.6565E-1, 8.9278E-1,&
     & 9.1560E-1, 9.4223E-1, 9.4876E-1, 9.5387E-1, 9.5840E-1, 9.6075E-1,&
     & 9.6266E-1, 9.6383E-1, 9.6409E-1, 9.6649E-1, 9.6900E-1/           
      DATA X1001/ 9.6990E-1, 9.7867E-1, 9.8338E-1, 9.8533E-1, 9.8593E-1,&
     & 9.8670E-1, 9.8714E-1, 9.6695E-2, 3.0759E-1, 5.1500E-1, 6.8109E-1,&
     & 8.5847E-1, 8.9665E-1, 9.2359E-1, 9.4431E-1, 9.5334E-1, 9.5931E-1,&
     & 9.6217E-1, 9.6269E-1, 9.6500E-1, 9.6739E-1, 9.6825E-1, 9.7678E-1,&
     & 9.8148E-1, 9.8346E-1, 9.8408E-1, 9.8489E-1, 9.8537E-1, 2.0352E+0,&
     & 1.7493E+0, 1.4709E+0, 1.2576E+0, 1.0459E+0, 1.0049E+0, 9.7926E-1,&
     & 9.6333E-1, 9.5887E-1, 9.5813E-1, 9.5943E-1, 9.5994E-1, 9.6208E-1,&
     & 9.6425E-1, 9.6504E-1, 9.7310E-1, 9.7773E-1, 9.7976E-1, 9.8041E-1,&
     & 9.8130E-1, 9.8183E-1, 1.5693E+0, 1.4043E+0, 1.2456E+0, 1.1228E+0,&
     & 1.0016E+0, 9.7911E-1, 9.6527E-1, 9.5720E-1, 9.5536E-1, 9.5565E-1,&
     & 9.5692E-1, 9.5742E-1, 9.5947E-1, 9.6153E-1, 9.6228E-1, 9.7009E-1,&
     & 9.7470E-1, 9.7676E-1, 9.7744E-1, 9.7838E-1, 9.7895E-1, 1.5728E+0,&
     & 1.4063E+0, 1.2463E+0, 1.1231E+0, 1.0008E+0, 9.7810E-1, 9.6410E-1,&
     & 9.5592E-1, 9.5405E-1, 9.5432E-1, 9.5557E-1, 9.5608E-1, 9.5811E-1,&
     & 9.6013E-1, 9.6087E-1, 9.6863E-1, 9.7324E-1, 9.7532E-1, 9.7601E-1,&
     & 9.7697E-1, 9.7756E-1, 8.8040E-1, 9.0042E-1, 9.1946E-1, 9.3390E-1,&
     & 9.4706E-1, 9.4915E-1, 9.5018E-1, 9.5042E-1, 9.5017E-1/           
      DATA X1101/ 9.5042E-1, 9.5168E-1, 9.5219E-1, 9.5422E-1, 9.5625E-1,&
     & 9.5699E-1, 9.6479E-1, 9.6946E-1, 9.7158E-1, 9.7229E-1, 9.7331E-1,&
     & 9.7395E-1, 8.3533E-1, 8.6798E-1, 8.9879E-1, 9.2189E-1, 9.4292E-1,&
     & 9.4619E-1, 9.4776E-1, 9.4804E-1, 9.4780E-1, 9.4807E-1, 9.4935E-1,&
     & 9.4987E-1, 9.5194E-1, 9.5401E-1, 9.5477E-1, 9.6271E-1, 9.6743E-1,&
     & 9.6957E-1, 9.7029E-1, 9.7133E-1, 9.7199E-1, 8.5535E-1, 8.8014E-1,&
     & 9.0381E-1, 9.2197E-1, 9.3928E-1, 9.4232E-1, 9.4406E-1, 9.4447E-1,&
     & 9.4429E-1, 9.4462E-1, 9.4595E-1, 9.4648E-1, 9.4866E-1, 9.5085E-1,&
     & 9.5165E-1, 9.5990E-1, 9.6471E-1, 9.6687E-1, 9.6759E-1, 9.6865E-1,&
     & 9.6933E-1, 8.8927E-1, 8.9934E-1, 9.1018E-1, 9.2007E-1, 9.3334E-1,&
     & 9.3713E-1, 9.3940E-1, 9.4022E-1, 9.4024E-1, 9.4074E-1, 9.4222E-1,&
     & 9.4279E-1, 9.4526E-1, 9.4779E-1, 9.4870E-1, 9.5774E-1, 9.6259E-1,&
     & 9.6460E-1, 9.6526E-1, 9.6621E-1, 9.6684E-1, 8.8350E-1, 8.9522E-1,&
     & 9.0786E-1, 9.1939E-1, 9.3487E-1, 9.3910E-1, 9.4167E-1, 9.4271E-1,&
     & 9.4283E-1, 9.4342E-1, 9.4498E-1, 9.4558E-1, 9.4820E-1, 9.5089E-1,&
     & 9.5186E-1, 9.6115E-1, 9.6580E-1, 9.6753E-1, 9.6807E-1, 9.6880E-1,&
     & 9.6928E-1, 8.8091E-1, 8.9505E-1, 9.1000E-1, 9.2333E-1/           
      DATA X1201/ 9.4029E-1, 9.4481E-1, 9.4756E-1, 9.4872E-1, 9.4889E-1,&
     & 9.4952E-1, 9.5114E-1, 9.5175E-1, 9.5446E-1, 9.5724E-1, 9.5824E-1,&
     & 9.6753E-1, 9.7181E-1, 9.7318E-1, 9.7355E-1, 9.7401E-1, 9.7428E-1,&
     & 8.8124E-1, 8.9714E-1, 9.1358E-1, 9.2779E-1, 9.4548E-1, 9.5013E-1,&
     & 9.5297E-1, 9.5417E-1, 9.5435E-1, 9.5500E-1, 9.5664E-1, 9.5726E-1,&
     & 9.6001E-1, 9.6281E-1, 9.6381E-1, 9.7299E-1, 9.7699E-1, 9.7807E-1,&
     & 9.7832E-1, 9.7855E-1, 9.7866E-1, 9.0665E-1, 9.1184E-1, 9.3118E-1,&
     & 9.4710E-1, 9.6610E-1, 9.7098E-1, 9.7392E-1, 9.7514E-1, 9.7530E-1,&
     & 9.7594E-1, 9.7762E-1, 9.7826E-1, 9.8104E-1, 9.8382E-1, 9.8480E-1,&
     & 9.9335E-1, 9.9626E-1, 9.9635E-1, 9.9615E-1, 9.9560E-1, 9.9514E-1,&
     & 9.2436E-1, 9.3092E-1, 9.5162E-1, 9.6828E-1, 9.8777E-1, 9.9270E-1,&
     & 9.9564E-1, 9.9679E-1, 9.9688E-1, 9.9748E-1, 9.9916E-1, 9.9981E-1,&
     & 1.0026E+0, 1.0052E+0, 1.0062E+0, 1.0139E+0, 1.0157E+0, 1.0148E+0,&
     & 1.0142E+0, 1.0129E+0, 1.0118E+0, 9.6784E-1, 9.7508E-1, 9.9684E-1,&
     & 1.0140E+0, 1.0335E+0, 1.0383E+0, 1.0411E+0, 1.0420E+0, 1.0419E+0,&
     & 1.0424E+0, 1.0440E+0, 1.0447E+0, 1.0473E+0, 1.0497E+0, 1.0505E+0,&
     & 1.0563E+0, 1.0557E+0, 1.0528E+0, 1.0513E+0, 1.0483E+0/           
      DATA X1301/ 1.0461E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 9.9995E-1, 1.0000E+0, 1.0000E+0, 1.0000E+0, 9.9944E-1,&
     & 9.9956E-1, 9.9966E-1, 9.9973E-1, 9.9981E-1, 9.9983E-1, 9.9984E-1,&
     & 9.9986E-1, 9.9986E-1, 9.9987E-1, 9.9987E-1, 9.9987E-1, 9.9988E-1,&
     & 9.9989E-1, 9.9990E-1, 9.9994E-1, 9.9996E-1, 9.9992E-1, 9.9997E-1,&
     & 9.9997E-1, 9.9997E-1, 9.9766E-1, 9.9813E-1, 9.9857E-1, 9.9888E-1,&
     & 9.9920E-1, 9.9927E-1, 9.9933E-1, 9.9939E-1, 9.9942E-1, 9.9944E-1,&
     & 9.9946E-1, 9.9946E-1, 9.9950E-1, 9.9955E-1, 9.9957E-1, 9.9974E-1,&
     & 9.9983E-1, 9.9981E-1, 9.9988E-1, 9.9988E-1, 9.9988E-1, 9.9245E-1,&
     & 9.9383E-1, 9.9516E-1, 9.9621E-1, 9.9729E-1, 9.9755E-1, 9.9775E-1,&
     & 9.9793E-1, 9.9803E-1, 9.9812E-1, 9.9817E-1, 9.9818E-1, 9.9831E-1,&
     & 9.9848E-1, 9.9854E-1, 9.9913E-1, 9.9944E-1, 9.9950E-1, 9.9958E-1,&
     & 9.9960E-1, 9.9961E-1, 9.8226E-1, 9.8517E-1, 9.8808E-1, 9.9048E-1,&
     & 9.9320E-1, 9.9384E-1, 9.9435E-1, 9.9481E-1, 9.9506E-1, 9.9527E-1,&
     & 9.9541E-1, 9.9544E-1, 9.9576E-1, 9.9619E-1, 9.9634E-1/           
      DATA X1401/ 9.9783E-1, 9.9860E-1, 9.9882E-1, 9.9894E-1, 9.9900E-1,&
     & 9.9902E-1, 9.4960E-1, 9.5723E-1, 9.6504E-1, 9.7166E-1, 9.7946E-1,&
     & 9.8141E-1, 9.8295E-1, 9.8436E-1, 9.8513E-1, 9.8578E-1, 9.8620E-1,&
     & 9.8629E-1, 9.8725E-1, 9.8857E-1, 9.8904E-1, 9.9354E-1, 9.9584E-1,&
     & 9.9660E-1, 9.9683E-1, 9.9700E-1, 9.9704E-1, 9.3497E-1, 9.4444E-1,&
     & 9.5419E-1, 9.6254E-1, 9.7260E-1, 9.7517E-1, 9.7723E-1, 9.7912E-1,&
     & 9.8015E-1, 9.8103E-1, 9.8160E-1, 9.8172E-1, 9.8301E-1, 9.8477E-1,&
     & 9.8540E-1, 9.9142E-1, 9.9447E-1, 9.9548E-1, 9.9577E-1, 9.9598E-1,&
     & 9.9602E-1, 9.1489E-1, 9.2679E-1, 9.3916E-1, 9.4992E-1, 9.6306E-1,&
     & 9.6648E-1, 9.6925E-1, 9.7182E-1, 9.7322E-1, 9.7441E-1, 9.7518E-1,&
     & 9.7535E-1, 9.7709E-1, 9.7948E-1, 9.8034E-1, 9.8848E-1, 9.9256E-1,&
     & 9.9390E-1, 9.9425E-1, 9.9451E-1, 9.9455E-1, 8.8843E-1, 9.0356E-1,&
     & 9.1895E-1, 9.3315E-1, 9.4989E-1, 9.5438E-1, 9.5808E-1, 9.6154E-1,&
     & 9.6346E-1, 9.6509E-1, 9.6614E-1, 9.6638E-1, 9.6877E-1, 9.7205E-1,&
     & 9.7322E-1, 9.8431E-1, 9.8979E-1, 9.9154E-1, 9.9197E-1, 9.9228E-1,&
     & 9.9230E-1, 8.6548E-1, 8.8354E-1, 9.0234E-1, 9.1934E-1, 9.3950E-1,&
     & 9.4492E-1, 9.4940E-1, 9.5357E-1, 9.5589E-1, 9.5786E-1/           
      DATA X1501/ 9.5914E-1, 9.5942E-1, 9.6231E-1, 9.6627E-1, 9.6768E-1,&
     & 9.8101E-1, 9.8751E-1, 9.8955E-1, 9.9002E-1, 9.9034E-1, 9.9034E-1,&
     & 8.2813E-1, 8.5596E-1, 8.7695E-1, 8.9819E-1, 9.2505E-1, 9.3164E-1,&
     & 9.3710E-1, 9.4232E-1, 9.4520E-1, 9.4763E-1, 9.4921E-1, 9.4956E-1,&
     & 9.5313E-1, 9.5801E-1, 9.5975E-1, 9.7611E-1, 9.8393E-1, 9.8630E-1,&
     & 9.8681E-1, 9.8712E-1, 9.8707E-1, 8.0617E-1, 8.3061E-1, 8.5690E-1,&
     & 8.7968E-1, 9.0831E-1, 9.1627E-1, 9.2264E-1, 9.2866E-1, 9.3205E-1,&
     & 9.3496E-1, 9.3685E-1, 9.3728E-1, 9.4158E-1, 9.4747E-1, 9.4957E-1,&
     & 9.6922E-1, 9.7836E-1, 9.8097E-1, 9.8148E-1, 9.8172E-1, 9.8159E-1,&
     & 7.9724E-1, 8.2246E-1, 8.4900E-1, 8.7238E-1, 9.0202E-1, 9.1003E-1,&
     & 9.1667E-1, 9.2299E-1, 9.2653E-1, 9.2956E-1, 9.3155E-1, 9.3201E-1,&
     & 9.3655E-1, 9.4278E-1, 9.4500E-1, 9.6575E-1, 9.7527E-1, 9.7791E-1,&
     & 9.7840E-1, 9.7858E-1, 9.7842E-1, 6.0437E-1, 6.7024E-1, 7.3709E-1,&
     & 7.9333E-1, 8.5916E-1, 8.7533E-1, 8.8799E-1, 8.9923E-1, 9.0510E-1,&
     & 9.0985E-1, 9.1279E-1, 9.1343E-1, 9.1946E-1, 9.2582E-1, 9.2810E-1,&
     & 9.4941E-1, 9.5876E-1, 9.6099E-1, 9.6132E-1, 9.6133E-1, 9.6109E-1,&
     &-1.2110E+0,-6.9525E-1,-1.8764E-1, 2.1890E-1, 6.5286E-1/           
      DATA X1601/ 7.4655E-1, 8.1268E-1, 8.6359E-1, 8.8580E-1, 9.0048E-1,&
     & 9.0757E-1, 9.0887E-1, 9.1472E-1, 9.2082E-1, 9.2301E-1, 9.4354E-1,&
     & 9.5248E-1, 9.5455E-1, 9.5485E-1, 9.5488E-1, 9.5467E-1, 3.5313E+0,&
     & 2.8306E+0, 2.1543E+0, 1.6301E+0, 1.1086E+0, 1.0089E+0, 9.4583E-1,&
     & 9.0692E-1, 8.9615E-1, 8.9452E-1, 8.9785E-1, 8.9913E-1, 9.0461E-1,&
     & 9.1017E-1, 9.1217E-1, 9.3109E-1, 9.3932E-1, 9.4125E-1, 9.4159E-1,&
     & 9.4178E-1, 9.4175E-1, 2.3789E+0, 1.9758E+0, 1.5890E+0, 1.2898E+0,&
     & 9.9547E-1, 9.4092E-1, 9.0749E-1, 8.8819E-1, 8.8399E-1, 8.8494E-1,&
     & 8.8820E-1, 8.8948E-1, 8.9476E-1, 9.0003E-1, 9.0193E-1, 9.2004E-1,&
     & 9.2805E-1, 9.3009E-1, 9.3054E-1, 9.3100E-1, 9.3118E-1, 2.3860E+0,&
     & 1.9800E+0, 1.5899E+0, 1.2881E+0, 9.9130E-1, 9.3626E-1, 9.0249E-1,&
     & 8.8295E-1, 8.7866E-1, 8.7957E-1, 8.8282E-1, 8.8409E-1, 8.8933E-1,&
     & 8.9454E-1, 8.9642E-1, 9.1439E-1, 9.2244E-1, 9.2460E-1, 9.2513E-1,&
     & 9.2575E-1, 9.2607E-1, 6.8130E-1, 7.3221E-1, 7.8056E-1, 8.1740E-1,&
     & 8.5204E-1, 8.5789E-1, 8.6108E-1, 8.6236E-1, 8.6215E-1, 8.6311E-1,&
     & 8.6641E-1, 8.6770E-1, 8.7302E-1, 8.7833E-1, 8.8025E-1, 8.9866E-1,&
     & 9.0723E-1, 9.0994E-1, 9.1073E-1, 9.1186E-1, 9.1257E-1/           
      DATA X1701/ 5.5901E-1, 6.4224E-1, 7.2110E-1, 7.8077E-1, 8.3620E-1,&
     & 8.4528E-1, 8.5003E-1, 8.5159E-1, 8.5154E-1, 8.5263E-1, 8.5600E-1,&
     & 8.5729E-1, 8.6277E-1, 8.6830E-1, 8.7029E-1, 8.8942E-1, 8.9850E-1,&
     & 9.0161E-1, 9.0259E-1, 9.0405E-1, 9.0499E-1, 5.8815E-1, 6.5512E-1,&
     & 7.1936E-1, 7.6906E-1, 8.1771E-1, 8.2668E-1, 8.3214E-1, 8.3439E-1,&
     & 8.3472E-1, 8.3611E-1, 8.3960E-1, 8.4091E-1, 8.4670E-1, 8.5269E-1,&
     & 8.5484E-1, 8.7541E-1, 8.8543E-1, 8.8921E-1, 8.9047E-1, 8.9244E-1,&
     & 8.9374E-1, 6.1693E-1, 6.5924E-1, 7.0228E-1, 7.3869E-1, 7.8176E-1,&
     & 7.9248E-1, 7.9939E-1, 8.0316E-1, 8.0439E-1, 8.0640E-1, 8.1000E-1,&
     & 8.1128E-1, 8.1753E-1, 8.2431E-1, 8.2674E-1, 8.4968E-1, 8.6124E-1,&
     & 8.6616E-1, 8.6790E-1, 8.7074E-1, 8.7266E-1, 5.8077E-1, 6.3292E-1,&
     & 6.8430E-1, 7.2574E-1, 7.7041E-1, 7.8131E-1, 7.8845E-1, 7.9264E-1,&
     & 7.9416E-1, 7.9632E-1, 7.9981E-1, 8.0102E-1, 8.0719E-1, 8.1400E-1,&
     & 8.1643E-1, 8.3939E-1, 8.5109E-1, 8.5625E-1, 8.5811E-1, 8.6119E-1,&
     & 8.6331E-1, 5.5423E-1, 6.2111E-1, 6.8113E-1, 7.2231E-1, 7.6624E-1,&
     & 7.7688E-1, 7.8393E-1, 7.8820E-1, 7.8981E-1, 7.9198E-1, 7.9533E-1,&
     & 7.9648E-1, 8.0244E-1, 8.0908E-1, 8.1145E-1, 8.3383E-1/           
      DATA X1801/ 8.4529E-1, 8.5043E-1, 8.5232E-1, 8.5546E-1, 8.5765E-1,&
     & 5.5752E-1, 6.2291E-1, 6.8168E-1, 7.2210E-1, 7.6517E-1, 7.7560E-1,&
     & 7.8253E-1, 7.8677E-1, 7.8839E-1, 7.9055E-1, 7.9380E-1, 7.9491E-1,&
     & 8.0073E-1, 8.0724E-1, 8.0956E-1, 8.3147E-1, 8.4271E-1, 8.4778E-1,&
     & 8.4966E-1, 8.5281E-1, 8.5501E-1, 5.8013E-1, 6.3185E-1, 6.8640E-1,&
     & 7.2437E-1, 7.6494E-1, 7.7477E-1, 7.8134E-1, 7.8543E-1, 7.8703E-1,&
     & 7.8908E-1, 7.9212E-1, 7.9316E-1, 7.9862E-1, 8.0476E-1, 8.0695E-1,&
     & 8.2760E-1, 8.3820E-1, 8.4304E-1, 8.4485E-1, 8.4794E-1, 8.5012E-1,&
     & 5.8975E-1, 6.3839E-1, 6.9029E-1, 7.2669E-1, 7.6570E-1, 7.7516E-1,&
     & 7.8150E-1, 7.8547E-1, 7.8703E-1, 7.8902E-1, 7.9194E-1, 7.9293E-1,&
     & 7.9819E-1, 8.0410E-1, 8.0621E-1, 8.2609E-1, 8.3628E-1, 8.4094E-1,&
     & 8.4271E-1, 8.4573E-1, 8.4789E-1, 6.0063E-1, 6.4595E-1, 6.9498E-1,&
     & 7.2966E-1, 7.6697E-1, 7.7604E-1, 7.8212E-1, 7.8595E-1, 7.8745E-1,&
     & 7.8936E-1, 7.9216E-1, 7.9310E-1, 7.9814E-1, 8.0381E-1, 8.0583E-1,&
     & 8.2486E-1, 8.3458E-1, 8.3904E-1, 8.4074E-1, 8.4368E-1, 8.4579E-1,&
     & 1.0000E+0, 1.0000E+0, 9.9999E-1, 9.9999E-1, 9.9999E-1, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0/           
      DATA X1901/ 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 9.9976E-1, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0048E+0,&
     & 1.0039E+0, 1.0029E+0, 1.0022E+0, 1.0015E+0, 1.0013E+0, 1.0012E+0,&
     & 1.0011E+0, 1.0010E+0, 1.0010E+0, 1.0009E+0, 1.0009E+0, 1.0009E+0,&
     & 1.0007E+0, 1.0007E+0, 1.0003E+0, 1.0001E+0, 9.9983E-1, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0203E+0, 1.0161E+0, 1.0121E+0, 1.0092E+0,&
     & 1.0063E+0, 1.0056E+0, 1.0051E+0, 1.0046E+0, 1.0043E+0, 1.0041E+0,&
     & 1.0039E+0, 1.0039E+0, 1.0036E+0, 1.0031E+0, 1.0030E+0, 1.0014E+0,&
     & 1.0006E+0, 1.0000E+0, 1.0002E+0, 1.0001E+0, 1.0001E+0, 1.0649E+0,&
     & 1.0526E+0, 1.0405E+0, 1.0310E+0, 1.0211E+0, 1.0188E+0, 1.0170E+0,&
     & 1.0154E+0, 1.0145E+0, 1.0137E+0, 1.0132E+0, 1.0131E+0, 1.0120E+0,&
     & 1.0105E+0, 1.0100E+0, 1.0048E+0, 1.0020E+0, 1.0007E+0, 1.0006E+0,&
     & 1.0003E+0, 1.0002E+0, 1.1489E+0, 1.1233E+0, 1.0976E+0, 1.0764E+0,&
     & 1.0525E+0, 1.0468E+0, 1.0424E+0, 1.0383E+0, 1.0361E+0, 1.0342E+0,&
     & 1.0330E+0, 1.0327E+0, 1.0300E+0, 1.0262E+0, 1.0249E+0, 1.0119E+0,&
     & 1.0050E+0, 1.0020E+0, 1.0016E+0, 1.0009E+0, 1.0006E+0, 1.3869E+0,&
     & 1.3274E+0, 1.2666E+0, 1.2147E+0, 1.1524E+0, 1.1366E+0/           
      DATA X2001/ 1.1240E+0, 1.1123E+0, 1.1059E+0, 1.1005E+0, 1.0970E+0,&
     & 1.0962E+0, 1.0882E+0, 1.0772E+0, 1.0732E+0, 1.0349E+0, 1.0144E+0,&
     & 1.0063E+0, 1.0046E+0, 1.0024E+0, 1.0015E+0, 1.4860E+0, 1.4145E+0,&
     & 1.3407E+0, 1.2771E+0, 1.1993E+0, 1.1791E+0, 1.1628E+0, 1.1477E+0,&
     & 1.1394E+0, 1.1323E+0, 1.1277E+0, 1.1266E+0, 1.1162E+0, 1.1017E+0,&
     & 1.0965E+0, 1.0459E+0, 1.0189E+0, 1.0083E+0, 1.0059E+0, 1.0031E+0,&
     & 1.0020E+0, 1.6101E+0, 1.5241E+0, 1.4350E+0, 1.3575E+0, 1.2610E+0,&
     & 1.2354E+0, 1.2145E+0, 1.1949E+0, 1.1841E+0, 1.1748E+0, 1.1688E+0,&
     & 1.1675E+0, 1.1537E+0, 1.1347E+0, 1.1278E+0, 1.0608E+0, 1.0249E+0,&
     & 1.0109E+0, 1.0077E+0, 1.0040E+0, 1.0025E+0, 1.7556E+0, 1.6550E+0,&
     & 1.5493E+0, 1.4571E+0, 1.3394E+0, 1.3077E+0, 1.2815E+0, 1.2565E+0,&
     & 1.2426E+0, 1.2307E+0, 1.2228E+0, 1.2211E+0, 1.2031E+0, 1.1782E+0,&
     & 1.1692E+0, 1.0805E+0, 1.0327E+0, 1.0142E+0, 1.0099E+0, 1.0051E+0,&
     & 1.0031E+0, 1.8618E+0, 1.7490E+0, 1.6309E+0, 1.5272E+0, 1.3941E+0,&
     & 1.3581E+0, 1.3282E+0, 1.2997E+0, 1.2837E+0, 1.2699E+0, 1.2609E+0,&
     & 1.2589E+0, 1.2381E+0, 1.2092E+0, 1.1987E+0, 1.0947E+0, 1.0383E+0,&
     & 1.0165E+0, 1.0115E+0, 1.0058E+0, 1.0035E+0, 1.9609E+0/           
      DATA X2101/ 1.8477E+0, 1.7144E+0, 1.6016E+0, 1.4573E+0, 1.4172E+0,&
     & 1.3836E+0, 1.3515E+0, 1.3334E+0, 1.3177E+0, 1.3074E+0, 1.3050E+0,&
     & 1.2811E+0, 1.2476E+0, 1.2353E+0, 1.1126E+0, 1.0453E+0, 1.0194E+0,&
     & 1.0133E+0, 1.0066E+0, 1.0039E+0, 2.0220E+0, 1.8999E+0, 1.7717E+0,&
     & 1.6558E+0, 1.5053E+0, 1.4638E+0, 1.4286E+0, 1.3946E+0, 1.3753E+0,&
     & 1.3585E+0, 1.3474E+0, 1.3449E+0, 1.3190E+0, 1.2822E+0, 1.2687E+0,&
     & 1.1302E+0, 1.0523E+0, 1.0221E+0, 1.0150E+0, 1.0071E+0, 1.0040E+0,&
     & 2.0022E+0, 1.8872E+0, 1.7647E+0, 1.6546E+0, 1.5100E+0, 1.4695E+0,&
     & 1.4352E+0, 1.4020E+0, 1.3830E+0, 1.3664E+0, 1.3554E+0, 1.3529E+0,&
     & 1.3272E+0, 1.2904E+0, 1.2767E+0, 1.1353E+0, 1.0545E+0, 1.0229E+0,&
     & 1.0155E+0, 1.0072E+0, 1.0040E+0, 1.6895E+0, 1.6302E+0, 1.5650E+0,&
     & 1.5039E+0, 1.4186E+0, 1.3933E+0, 1.3713E+0, 1.3492E+0, 1.3363E+0,&
     & 1.3248E+0, 1.3170E+0, 1.3152E+0, 1.2965E+0, 1.2682E+0, 1.2574E+0,&
     & 1.1340E+0, 1.0550E+0, 1.0225E+0, 1.0147E+0, 1.0061E+0, 1.0027E+0,&
     & 1.5251E+0, 1.4946E+0, 1.4599E+0, 1.4236E+0, 1.3683E+0, 1.3511E+0,&
     & 1.3348E+0, 1.3180E+0, 1.3079E+0, 1.2988E+0, 1.2924E+0, 1.2910E+0,&
     & 1.2753E+0, 1.2511E+0, 1.2416E+0, 1.1289E+0, 1.0532E+0/           
      DATA X2201/ 1.0215E+0, 1.0138E+0, 1.0054E+0, 1.0020E+0, 1.2656E+0,&
     & 1.2813E+0, 1.2888E+0, 1.2927E+0, 1.2854E+0, 1.2793E+0, 1.2723E+0,&
     & 1.2641E+0, 1.2585E+0, 1.2530E+0, 1.2490E+0, 1.2481E+0, 1.2375E+0,&
     & 1.2199E+0, 1.2127E+0, 1.1184E+0, 1.0491E+0, 1.0190E+0, 1.0117E+0,&
     & 1.0037E+0, 1.0005E+0, 1.1182E+0, 1.1592E+0, 1.1963E+0, 1.2221E+0,&
     & 1.2393E+0, 1.2397E+0, 1.2380E+0, 1.2342E+0, 1.2310E+0, 1.2274E+0,&
     & 1.2246E+0, 1.2239E+0, 1.2160E+0, 1.2019E+0, 1.1960E+0, 1.1117E+0,&
     & 1.0458E+0, 1.0168E+0, 1.0098E+0, 1.0022E+0, 9.9919E-1, 1.0825E+0,&
     & 1.1289E+0, 1.1719E+0, 1.2025E+0, 1.2259E+0, 1.2279E+0, 1.2275E+0,&
     & 1.2249E+0, 1.2223E+0, 1.2193E+0, 1.2168E+0, 1.2162E+0, 1.2091E+0,&
     & 1.1961E+0, 1.1905E+0, 1.1091E+0, 1.0443E+0, 1.0157E+0, 1.0089E+0,&
     & 1.0014E+0, 9.9848E-1, 9.4176E-1, 1.0229E+0, 1.0988E+0, 1.1553E+0,&
     & 1.2051E+0, 1.2123E+0, 1.2152E+0, 1.2148E+0, 1.2128E+0, 1.2103E+0,&
     & 1.2081E+0, 1.2076E+0, 1.2011E+0, 1.1890E+0, 1.1837E+0, 1.1046E+0,&
     & 1.0406E+0, 1.0127E+0, 1.0061E+0, 9.9917E-1, 9.9645E-1, 8.8049E-1,&
     & 9.8180E-1, 1.0764E+0, 1.1463E+0, 1.2072E+0, 1.2155E+0, 1.2186E+0,&
     & 1.2174E+0, 1.2151E+0, 1.2123E+0, 1.2099E+0, 1.2094E+0/           
      DATA X2301/ 1.2025E+0, 1.1898E+0, 1.1842E+0, 1.1033E+0, 1.0387E+0,&
     & 1.0109E+0, 1.0045E+0, 9.9775E-1, 9.9518E-1, 8.6130E-1, 9.7891E-1,&
     & 1.0871E+0, 1.1650E+0, 1.2275E+0, 1.2338E+0, 1.2340E+0, 1.2304E+0,&
     & 1.2268E+0, 1.2229E+0, 1.2198E+0, 1.2191E+0, 1.2107E+0, 1.1959E+0,&
     & 1.1897E+0, 1.1025E+0, 1.0357E+0, 1.0079E+0, 1.0017E+0, 9.9542E-1,&
     & 9.9308E-1, 9.7252E-1, 1.0942E+0, 1.2001E+0, 1.2683E+0, 1.3028E+0,&
     & 1.2970E+0, 1.2880E+0, 1.2762E+0, 1.2683E+0, 1.2607E+0, 1.2553E+0,&
     & 1.2540E+0, 1.2404E+0, 1.2188E+0, 1.2102E+0, 1.1024E+0, 1.0287E+0,&
     & 1.0007E+0, 9.9506E-1, 9.8988E-1, 9.8815E-1, 1.5237E+0, 1.4333E+0,&
     & 1.3752E+0, 1.3666E+0, 1.4442E+0, 1.3572E+0, 1.1829E+0, 9.8304E-1,&
     & 9.8606E-1, 1.3030E+0, 2.8298E+0, 2.2466E+0, 1.2573E+0, 1.2315E+0,&
     & 1.2214E+0, 1.1016E+0, 1.0243E+0, 9.9643E-1, 9.9111E-1, 9.8664E-1,&
     & 9.8530E-1, 9.0304E-1, 1.2542E+0, 1.4483E+0, 1.4176E+0, 1.4734E+0,&
     & 1.3815E+0, 1.2034E+0, 1.0003E+0, 1.0015E+0, 1.3170E+0, 2.8428E+0,&
     & 2.2593E+0, 1.2680E+0, 1.2394E+0, 1.2284E+0, 1.1005E+0, 1.0209E+0,&
     & 9.9324E-1, 9.8823E-1, 9.8430E-1, 9.8325E-1, 9.6916E-1, 1.3047E+0,&
     & 1.4843E+0, 1.4427E+0, 1.4876E+0, 1.3934E+0, 1.2134E+0/           
      DATA X2401/ 1.0086E+0, 1.0089E+0, 1.3237E+0, 2.8490E+0, 2.2654E+0,&
     & 1.2731E+0, 1.2431E+0, 1.2315E+0, 1.0997E+0, 1.0190E+0, 9.9155E-1,&
     & 9.8670E-1, 9.8308E-1, 9.8218E-1, 6.2449E-1, 1.4024E+0, 1.5543E+0,&
     & 1.4916E+0, 1.5152E+0, 1.4161E+0, 1.2324E+0, 1.0243E+0, 1.0229E+0,&
     & 1.3361E+0, 2.8606E+0, 2.2768E+0, 1.2824E+0, 1.2496E+0, 1.2371E+0,&
     & 1.0975E+0, 1.0149E+0, 9.8796E-1, 9.8349E-1, 9.8051E-1, 9.7995E-1,&
     & 6.8195E-1, 1.4493E+0, 1.5882E+0, 1.5152E+0, 1.5283E+0, 1.4268E+0,&
     & 1.2414E+0, 1.0316E+0, 1.0293E+0, 1.3419E+0, 2.8659E+0, 2.2819E+0,&
     & 1.2865E+0, 1.2524E+0, 1.2395E+0, 1.0962E+0, 1.0128E+0, 9.8606E-1,&
     & 9.8180E-1, 9.7918E-1, 9.7880E-1, 7.3704E-1, 1.4949E+0, 1.6213E+0,&
     & 1.5382E+0, 1.5409E+0, 1.4372E+0, 1.2499E+0, 1.0386E+0, 1.0354E+0,&
     & 1.3473E+0, 2.8708E+0, 2.2868E+0, 1.2904E+0, 1.2550E+0, 1.2416E+0,&
     & 1.0946E+0, 1.0104E+0, 9.8409E-1, 9.8006E-1, 9.7780E-1, 9.7761E-1,&
     & 1.0004E+0, 1.0003E+0, 1.0002E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0,&
     & 1.0001E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0,&
     & 1.0001E+0, 1.0001E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0060E+0, 1.0043E+0/           
      DATA X2501/ 1.0030E+0, 1.0022E+0, 1.0015E+0, 1.0013E+0, 1.0012E+0,&
     & 1.0011E+0, 1.0010E+0, 1.0010E+0, 1.0009E+0, 1.0009E+0, 1.0009E+0,&
     & 1.0008E+0, 1.0007E+0, 1.0004E+0, 1.0002E+0, 1.0001E+0, 1.0001E+0,&
     & 1.0001E+0, 1.0001E+0, 1.0239E+0, 1.0178E+0, 1.0125E+0, 1.0091E+0,&
     & 1.0060E+0, 1.0053E+0, 1.0048E+0, 1.0044E+0, 1.0041E+0, 1.0039E+0,&
     & 1.0038E+0, 1.0037E+0, 1.0034E+0, 1.0030E+0, 1.0029E+0, 1.0015E+0,&
     & 1.0008E+0, 1.0004E+0, 1.0004E+0, 1.0003E+0, 1.0002E+0, 1.0796E+0,&
     & 1.0616E+0, 1.0447E+0, 1.0321E+0, 1.0209E+0, 1.0185E+0, 1.0166E+0,&
     & 1.0150E+0, 1.0141E+0, 1.0134E+0, 1.0129E+0, 1.0128E+0, 1.0117E+0,&
     & 1.0103E+0, 1.0098E+0, 1.0050E+0, 1.0025E+0, 1.0015E+0, 1.0012E+0,&
     & 1.0008E+0, 1.0007E+0, 1.2116E+0, 1.1680E+0, 1.1255E+0, 1.0920E+0,&
     & 1.0572E+0, 1.0501E+0, 1.0448E+0, 1.0400E+0, 1.0375E+0, 1.0354E+0,&
     & 1.0341E+0, 1.0338E+0, 1.0308E+0, 1.0269E+0, 1.0255E+0, 1.0128E+0,&
     & 1.0063E+0, 1.0036E+0, 1.0029E+0, 1.0020E+0, 1.0017E+0, 2.1402E+0,&
     & 1.8914E+0, 1.6482E+0, 1.4545E+0, 1.2511E+0, 1.2084E+0, 1.1789E+0,&
     & 1.1545E+0, 1.1422E+0, 1.1323E+0, 1.1260E+0, 1.1246E+0, 1.1112E+0,&
     & 1.0940E+0, 1.0882E+0, 1.0397E+0, 1.0183E+0, 1.0103E+0/           
      DATA X2601/ 1.0081E+0, 1.0057E+0, 1.0046E+0, 3.0191E+0, 2.5787E+0,&
     & 2.1454E+0, 1.7967E+0, 1.4227E+0, 1.3416E+0, 1.2836E+0, 1.2385E+0,&
     & 1.2165E+0, 1.1992E+0, 1.1885E+0, 1.1861E+0, 1.1636E+0, 1.1357E+0,&
     & 1.1264E+0, 1.0535E+0, 1.0238E+0, 1.0132E+0, 1.0104E+0, 1.0072E+0,&
     & 1.0059E+0, 5.4535E+0, 4.4581E+0, 3.4770E+0, 2.6858E+0, 1.8328E+0,&
     & 1.6462E+0, 1.5122E+0, 1.4068E+0, 1.3594E+0, 1.3236E+0, 1.3023E+0,&
     & 1.2977E+0, 1.2546E+0, 1.2042E+0, 1.1882E+0, 1.0726E+0, 1.0308E+0,&
     & 1.0167E+0, 1.0132E+0, 1.0091E+0, 1.0075E+0, 1.2010E+1, 9.5586E+0,&
     & 7.1289E+0, 5.1514E+0, 2.9779E+0, 2.4886E+0, 2.1291E+0, 1.8363E+0,&
     & 1.6982E+0, 1.5976E+0, 1.5420E+0, 1.5304E+0, 1.4285E+0, 1.3224E+0,&
     & 1.2913E+0, 1.0975E+0, 1.0391E+0, 1.0208E+0, 1.0164E+0, 1.0113E+0,&
     & 1.0093E+0, 3.7047E+1, 2.8495E+1, 2.0089E+1, 1.3334E+1, 6.1107E+0,&
     & 4.5508E+0, 3.4423E+0, 2.5845E+0, 2.2078E+0, 1.9560E+0, 1.8326E+0,&
     & 1.8081E+0, 1.6087E+0, 1.4277E+0, 1.3791E+0, 1.1134E+0, 1.0442E+0,&
     & 1.0234E+0, 1.0184E+0, 1.0128E+0, 1.0106E+0, 1.8658E+2, 1.4113E+2,&
     & 9.6629E+1, 6.1080E+1, 2.3543E+1, 1.5603E+1, 1.0057E+1, 5.8867E+0,&
     & 4.1335E+0, 3.0312E+0, 2.5420E+0, 2.4597E+0, 1.9191E+0/           
      DATA X2701/ 1.5657E+0, 1.4860E+0, 1.1275E+0, 1.0492E+0, 1.0264E+0,&
     & 1.0209E+0, 1.0147E+0, 1.0123E+0, 1.5287E+3, 1.1536E+3, 7.8614E+2,&
     & 4.9222E+2, 1.8107E+2, 1.1497E+2, 6.8643E+1, 3.3589E+1, 1.8710E+1,&
     & 9.2257E+0, 4.9134E+0, 4.1694E+0, 2.0948E+0, 1.5629E+0, 1.4727E+0,&
     & 1.1265E+0, 1.0532E+0, 1.0304E+0, 1.0247E+0, 1.0181E+0, 1.0154E+0,&
     & 4.8788E+2, 3.7552E+2, 2.6405E+2, 1.7321E+2, 7.3174E+1, 5.0573E+1,&
     & 3.3922E+1, 2.0306E+1, 1.3852E+1, 9.1215E+0, 6.4919E+0, 5.9551E+0,&
     & 1.8635E+0, 1.4526E+0, 1.3872E+0, 1.1208E+0, 1.0552E+0, 1.0331E+0,&
     & 1.0273E+0, 1.0204E+0, 1.0177E+0, 3.5814E+2, 2.7572E+2, 1.9395E+2,&
     & 1.2731E+2, 5.3930E+1, 3.7351E+1, 2.5138E+1, 1.5151E+1, 1.0417E+1,&
     & 6.9477E+0, 5.0192E+0, 4.6256E+0, 1.6254E+0, 1.3262E+0, 1.2834E+0,&
     & 1.1246E+0, 1.0773E+0, 1.0555E+0, 1.0487E+0, 1.0398E+0, 1.0363E+0,&
     & 7.7055E+2, 5.8214E+2, 3.9744E+2, 2.4960E+2, 9.2836E+1, 5.9444E+1,&
     & 3.5985E+1, 1.8167E+1, 1.0560E+1, 5.6689E+0, 3.4133E+0, 3.0186E+0,&
     & 1.7449E+0, 1.3942E+0, 1.3376E+0, 1.1387E+0, 1.0892E+0, 1.0662E+0,&
     & 1.0587E+0, 1.0489E+0, 1.0451E+0, 1.0626E+2, 8.0555E+1, 5.5367E+1,&
     & 3.5239E+1, 1.3960E+1, 9.4500E+0, 6.2949E+0, 3.9149E+0/           
      DATA X2801/ 2.9100E+0, 2.2741E+0, 1.9886E+0, 1.9399E+0, 1.6186E+0,&
     & 1.4113E+0, 1.3656E+0, 1.1676E+0, 1.1145E+0, 1.0890E+0, 1.0803E+0,&
     & 1.0687E+0, 1.0643E+0, 2.6255E+1, 2.0252E+1, 1.4357E+1, 9.6272E+0,&
     & 4.5817E+0, 3.4971E+0, 2.7292E+0, 2.1385E+0, 1.8814E+0, 1.7116E+0,&
     & 1.6299E+0, 1.6137E+0, 1.4849E+0, 1.3720E+0, 1.3425E+0, 1.1850E+0,&
     & 1.1337E+0, 1.1074E+0, 1.0981E+0, 1.0854E+0, 1.0808E+0, 1.3377E+1,&
     & 1.0547E+1, 7.7542E+0, 5.4982E+0, 3.0552E+0, 2.5176E+0, 2.1296E+0,&
     & 1.8219E+0, 1.6819E+0, 1.5842E+0, 1.5331E+0, 1.5227E+0, 1.4350E+0,&
     & 1.3506E+0, 1.3272E+0, 1.1910E+0, 1.1422E+0, 1.1160E+0, 1.1065E+0,&
     & 1.0934E+0, 1.0889E+0, 5.9092E+0, 4.7963E+0, 3.7058E+0, 2.8340E+0,&
     & 1.9112E+0, 1.7152E+0, 1.5779E+0, 1.4741E+0, 1.4301E+0, 1.3981E+0,&
     & 1.3794E+0, 1.3754E+0, 1.3390E+0, 1.2983E+0, 1.2858E+0, 1.1994E+0,&
     & 1.1610E+0, 1.1370E+0, 1.1276E+0, 1.1143E+0, 1.1103E+0, 4.1587E+0,&
     & 3.4448E+0, 2.7501E+0, 2.2003E+0, 1.6320E+0, 1.5160E+0, 1.4376E+0,&
     & 1.3818E+0, 1.3563E+0, 1.3369E+0, 1.3253E+0, 1.3228E+0, 1.2993E+0,&
     & 1.2719E+0, 1.2632E+0, 1.2000E+0, 1.1691E+0, 1.1474E+0, 1.1384E+0,&
     & 1.1256E+0, 1.1221E+0, 2.6374E+0, 2.2831E+0, 1.9409E+0/           
      DATA X2901/ 1.6734E+0, 1.4042E+0, 1.3519E+0, 1.3182E+0, 1.2921E+0,&
     & 1.2795E+0, 1.2697E+0, 1.2637E+0, 1.2624E+0, 1.2501E+0, 1.2353E+0,&
     & 1.2305E+0, 1.1961E+0, 1.1779E+0, 1.1609E+0, 1.1530E+0, 1.1415E+0,&
     & 1.1391E+0, 1.6616E+0, 1.5228E+0, 1.3924E+0, 1.2951E+0, 1.2079E+0,&
     & 1.1949E+0, 1.1865E+0, 1.1801E+0, 1.1772E+0, 1.1751E+0, 1.1739E+0,&
     & 1.1736E+0, 1.1714E+0, 1.1694E+0, 1.1691E+0, 1.1753E+0, 1.1828E+0,&
     & 1.1783E+0, 1.1741E+0, 1.1672E+0, 1.1686E+0, 1.4510E+0, 1.3519E+0,&
     & 1.2608E+0, 1.1953E+0, 1.1430E+0, 1.1427E+0, 1.1534E+0, 1.1715E+0,&
     & 1.1691E+0, 1.1359E+0, 1.0707E+0, 1.0864E+0, 1.1378E+0, 1.1393E+0,&
     & 1.1402E+0, 1.1602E+0, 1.1792E+0, 1.1817E+0, 1.1797E+0, 1.1762E+0,&
     & 1.1800E+0, 1.4810E+0, 1.3132E+0, 1.1919E+0, 1.1483E+0, 1.1133E+0,&
     & 1.1146E+0, 1.1246E+0, 1.1411E+0, 1.1402E+0, 1.1134E+0, 1.0592E+0,&
     & 1.0724E+0, 1.1168E+0, 1.1199E+0, 1.1214E+0, 1.1487E+0, 1.1746E+0,&
     & 1.1818E+0, 1.1815E+0, 1.1804E+0, 1.1860E+0, 1.3991E+0, 1.2626E+0,&
     & 1.1638E+0, 1.1281E+0, 1.0997E+0, 1.1016E+0, 1.1111E+0, 1.1266E+0,&
     & 1.1263E+0, 1.1026E+0, 1.0537E+0, 1.0657E+0, 1.1066E+0, 1.1104E+0,&
     & 1.1121E+0, 1.1425E+0, 1.1717E+0, 1.1813E+0, 1.1818E+0/           
      DATA X3001/ 1.1820E+0, 1.1884E+0, 1.4756E+0, 1.1828E+0, 1.1165E+0,&
     & 1.0924E+0, 1.0746E+0, 1.0771E+0, 1.0855E+0, 1.0989E+0, 1.0996E+0,&
     & 1.0816E+0, 1.0430E+0, 1.0526E+0, 1.0865E+0, 1.0914E+0, 1.0936E+0,&
     & 1.1293E+0, 1.1646E+0, 1.1788E+0, 1.1811E+0, 1.1839E+0, 1.1923E+0,&
     & 1.3805E+0, 1.1506E+0, 1.0962E+0, 1.0764E+0, 1.0628E+0, 1.0655E+0,&
     & 1.0733E+0, 1.0855E+0, 1.0866E+0, 1.0713E+0, 1.0377E+0, 1.0462E+0,&
     & 1.0766E+0, 1.0819E+0, 1.0842E+0, 1.1222E+0, 1.1604E+0, 1.1769E+0,&
     & 1.1800E+0, 1.1843E+0, 1.1936E+0, 1.3022E+0, 1.1221E+0, 1.0776E+0,&
     & 1.0614E+0, 1.0514E+0, 1.0541E+0, 1.0612E+0, 1.0722E+0, 1.0737E+0,&
     & 1.0611E+0, 1.0325E+0, 1.0398E+0, 1.0667E+0, 1.0724E+0, 1.0748E+0,&
     & 1.1148E+0, 1.1557E+0, 1.1745E+0, 1.1786E+0, 1.1843E+0, 1.1946E+0,&
     & 9.9969E-1, 9.9979E-1, 9.9986E-1, 9.9990E-1, 9.9994E-1, 9.9994E-1,&
     & 9.9995E-1, 9.9996E-1, 9.9996E-1, 9.9996E-1, 9.9996E-1, 9.9996E-1,&
     & 9.9997E-1, 9.9997E-1, 9.9998E-1, 9.9999E-1, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 9.9539E-1, 9.9681E-1, 9.9783E-1,&
     & 9.9846E-1, 9.9904E-1, 9.9917E-1, 9.9926E-1, 9.9935E-1, 9.9939E-1,&
     & 9.9943E-1, 9.9946E-1, 9.9946E-1, 9.9952E-1, 9.9960E-1/           
      DATA X3101/ 9.9962E-1, 9.9988E-1, 1.0000E+0, 1.0001E+0, 1.0001E+0,&
     & 1.0002E+0, 1.0002E+0, 9.8219E-1, 9.8705E-1, 9.9121E-1, 9.9380E-1,&
     & 9.9614E-1, 9.9664E-1, 9.9703E-1, 9.9738E-1, 9.9757E-1, 9.9772E-1,&
     & 9.9782E-1, 9.9785E-1, 9.9807E-1, 9.9838E-1, 9.9849E-1, 9.9953E-1,&
     & 1.0001E+0, 1.0004E+0, 1.0005E+0, 1.0006E+0, 1.0007E+0, 9.4419E-1,&
     & 9.5726E-1, 9.6953E-1, 9.7868E-1, 9.8686E-1, 9.8861E-1, 9.8995E-1,&
     & 9.9115E-1, 9.9179E-1, 9.9233E-1, 9.9268E-1, 9.9275E-1, 9.9353E-1,&
     & 9.9458E-1, 9.9495E-1, 9.9846E-1, 1.0004E+0, 1.0013E+0, 1.0016E+0,&
     & 1.0021E+0, 1.0023E+0, 8.6579E-1, 8.9373E-1, 9.2104E-1, 9.4279E-1,&
     & 9.6561E-1, 9.7038E-1, 9.7401E-1, 9.7722E-1, 9.7894E-1, 9.8037E-1,&
     & 9.8129E-1, 9.8149E-1, 9.8354E-1, 9.8629E-1, 9.8726E-1, 9.9627E-1,&
     & 1.0011E+0, 1.0034E+0, 1.0041E+0, 1.0051E+0, 1.0057E+0, 4.9625E-1,&
     & 5.9973E-1, 7.0212E-1, 7.8529E-1, 8.7607E-1, 8.9634E-1, 9.1113E-1,&
     & 9.2381E-1, 9.3041E-1, 9.3583E-1, 9.3926E-1, 9.4002E-1, 9.4755E-1,&
     & 9.5737E-1, 9.6076E-1, 9.9035E-1, 1.0047E+0, 1.0108E+0, 1.0126E+0,&
     & 1.0151E+0, 1.0166E+0, 2.5363E-1, 4.0465E-1, 5.5518E-1, 6.7869E-1,&
     & 8.1656E-1, 8.4833E-1, 8.7210E-1, 8.9196E-1, 9.0211E-1/           
      DATA X3201/ 9.1035E-1, 9.1553E-1, 9.1667E-1, 9.2789E-1, 9.4229E-1,&
     & 9.4718E-1, 9.8844E-1, 1.0072E+0, 1.0149E+0, 1.0172E+0, 1.0204E+0,&
     & 1.0221E+0,-2.4446E-1, 1.0010E-2, 2.6418E-1, 4.7353E-1, 7.0881E-1,&
     & 7.6357E-1, 8.0482E-1, 8.3963E-1, 8.5680E-1, 8.7043E-1, 8.7887E-1,&
     & 8.8073E-1, 8.9861E-1, 9.2090E-1, 9.2831E-1, 9.8728E-1, 1.0119E+0,&
     & 1.0215E+0, 1.0243E+0, 1.0281E+0, 1.0303E+0,-1.2246E+0,-7.6929E-1,&
     &-3.1274E-1, 6.5796E-2, 4.9661E-1, 5.9872E-1, 6.7664E-1, 7.4356E-1,&
     & 7.7725E-1, 8.0355E-1, 8.1925E-1, 8.2265E-1, 8.5440E-1, 8.9166E-1,&
     & 9.0352E-1, 9.8932E-1, 1.0209E+0, 1.0325E+0, 1.0358E+0, 1.0403E+0,&
     & 1.0429E+0,-3.5154E+0,-2.5264E+0,-1.5426E+0,-7.3814E-1, 1.5424E-1,&
     & 3.5808E-1, 5.0947E-1, 6.3478E-1, 6.9508E-1, 7.4003E-1, 7.6551E-1,&
     & 7.7090E-1, 8.1936E-1, 8.7227E-1, 8.8831E-1, 9.9453E-1, 1.0299E+0,&
     & 1.0426E+0, 1.0462E+0, 1.0511E+0, 1.0539E+0,-1.1936E+1,-8.9333E+0,&
     &-5.9690E+0,-3.5688E+0,-9.6436E-1,-3.8899E-1, 2.7725E-2, 3.5983E-1,&
     & 5.1192E-1, 6.1903E-1, 6.7563E-1, 6.8676E-1, 7.7666E-1, 8.5869E-1,&
     & 8.8103E-1, 1.0084E+0, 1.0458E+0, 1.0593E+0, 1.0633E+0, 1.0686E+0,&
     & 1.0718E+0,-6.4749E+1,-4.8924E+1,-3.3364E+1,-2.0853E+1/           
      DATA X3301/-7.4583E+0,-4.5601E+0,-2.4972E+0,-8.9672E-1,-1.9111E-1,&
     & 2.8270E-1, 5.1679E-1, 5.6041E-1, 7.8317E-1, 8.9750E-1, 9.2182E-1,&
     & 1.0366E+0, 1.0705E+0, 1.0843E+0, 1.0886E+0, 1.0947E+0, 1.0984E+0,&
     &-3.8291E+1,-2.9319E+1,-2.0403E+1,-1.3117E+1,-5.0508E+0,-3.2142E+0,&
     &-1.8531E+0,-7.3033E-1,-1.9223E-1, 2.0701E-1, 4.3223E-1, 4.7867E-1,&
     & 8.4491E-1, 9.4455E-1, 9.6296E-1, 1.0511E+0, 1.0823E+0, 1.0962E+0,&
     & 1.1007E+0, 1.1072E+0, 1.1112E+0,-3.6729E+1,-2.8118E+1,-1.9558E+1,&
     &-1.2563E+1,-4.8144E+0,-3.0488E+0,-1.7397E+0,-6.5908E-1,-1.4067E-1,&
     & 2.4435E-1, 4.6181E-1, 5.0669E-1, 8.6157E-1, 9.6289E-1, 9.8182E-1,&
     & 1.0747E+0, 1.1103E+0, 1.1275E+0, 1.1332E+0, 1.1417E+0, 1.1471E+0,&
     &-5.1409E+1,-3.8854E+1,-2.6498E+1,-1.6550E+1,-5.8693E+0,-3.5478E+0,&
     &-1.8893E+0,-5.9490E-1,-1.9311E-2, 3.7151E-1, 5.6779E-1, 6.0488E-1,&
     & 8.0901E-1, 9.2218E-1, 9.4694E-1, 1.0683E+0, 1.1084E+0, 1.1267E+0,&
     & 1.1328E+0, 1.1418E+0, 1.1475E+0,-1.1106E+1,-8.2939E+0,-5.5161E+0,&
     &-3.2661E+0,-8.2080E-1,-2.8014E-1, 1.1206E-1, 4.2523E-1, 5.6899E-1,&
     & 6.7057E-1, 7.2446E-1, 7.3510E-1, 8.2123E-1, 9.0010E-1, 9.2163E-1,&
     & 1.0475E+0, 1.0903E+0, 1.1092E+0, 1.1155E+0, 1.1250E+0/           
      DATA X3401/ 1.1310E+0,-3.6782E+0,-2.6360E+0,-1.6015E+0,-7.5694E-1,&
     & 1.7558E-1, 3.8721E-1, 5.4363E-1, 6.7217E-1, 7.3347E-1, 7.7871E-1,&
     & 8.0406E-1, 8.0940E-1, 8.5693E-1, 9.0796E-1, 9.2327E-1, 1.0250E+0,&
     & 1.0636E+0, 1.0813E+0, 1.0873E+0, 1.0964E+0, 1.1024E+0,-1.9497E+0,&
     &-1.3159E+0,-6.8417E-1,-1.6451E-1, 4.1771E-1, 5.5272E-1, 6.5411E-1,&
     & 7.3934E-1, 7.8116E-1, 8.1297E-1, 8.3144E-1, 8.3539E-1, 8.7143E-1,&
     & 9.1194E-1, 9.2447E-1, 1.0120E+0, 1.0471E+0, 1.0636E+0, 1.0694E+0,&
     & 1.0781E+0, 1.0839E+0,-4.1641E-1,-1.1646E-1, 1.8117E-1, 4.2384E-1,&
     & 6.9113E-1, 7.5156E-1, 7.9610E-1, 8.3255E-1, 8.4984E-1, 8.6326E-1,&
     & 8.7142E-1, 8.7320E-1, 8.9011E-1, 9.1054E-1, 9.1718E-1, 9.6839E-1,&
     & 9.9201E-1, 1.0043E+0, 1.0088E+0, 1.0159E+0, 1.0208E+0, 5.3909E-2,&
     & 2.5002E-1, 4.4324E-1, 5.9911E-1, 7.6709E-1, 8.0383E-1, 8.3021E-1,&
     & 8.5096E-1, 8.6111E-1, 8.6913E-1, 8.7406E-1, 8.7515E-1, 8.8553E-1,&
     & 8.9833E-1, 9.0255E-1, 9.3618E-1, 9.5277E-1, 9.6208E-1, 9.6566E-1,&
     & 9.7155E-1, 9.7568E-1, 5.0659E-1, 5.9244E-1, 6.7609E-1, 7.4238E-1,&
     & 8.1113E-1, 8.2525E-1, 8.3486E-1, 8.4257E-1, 8.4639E-1, 8.4942E-1,&
     & 8.5128E-1, 8.5169E-1, 8.5562E-1, 8.6045E-1, 8.6203E-1/           
      DATA X3501/ 8.7432E-1, 8.8078E-1, 8.8532E-1, 8.8731E-1, 8.9090E-1,&
     & 8.9361E-1, 7.2664E-1, 7.2631E-1, 7.2482E-1, 7.2221E-1, 7.1618E-1,&
     & 7.1376E-1, 7.1156E-1, 7.0931E-1, 7.0799E-1, 7.0680E-1, 7.0601E-1,&
     & 7.0583E-1, 7.0392E-1, 7.0111E-1, 7.0004E-1, 6.8769E-1, 6.7904E-1,&
     & 6.7497E-1, 6.7383E-1, 6.7253E-1, 6.7204E-1, 6.4782E-1, 6.3553E-1,&
     & 6.2241E-1, 6.1058E-1, 5.9499E-1, 5.9068E-1, 5.8706E-1, 5.8356E-1,&
     & 5.8157E-1, 5.7983E-1, 5.7867E-1, 5.7841E-1, 5.7570E-1, 5.7178E-1,&
     & 5.7031E-1, 5.5370E-1, 5.4151E-1, 5.3488E-1, 5.3269E-1, 5.2963E-1,&
     & 5.2789E-1, 5.4834E-1, 5.3249E-1, 5.1647E-1, 5.0306E-1, 4.8664E-1,&
     & 4.8225E-1, 4.7860E-1, 4.7508E-1, 4.7309E-1, 4.7135E-1, 4.7020E-1,&
     & 4.6994E-1, 4.6724E-1, 4.6334E-1, 4.6189E-1, 4.4530E-1, 4.3273E-1,&
     & 4.2554E-1, 4.2305E-1, 4.1942E-1, 4.1724E-1, 4.8353E-1, 4.6775E-1,&
     & 4.5201E-1, 4.3909E-1, 4.2350E-1, 4.1936E-1, 4.1592E-1, 4.1261E-1,&
     & 4.1073E-1, 4.0910E-1, 4.0802E-1, 4.0777E-1, 4.0524E-1, 4.0157E-1,&
     & 4.0020E-1, 3.8453E-1, 3.7249E-1, 3.6545E-1, 3.6298E-1, 3.5932E-1,&
     & 3.5708E-1, 3.2429E-1, 3.1110E-1, 2.9890E-1, 2.8907E-1, 2.7736E-1,&
     & 2.7427E-1, 2.7170E-1, 2.6924E-1, 2.6784E-1, 2.6662E-1/           
      DATA X3601/ 2.6581E-1, 2.6563E-1, 2.6374E-1, 2.6100E-1, 2.5997E-1,&
     & 2.4814E-1, 2.3881E-1, 2.3318E-1, 2.3116E-1, 2.2809E-1, 2.2617E-1,&
     & 2.2817E-1, 2.1833E-1, 2.0927E-1, 2.0198E-1, 1.9334E-1, 1.9106E-1,&
     & 1.8916E-1, 1.8734E-1, 1.8631E-1, 1.8541E-1, 1.8482E-1, 1.8468E-1,&
     & 1.8328E-1, 1.8126E-1, 1.8050E-1, 1.7171E-1, 1.6471E-1, 1.6043E-1,&
     & 1.5887E-1, 1.5650E-1, 1.5499E-1, 1.2046E-1, 1.1499E-1, 1.0995E-1,&
     & 1.0592E-1, 1.0115E-1, 9.9892E-2, 9.8847E-2, 9.7843E-2, 9.7273E-2,&
     & 9.6777E-2, 9.6447E-2, 9.6373E-2, 9.5600E-2, 9.4480E-2, 9.4060E-2,&
     & 8.9179E-2, 8.5250E-2, 8.2821E-2, 8.1932E-2, 8.0567E-2, 7.9692E-2,&
     & 3.7870E-5, 4.3245E-5, 4.9480E-5, 5.5616E-5, 6.4653E-5, 6.7446E-5,&
     & 6.9922E-5, 7.2449E-5, 7.3952E-5, 7.5305E-5, 7.6227E-5, 7.6439E-5,&
     & 7.8689E-5, 8.2159E-5, 8.3532E-5, 1.0302E-4, 1.2610E-4, 1.4675E-4,&
     & 1.5651E-4, 1.7550E-4, 1.8988E-4, 3.7900E-5, 4.3275E-5, 4.9510E-5,&
     & 5.5646E-5, 6.4683E-5, 6.7476E-5, 6.9952E-5, 7.2479E-5, 7.3982E-5,&
     & 7.5335E-5, 7.6257E-5, 7.6469E-5, 7.8719E-5, 8.2189E-5, 8.3562E-5,&
     & 1.0305E-4, 1.2613E-4, 1.4678E-4, 1.5654E-4, 1.7553E-4, 1.8991E-4,&
     & 3.7957E-5, 4.3373E-5, 4.9608E-5, 5.5744E-5, 6.4781E-5/           
      DATA X3701/ 6.7574E-5, 7.0050E-5, 7.2577E-5, 7.4081E-5, 7.5433E-5,&
     & 7.6355E-5, 7.6567E-5, 7.8817E-5, 8.2288E-5, 8.3660E-5, 1.0315E-4,&
     & 1.2623E-4, 1.4688E-4, 1.5664E-4, 1.7562E-4, 1.9001E-4, 3.8150E-5,&
     & 4.3647E-5, 4.9929E-5, 5.6064E-5, 6.5102E-5, 6.7895E-5, 7.0371E-5,&
     & 7.2897E-5, 7.4401E-5, 7.5754E-5, 7.6676E-5, 7.6888E-5, 7.9138E-5,&
     & 8.2608E-5, 8.3981E-5, 1.0347E-4, 1.2655E-4, 1.4720E-4, 1.5696E-4,&
     & 1.7594E-4, 1.9033E-4, 3.8726E-5, 4.4308E-5, 5.0659E-5, 5.6832E-5,&
     & 6.5870E-5, 6.8663E-5, 7.1139E-5, 7.3665E-5, 7.5169E-5, 7.6522E-5,&
     & 7.7444E-5, 7.7656E-5, 7.9906E-5, 8.3376E-5, 8.4749E-5, 1.0424E-4,&
     & 1.2732E-4, 1.4797E-4, 1.5772E-4, 1.7671E-4, 1.9109E-4, 4.1895E-5,&
     & 4.7544E-5, 5.3955E-5, 6.0172E-5, 6.9237E-5, 7.2029E-5, 7.4506E-5,&
     & 7.7032E-5, 7.8536E-5, 7.9889E-5, 8.0810E-5, 8.1022E-5, 8.3272E-5,&
     & 8.6743E-5, 8.8115E-5, 1.0761E-4, 1.3068E-4, 1.5133E-4, 1.6109E-4,&
     & 1.8008E-4, 1.9446E-4, 4.3955E-5, 4.9636E-5, 5.6083E-5, 6.2317E-5,&
     & 7.1399E-5, 7.4194E-5, 7.6670E-5, 7.9196E-5, 8.0700E-5, 8.2053E-5,&
     & 8.2974E-5, 8.3187E-5, 8.5437E-5, 8.8907E-5, 9.0280E-5, 1.0977E-4,&
     & 1.3285E-4, 1.5350E-4, 1.6326E-4, 1.8224E-4, 1.9662E-4/           
      DATA X3801/ 4.7464E-5, 5.3171E-5, 5.9634E-5, 6.5895E-5, 7.4993E-5,&
     & 7.7790E-5, 8.0268E-5, 8.2794E-5, 8.4298E-5, 8.5651E-5, 8.6572E-5,&
     & 8.6784E-5, 8.9034E-5, 9.2505E-5, 9.3877E-5, 1.1337E-4, 1.3645E-4,&
     & 1.5710E-4, 1.6685E-4, 1.8584E-4, 2.0022E-4, 5.3760E-5, 5.9459E-5,&
     & 6.5926E-5, 7.2230E-5, 8.1342E-5, 8.4141E-5, 8.6617E-5, 8.9145E-5,&
     & 9.0650E-5, 9.2002E-5, 9.2924E-5, 9.3136E-5, 9.5386E-5, 9.8857E-5,&
     & 1.0023E-4, 1.1972E-4, 1.4280E-4, 1.6345E-4, 1.7320E-4, 1.9219E-4,&
     & 2.0657E-4, 5.9899E-5, 6.5636E-5, 7.2092E-5, 7.8399E-5, 8.7507E-5,&
     & 9.0308E-5, 9.2785E-5, 9.5313E-5, 9.6817E-5, 9.8170E-5, 9.9091E-5,&
     & 9.9303E-5, 1.0155E-4, 1.0502E-4, 1.0640E-4, 1.2589E-4, 1.4896E-4,&
     & 1.6961E-4, 1.7937E-4, 1.9836E-4, 2.1274E-4, 7.0810E-5, 7.6830E-5,&
     & 8.3089E-5, 8.9467E-5, 9.8720E-5, 1.0145E-4, 1.0393E-4, 1.0647E-4,&
     & 1.0797E-4, 1.0932E-4, 1.1024E-4, 1.1046E-4, 1.1271E-4, 1.1618E-4,&
     & 1.1755E-4, 1.3704E-4, 1.6012E-4, 1.8077E-4, 1.9052E-4, 2.0951E-4,&
     & 2.2389E-4, 9.0789E-5, 9.6444E-5, 1.0309E-4, 1.0927E-4, 1.1844E-4,&
     & 1.2126E-4, 1.2374E-4, 1.2626E-4, 1.2777E-4, 1.2912E-4, 1.3004E-4,&
     & 1.3025E-4, 1.3250E-4, 1.3598E-4, 1.3735E-4, 1.5684E-4/           
      DATA X3901/ 1.7992E-4, 2.0057E-4, 2.1032E-4, 2.2931E-4, 2.4369E-4,&
     & 1.0233E-4, 1.0809E-4, 1.1462E-4, 1.2093E-4, 1.3008E-4, 1.3288E-4,&
     & 1.3536E-4, 1.3790E-4, 1.3940E-4, 1.4075E-4, 1.4168E-4, 1.4189E-4,&
     & 1.4414E-4, 1.4761E-4, 1.4898E-4, 1.6847E-4, 1.9155E-4, 2.1220E-4,&
     & 2.2196E-4, 2.4094E-4, 2.5533E-4, 1.6415E-4, 1.6991E-4, 1.7644E-4,&
     & 1.8275E-4, 1.9190E-4, 1.9470E-4, 1.9719E-4, 1.9972E-4, 2.0122E-4,&
     & 2.0257E-4, 2.0350E-4, 2.0371E-4, 2.0596E-4, 2.0943E-4, 2.1080E-4,&
     & 2.3029E-4, 2.5337E-4, 2.7402E-4, 2.8378E-4, 3.0276E-4, 3.1715E-4,&
     & 1.8632E-4, 1.9196E-4, 1.9865E-4, 2.0485E-4, 2.1403E-4, 2.1683E-4,&
     & 2.1931E-4, 2.2183E-4, 2.2333E-4, 2.2469E-4, 2.2561E-4, 2.2582E-4,&
     & 2.2807E-4, 2.3154E-4, 2.3292E-4, 2.5241E-4, 2.7549E-4, 2.9614E-4,&
     & 3.0589E-4, 3.2488E-4, 3.3926E-4, 2.3174E-4, 2.3842E-4, 2.4331E-4,&
     & 2.4962E-4, 2.5898E-4, 2.6172E-4, 2.6419E-4, 2.6672E-4, 2.6823E-4,&
     & 2.6958E-4, 2.7050E-4, 2.7071E-4, 2.7296E-4, 2.7643E-4, 2.7781E-4,&
     & 2.9730E-4, 3.2037E-4, 3.4102E-4, 3.5078E-4, 3.6977E-4, 3.8415E-4,&
     & 2.5761E-4, 2.6309E-4, 2.6935E-4, 2.7540E-4, 2.8405E-4, 2.8672E-4,&
     & 2.8909E-4, 2.9150E-4, 2.9293E-4, 2.9422E-4, 2.9510E-4/           
      DATA X4001/ 2.9530E-4, 2.9744E-4, 3.0075E-4, 3.0206E-4, 3.2063E-4,&
     & 3.4262E-4, 3.6229E-4, 3.7159E-4, 3.8968E-4, 4.0339E-4, 2.7853E-4,&
     & 2.8408E-4, 2.9033E-4, 2.9651E-4, 3.0519E-4, 3.0787E-4, 3.1026E-4,&
     & 3.1268E-4, 3.1412E-4, 3.1542E-4, 3.1630E-4, 3.1650E-4, 3.1865E-4,&
     & 3.2198E-4, 3.2329E-4, 3.4195E-4, 3.6404E-4, 3.8381E-4, 3.9315E-4,&
     & 4.1133E-4, 4.2510E-4, 3.4440E-4, 3.4991E-4, 3.5612E-4, 3.6221E-4,&
     & 3.7103E-4, 3.7374E-4, 3.7614E-4, 3.7859E-4, 3.8004E-4, 3.8135E-4,&
     & 3.8225E-4, 3.8245E-4, 3.8463E-4, 3.8800E-4, 3.8933E-4, 4.0821E-4,&
     & 4.3057E-4, 4.5058E-4, 4.6004E-4, 4.7844E-4, 4.9237E-4, 3.9123E-4,&
     & 3.9673E-4, 4.0304E-4, 4.0912E-4, 4.1799E-4, 4.2071E-4, 4.2313E-4,&
     & 4.2560E-4, 4.2706E-4, 4.2838E-4, 4.2928E-4, 4.2949E-4, 4.3168E-4,&
     & 4.3507E-4, 4.3641E-4, 4.5543E-4, 4.7794E-4, 4.9808E-4, 5.0760E-4,&
     & 5.2613E-4, 5.4016E-4, 4.8370E-4, 4.8926E-4, 4.9558E-4, 5.0171E-4,&
     & 5.1065E-4, 5.1340E-4, 5.1584E-4, 5.1833E-4, 5.1981E-4, 5.2115E-4,&
     & 5.2206E-4, 5.2226E-4, 5.2448E-4, 5.2790E-4, 5.2926E-4, 5.4847E-4,&
     & 5.7122E-4, 5.9157E-4, 6.0119E-4, 6.1991E-4, 6.3408E-4, 8.2283E-4,&
     & 8.2846E-4, 8.3485E-4, 8.4107E-4, 8.5016E-4, 8.5297E-4/           
      DATA X4101/ 8.5547E-4, 8.5801E-4, 8.5952E-4, 8.6089E-4, 8.6181E-4,&
     & 8.6203E-4, 8.6429E-4, 8.6778E-4, 8.6917E-4, 8.8879E-4, 9.1201E-4,&
     & 9.3280E-4, 9.4262E-4, 9.6173E-4, 9.7621E-4, 1.1478E-3, 1.1534E-3,&
     & 1.1598E-3, 1.1660E-3, 1.1752E-3, 1.1780E-3, 1.1806E-3, 1.1831E-3,&
     & 1.1847E-3, 1.1860E-3, 1.1870E-3, 1.1872E-3, 1.1895E-3, 1.1930E-3,&
     & 1.1944E-3, 1.2142E-3, 1.2377E-3, 1.2587E-3, 1.2686E-3, 1.2880E-3,&
     & 1.3026E-3, 1.4729E-3, 1.4784E-3, 1.4848E-3, 1.4911E-3, 1.5004E-3,&
     & 1.5032E-3, 1.5058E-3, 1.5084E-3, 1.5099E-3, 1.5113E-3, 1.5122E-3,&
     & 1.5125E-3, 1.5148E-3, 1.5183E-3, 1.5197E-3, 1.5397E-3, 1.5633E-3,&
     & 1.5845E-3, 1.5945E-3, 1.6139E-3, 1.6287E-3, 1.6824E-3, 1.6880E-3,&
     & 1.6944E-3, 1.7007E-3, 1.7100E-3, 1.7129E-3, 1.7154E-3, 1.7180E-3,&
     & 1.7196E-3, 1.7210E-3, 1.7219E-3, 1.7222E-3, 1.7245E-3, 1.7280E-3,&
     & 1.7294E-3, 1.7495E-3, 1.7732E-3, 1.7944E-3, 1.8045E-3, 1.8240E-3,&
     & 1.8388E-3, 2.2238E-3, 2.2294E-3, 2.2358E-3, 2.2421E-3, 2.2515E-3,&
     & 2.2543E-3, 2.2569E-3, 2.2595E-3, 2.2611E-3, 2.2625E-3, 2.2634E-3,&
     & 2.2636E-3, 2.2659E-3, 2.2695E-3, 2.2709E-3, 2.2911E-3, 2.3149E-3,&
     & 2.3362E-3, 2.3463E-3, 2.3659E-3, 2.3807E-3, 2.5727E-3/           
      DATA X4201/ 2.5783E-3, 2.5847E-3, 2.5910E-3, 2.6003E-3, 2.6032E-3,&
     & 2.6058E-3, 2.6084E-3, 2.6099E-3, 2.6113E-3, 2.6123E-3, 2.6125E-3,&
     & 2.6148E-3, 2.6184E-3, 2.6198E-3, 2.6399E-3, 2.6638E-3, 2.6851E-3,&
     & 2.6951E-3, 2.7147E-3, 2.7296E-3, 2.9918E-3, 2.9973E-3, 3.0038E-3,&
     & 3.0101E-3, 3.0194E-3, 3.0223E-3, 3.0249E-3, 3.0275E-3, 3.0290E-3,&
     & 3.0304E-3, 3.0314E-3, 3.0316E-3, 3.0339E-3, 3.0375E-3, 3.0389E-3,&
     & 3.0590E-3, 3.0828E-3, 3.1041E-3, 3.1142E-3, 3.1338E-3, 3.1487E-3,&
     & 9.6957E-5, 1.1265E-4, 1.3012E-4, 1.4695E-4, 1.7181E-4, 1.7963E-4,&
     & 1.8665E-4, 1.9392E-4, 1.9831E-4, 2.0229E-4, 2.0503E-4, 2.0566E-4,&
     & 2.1244E-4, 2.2316E-4, 2.2749E-4, 2.9655E-4, 4.0403E-4, 5.2664E-4,&
     & 5.9242E-4, 7.2995E-4, 8.5303E-4, 9.6957E-5, 1.1265E-4, 1.3012E-4,&
     & 1.4695E-4, 1.7181E-4, 1.7963E-4, 1.8665E-4, 1.9392E-4, 1.9831E-4,&
     & 2.0229E-4, 2.0503E-4, 2.0566E-4, 2.1244E-4, 2.2316E-4, 2.2749E-4,&
     & 2.9655E-4, 4.0403E-4, 5.2664E-4, 5.9242E-4, 7.2996E-4, 8.5303E-4,&
     & 9.7182E-5, 1.1265E-4, 1.3012E-4, 1.4695E-4, 1.7181E-4, 1.7963E-4,&
     & 1.8665E-4, 1.9392E-4, 1.9831E-4, 2.0229E-4, 2.0503E-4, 2.0566E-4,&
     & 2.1244E-4, 2.2316E-4, 2.2749E-4, 2.9655E-4, 4.0403E-4/           
      DATA X4301/ 5.2664E-4, 5.9242E-4, 7.2996E-4, 8.5303E-4, 9.7912E-5,&
     & 1.1293E-4, 1.3012E-4, 1.4696E-4, 1.7181E-4, 1.7963E-4, 1.8666E-4,&
     & 1.9393E-4, 1.9832E-4, 2.0230E-4, 2.0504E-4, 2.0567E-4, 2.1245E-4,&
     & 2.2317E-4, 2.2750E-4, 2.9655E-4, 4.0404E-4, 5.2665E-4, 5.9243E-4,&
     & 7.2996E-4, 8.5304E-4, 9.9078E-5, 1.1358E-4, 1.3036E-4, 1.4697E-4,&
     & 1.7183E-4, 1.7965E-4, 1.8667E-4, 1.9394E-4, 1.9833E-4, 2.0231E-4,&
     & 2.0505E-4, 2.0568E-4, 2.1246E-4, 2.2318E-4, 2.2751E-4, 2.9657E-4,&
     & 4.0405E-4, 5.2666E-4, 5.9244E-4, 7.2998E-4, 8.5305E-4, 1.3252E-4,&
     & 1.4656E-4, 1.6294E-4, 1.7928E-4, 2.0396E-4, 2.1178E-4, 2.1880E-4,&
     & 2.2607E-4, 2.3046E-4, 2.3444E-4, 2.3718E-4, 2.3781E-4, 2.4459E-4,&
     & 2.5531E-4, 2.5964E-4, 3.2870E-4, 4.3618E-4, 5.5879E-4, 6.2457E-4,&
     & 7.6211E-4, 8.8518E-4, 1.4435E-4, 1.5816E-4, 1.7433E-4, 1.9050E-4,&
     & 2.1505E-4, 2.2286E-4, 2.2989E-4, 2.3716E-4, 2.4154E-4, 2.4553E-4,&
     & 2.4827E-4, 2.4890E-4, 2.5568E-4, 2.6639E-4, 2.7073E-4, 3.3978E-4,&
     & 4.4726E-4, 5.6988E-4, 6.3565E-4, 7.7319E-4, 8.9627E-4, 1.6227E-4,&
     & 1.7587E-4, 1.9183E-4, 2.0788E-4, 2.3231E-4, 2.4010E-4, 2.4711E-4,&
     & 2.5439E-4, 2.5877E-4, 2.6276E-4, 2.6549E-4, 2.6613E-4/           
      DATA X4401/ 2.7291E-4, 2.8362E-4, 2.8795E-4, 3.5701E-4, 4.6449E-4,&
     & 5.8710E-4, 6.5288E-4, 7.9042E-4, 9.1349E-4, 1.8907E-4, 2.0236E-4,&
     & 2.1809E-4, 2.3400E-4, 2.5815E-4, 2.6590E-4, 2.7290E-4, 2.8016E-4,&
     & 2.8454E-4, 2.8853E-4, 2.9127E-4, 2.9190E-4, 2.9868E-4, 3.0940E-4,&
     & 3.1373E-4, 3.8278E-4, 4.9026E-4, 6.1288E-4, 6.7866E-4, 8.1619E-4,&
     & 9.3927E-4, 2.1017E-4, 2.2346E-4, 2.3901E-4, 2.5497E-4, 2.7906E-4,&
     & 2.8680E-4, 2.9379E-4, 3.0104E-4, 3.0543E-4, 3.0941E-4, 3.1215E-4,&
     & 3.1278E-4, 3.1956E-4, 3.3028E-4, 3.3461E-4, 4.0367E-4, 5.1115E-4,&
     & 6.3376E-4, 6.9954E-4, 8.3708E-4, 9.6015E-4, 2.4128E-4, 2.5654E-4,&
     & 2.7132E-4, 2.8646E-4, 3.1084E-4, 3.1853E-4, 3.2549E-4, 3.3274E-4,&
     & 3.3712E-4, 3.4110E-4, 3.4384E-4, 3.4447E-4, 3.5125E-4, 3.6197E-4,&
     & 3.6630E-4, 4.3536E-4, 5.4284E-4, 6.6545E-4, 7.3123E-4, 8.6877E-4,&
     & 9.9184E-4, 2.8914E-4, 3.0208E-4, 3.1789E-4, 3.3350E-4, 3.5762E-4,&
     & 3.6537E-4, 3.7236E-4, 3.7960E-4, 3.8398E-4, 3.8797E-4, 3.9071E-4,&
     & 3.9134E-4, 3.9812E-4, 4.0884E-4, 4.1317E-4, 4.8223E-4, 5.8971E-4,&
     & 7.1232E-4, 7.7810E-4, 9.1563E-4, 1.0387E-3, 3.1512E-4, 3.2804E-4,&
     & 3.4333E-4, 3.5886E-4, 3.8276E-4, 3.9045E-4, 3.9741E-4/           
      DATA X4501/ 4.0463E-4, 4.0900E-4, 4.1298E-4, 4.1572E-4, 4.1635E-4,&
     & 4.2313E-4, 4.3384E-4, 4.3818E-4, 5.0723E-4, 6.1471E-4, 7.3733E-4,&
     & 8.0311E-4, 9.4064E-4, 1.0637E-3, 4.4387E-4, 4.5676E-4, 4.7208E-4,&
     & 4.8761E-4, 5.1151E-4, 5.1920E-4, 5.2615E-4, 5.3338E-4, 5.3776E-4,&
     & 5.4173E-4, 5.4447E-4, 5.4510E-4, 5.5188E-4, 5.6260E-4, 5.6693E-4,&
     & 6.3599E-4, 7.4347E-4, 8.6608E-4, 9.3186E-4, 1.0694E-3, 1.1925E-3,&
     & 4.9120E-4, 5.0509E-4, 5.2017E-4, 5.3569E-4, 5.5980E-4, 5.6766E-4,&
     & 5.7457E-4, 5.8182E-4, 5.8621E-4, 5.9019E-4, 5.9293E-4, 5.9357E-4,&
     & 6.0035E-4, 6.1106E-4, 6.1539E-4, 6.8445E-4, 7.9193E-4, 9.1455E-4,&
     & 9.8032E-4, 1.1179E-3, 1.2409E-3, 5.9605E-4, 6.1035E-4, 6.2466E-4,&
     & 6.3896E-4, 6.6423E-4, 6.7186E-4, 6.7878E-4, 6.8603E-4, 6.9042E-4,&
     & 6.9439E-4, 6.9713E-4, 6.9776E-4, 7.0454E-4, 7.1526E-4, 7.1959E-4,&
     & 7.8865E-4, 8.9613E-4, 1.0187E-3, 1.0845E-3, 1.2221E-3, 1.3451E-3,&
     & 6.8992E-4, 7.0322E-4, 7.1877E-4, 7.3481E-4, 7.5898E-4, 7.6671E-4,&
     & 7.7370E-4, 7.8096E-4, 7.8535E-4, 7.8933E-4, 7.9207E-4, 7.9270E-4,&
     & 7.9948E-4, 8.1020E-4, 8.1453E-4, 8.8359E-4, 9.9107E-4, 1.1137E-3,&
     & 1.1795E-3, 1.3170E-3, 1.4401E-3, 7.4011E-4, 7.5340E-4/           
      DATA X4601/ 7.6902E-4, 7.8505E-4, 8.0923E-4, 8.1692E-4, 8.2391E-4,&
     & 8.3117E-4, 8.3556E-4, 8.3954E-4, 8.4228E-4, 8.4291E-4, 8.4969E-4,&
     & 8.6041E-4, 8.6474E-4, 9.3380E-4, 1.0413E-3, 1.1639E-3, 1.2297E-3,&
     & 1.3672E-3, 1.4903E-3, 8.8859E-4, 9.0224E-4, 9.1815E-4, 9.3423E-4,&
     & 9.5866E-4, 9.6646E-4, 9.7347E-4, 9.8074E-4, 9.8513E-4, 9.8911E-4,&
     & 9.9185E-4, 9.9248E-4, 9.9926E-4, 1.0100E-3, 1.0143E-3, 1.0834E-3,&
     & 1.1908E-3, 1.3135E-3, 1.3792E-3, 1.5168E-3, 1.6399E-3, 9.8574E-4,&
     & 9.9956E-4, 1.0158E-3, 1.0319E-3, 1.0565E-3, 1.0643E-3, 1.0713E-3,&
     & 1.0786E-3, 1.0830E-3, 1.0870E-3, 1.0897E-3, 1.0903E-3, 1.0971E-3,&
     & 1.1078E-3, 1.1122E-3, 1.1812E-3, 1.2887E-3, 1.4113E-3, 1.4771E-3,&
     & 1.6146E-3, 1.7377E-3, 1.1554E-3, 1.1695E-3, 1.1858E-3, 1.2022E-3,&
     & 1.2268E-3, 1.2347E-3, 1.2417E-3, 1.2490E-3, 1.2533E-3, 1.2573E-3,&
     & 1.2601E-3, 1.2607E-3, 1.2675E-3, 1.2782E-3, 1.2825E-3, 1.3516E-3,&
     & 1.4591E-3, 1.5817E-3, 1.6475E-3, 1.7850E-3, 1.9081E-3, 1.6020E-3,&
     & 1.6165E-3, 1.6332E-3, 1.6499E-3, 1.6747E-3, 1.6825E-3, 1.6896E-3,&
     & 1.6968E-3, 1.7012E-3, 1.7052E-3, 1.7079E-3, 1.7086E-3, 1.7153E-3,&
     & 1.7261E-3, 1.7304E-3, 1.7995E-3, 1.9069E-3, 2.0295E-3/           
      DATA X4701/ 2.0953E-3, 2.2329E-3, 2.3559E-3, 1.8932E-3, 1.9083E-3,&
     & 1.9255E-3, 1.9423E-3, 1.9671E-3, 1.9750E-3, 1.9820E-3, 1.9893E-3,&
     & 1.9936E-3, 1.9976E-3, 2.0004E-3, 2.0010E-3, 2.0078E-3, 2.0185E-3,&
     & 2.0228E-3, 2.0919E-3, 2.1994E-3, 2.3220E-3, 2.3878E-3, 2.5253E-3,&
     & 2.6484E-3, 2.1191E-3, 2.1346E-3, 2.1520E-3, 2.1689E-3, 2.1937E-3,&
     & 2.2015E-3, 2.2086E-3, 2.2158E-3, 2.2202E-3, 2.2242E-3, 2.2270E-3,&
     & 2.2276E-3, 2.2344E-3, 2.2451E-3, 2.2494E-3, 2.3185E-3, 2.4260E-3,&
     & 2.5486E-3, 2.6143E-3, 2.7519E-3, 2.8750E-3, 2.2431E-3, 2.2586E-3,&
     & 2.2760E-3, 2.2929E-3, 2.3177E-3, 2.3256E-3, 2.3326E-3, 2.3399E-3,&
     & 2.3442E-3, 2.3482E-3, 2.3510E-3, 2.3516E-3, 2.3584E-3, 2.3691E-3,&
     & 2.3734E-3, 2.4425E-3, 2.5500E-3, 2.6726E-3, 2.7383E-3, 2.8759E-3,&
     & 2.9990E-3, 2.5146E-3, 2.5303E-3, 2.5478E-3, 2.5646E-3, 2.5895E-3,&
     & 2.5973E-3, 2.6043E-3, 2.6116E-3, 2.6160E-3, 2.6200E-3, 2.6227E-3,&
     & 2.6233E-3, 2.6301E-3, 2.6408E-3, 2.6452E-3, 2.7142E-3, 2.8217E-3,&
     & 2.9443E-3, 3.0101E-3, 3.1476E-3, 3.2707E-3, 2.6634E-3, 2.6790E-3,&
     & 2.6965E-3, 2.7133E-3, 2.7382E-3, 2.7460E-3, 2.7531E-3, 2.7603E-3,&
     & 2.7647E-3, 2.7687E-3, 2.7714E-3, 2.7721E-3, 2.7788E-3/           
      DATA X4801/ 2.7896E-3, 2.7939E-3, 2.8629E-3, 2.9704E-3, 3.0930E-3,&
     & 3.1588E-3, 3.2964E-3, 3.4194E-3, 2.8214E-3, 2.8371E-3, 2.8546E-3,&
     & 2.8714E-3, 2.8962E-3, 2.9041E-3, 2.9111E-3, 2.9184E-3, 2.9227E-3,&
     & 2.9267E-3, 2.9295E-3, 2.9301E-3, 2.9369E-3, 2.9476E-3, 2.9519E-3,&
     & 3.0210E-3, 3.1285E-3, 3.2511E-3, 3.3169E-3, 3.4544E-3, 3.5775E-3,&
     & 4.8000E-1, 5.0000E-1, 5.1000E-1, 5.2000E-1, 5.3000E-1, 5.4000E-1,&
     & 5.5000E-1, 5.6000E-1, 5.7000E-1, 5.8000E-1, 5.9000E-1, 6.0000E-1,&
     & 6.2000E-1, 6.4000E-1, 6.6000E-1, 6.8000E-1, 7.0000E-1, 7.2000E-1,&
     & 7.4000E-1, 7.6000E-1, 7.8000E-1, 8.0000E-1, 8.2000E-1, 8.4000E-1,&
     & 8.6000E-1, 8.8000E-1, 9.0000E-1, 9.2000E-1, 9.2500E-1, 9.3000E-1,&
     & 9.3500E-1, 9.4000E-1, 9.4500E-1, 9.5000E-1, 9.6000E-1, 9.7000E-1,&
     & 9.8000E-1, 9.8500E-1, 9.9000E-1, 1.0000E+0, 2.8276E-3, 4.4679E-3,&
     & 5.5403E-3, 6.8118E-3, 8.3076E-3, 1.0054E-2, 1.2079E-2, 1.4412E-2,&
     & 1.7082E-2, 2.0121E-2, 2.3561E-2, 2.7435E-2, 3.6623E-2, 4.7966E-2,&
     & 6.1760E-2, 7.8310E-2, 9.7932E-2, 1.2095E-1, 1.4768E-1, 1.7847E-1,&
     & 2.1362E-1, 2.5346E-1, 2.9831E-1, 3.4846E-1, 4.0426E-1, 4.6605E-1,&
     & 5.3425E-1, 6.0942E-1, 6.2938E-1, 6.4983E-1, 6.7079E-1/           
      DATA X4901/ 6.9228E-1, 7.1431E-1, 7.3690E-1, 7.8388E-1, 8.3340E-1,&
     & 8.8570E-1, 9.1299E-1, 9.4108E-1, 1.0000E+0, 2.7882E+0, 2.7551E+0,&
     & 2.7385E+0, 2.7217E+0, 2.7050E+0, 2.6881E+0, 2.6712E+0, 2.6542E+0,&
     & 2.6371E+0, 2.6199E+0, 2.6025E+0, 2.5851E+0, 2.5497E+0, 2.5137E+0,&
     & 2.4769E+0, 2.4392E+0, 2.4005E+0, 2.3605E+0, 2.3192E+0, 2.2763E+0,&
     & 2.2314E+0, 2.1844E+0, 2.1348E+0, 2.0820E+0, 2.0254E+0, 1.9640E+0,&
     & 1.8962E+0, 1.8198E+0, 1.7990E+0, 1.7773E+0, 1.7546E+0, 1.7308E+0,&
     & 1.7058E+0, 1.6793E+0, 1.6210E+0, 1.5526E+0, 1.4676E+0, 1.4145E+0,&
     & 1.3483E+0, 1.0000E+0, 1.7167E-3, 2.6132E-3, 3.1836E-3, 3.8479E-3,&
     & 4.6163E-3, 5.4990E-3, 6.5067E-3, 7.6505E-3, 8.9419E-3, 1.0393E-2,&
     & 1.2015E-2, 1.3821E-2, 1.8037E-2, 2.3152E-2, 2.9285E-2, 3.6567E-2,&
     & 4.5146E-2, 5.5185E-2, 6.6872E-2, 8.0419E-2, 9.6077E-2, 1.1414E-1,&
     & 1.3498E-1, 1.5905E-1, 1.8696E-1, 2.1956E-1, 2.5812E-1, 3.0469E-1,&
     & 3.1796E-1, 3.3203E-1, 3.4699E-1, 3.6297E-1, 3.8011E-1, 3.9861E-1,&
     & 4.4070E-1, 4.9236E-1, 5.5998E-1, 6.0421E-1, 6.6124E-1, 1.0000E+0,&
     & 1.1330E+1, 1.1528E+1, 1.1635E+1, 1.1746E+1, 1.1861E+1, 1.1977E+1,&
     & 1.2095E+1, 1.2214E+1, 1.2332E+1, 1.2451E+1, 1.2568E+1/           
      DATA X5001/ 1.2684E+1, 1.2912E+1, 1.3133E+1, 1.3348E+1, 1.3555E+1,&
     & 1.3758E+1, 1.3957E+1, 1.4153E+1, 1.4348E+1, 1.4543E+1, 1.4739E+1,&
     & 1.4936E+1, 1.5134E+1, 1.5332E+1, 1.5531E+1, 1.5731E+1, 1.5933E+1,&
     & 1.5984E+1, 1.6036E+1, 1.6089E+1, 1.6143E+1, 1.6198E+1, 1.6255E+1,&
     & 1.6376E+1, 1.6512E+1, 1.6676E+1, 1.6777E+1, 1.6900E+1, 1.7538E+1,&
     & 2.2660E+1, 2.2360E+1, 2.2221E+1, 2.2088E+1, 2.1961E+1, 2.1839E+1,&
     & 2.1724E+1, 2.1613E+1, 2.1507E+1, 2.1405E+1, 2.1307E+1, 2.1214E+1,&
     & 2.1037E+1, 2.0872E+1, 2.0717E+1, 2.0572E+1, 2.0434E+1, 2.0302E+1,&
     & 2.0174E+1, 2.0051E+1, 1.9930E+1, 1.9811E+1, 1.9692E+1, 1.9573E+1,&
     & 1.9451E+1, 1.9325E+1, 1.9191E+1, 1.9046E+1, 1.9006E+1, 1.8966E+1,&
     & 1.8924E+1, 1.8880E+1, 1.8833E+1, 1.8784E+1, 1.8677E+1, 1.8550E+1,&
     & 1.8393E+1, 1.8294E+1, 1.8170E+1, 1.7538E+1, 2.2486E+0, 2.3457E+0,&
     & 2.4000E+0, 2.4574E+0, 2.5176E+0, 2.5802E+0, 2.6447E+0, 2.7107E+0,&
     & 2.7780E+0, 2.8463E+0, 2.9154E+0, 2.9849E+0, 3.1250E+0, 3.2657E+0,&
     & 3.4065E+0, 3.5477E+0, 3.6898E+0, 3.8336E+0, 3.9800E+0, 4.1302E+0,&
     & 4.2849E+0, 4.4449E+0, 4.6104E+0, 4.7817E+0, 4.9584E+0, 5.1405E+0,&
     & 5.3282E+0, 5.5236E+0, 5.5741E+0, 5.6257E+0, 5.6783E+0/           
      DATA X5101/ 5.7323E+0, 5.7880E+0, 5.8458E+0, 5.9697E+0, 6.1104E+0,&
     & 6.2806E+0, 6.3849E+0, 6.5126E+0, 7.1621E+0, 7.6870E+0, 7.7619E+0,&
     & 7.7987E+0, 7.8349E+0, 7.8706E+0, 7.9058E+0, 7.9403E+0, 7.9742E+0,&
     & 8.0074E+0, 8.0399E+0, 8.0717E+0, 8.1027E+0, 8.1622E+0, 8.2183E+0,&
     & 8.2706E+0, 8.3189E+0, 8.3628E+0, 8.4020E+0, 8.4361E+0, 8.4646E+0,&
     & 8.4870E+0, 8.5026E+0, 8.5108E+0, 8.5105E+0, 8.5005E+0, 8.4788E+0,&
     & 8.4426E+0, 8.3874E+0, 8.3698E+0, 8.3504E+0, 8.3289E+0, 8.3050E+0,&
     & 8.2786E+0, 8.2491E+0, 8.1787E+0, 8.0874E+0, 7.9625E+0, 7.8787E+0,&
     & 7.7696E+0, 7.1621E+0, 5.1825E-1, 1.9077E+2, 4.6270E+0, 1.6200E-1,&
     & 1.0000E-3, 2.0000E-3, 1.0000E-3, 1.0000E-3/                      
                                                                        
!********************************************************************** 
       NG = 19 
       N1 = 21 
       N2 = 28 
       N3 = 8 
       NS = 40 
       DO 20 I=1,4 
         DO 10 J=1,19 
           G(J,I) = Z(J+(I-1)*19) 
   10    CONTINUE 
   20  CONTINUE 

       DO 30 I=1,21
         TT(I) = Z(I+76) 
   30 END DO 

       DO 40 I=1,28
         DD(I) = Z(I+97) 
   40  CONTINUE 

       KK=125
       DO 70 I=1,8 
         DO 60 J=1,28 
           DO 50 K=1,21 
             KK=KK+1 
             GG(K,J,I) = Z(KK) 
   50      CONTINUE 
   60    CONTINUE 
   70  CONTINUE 

       DO 90 I=1,8
         DO 80 J=1,40 
           SAT(J,I) = Z(J+(I-1)*40+4829) 
   80    CONTINUE 
   90  CONTINUE 

      DO 100 I=1,8
        C(I) = Z(I+5149) 
  100 CONTINUE 

      IGOTO = 4
      CALL FLUID(TEMP,PRES,DENS,PROPS,NP,ENTRY,VAPOR,ERROR,IGOTO) 

      RETURN
      END Subroutine CH4
