!+
      SUBROUTINE F2
! ---------------------------------------------------------------------------
! PURPOSE - Load the common block /FLUDPC/
!.....FLOURINE TABLES FOR FLUID SUBPROGRAM.                             

!      WRITTEN BY: THEODORE E. FESSLER, NASA TM X-3572, AUGUST 1977     
!      REWRITTEN BY: LT. MARK D. KLEM & MARGARET P. PROCTOR, JANUARY 198
!                                                                       
!      THE ORIGINAL PROGRAM WAS WRITTEN IN SFTRAN, BUT THIS PROGRAM IS  
!      REWRITTEN IN STANDARD FORTRAN 77 TO RUN PRIMARILY ON PERSONAL    
!      COMPUTERS AND CAN ALSO RUN ON MAINFRAMES. MUCH OF THE OLD CODE WA
!      COMMENTED OUT BUT LEFT INTACT FOR DOCUMENTATION AND REFERENCE    
!      PURPOSES.                                                        
!                                                                       

  INTERFACE
    SUBROUTINE Fluid(T,P,RHO,PROPS,NP,ENTRY,VAPOR,ERROR,igoto)
      REAL,INTENT(IN OUT):: t
      REAL,INTENT(IN OUT):: p
      REAL,INTENT(IN OUT):: rho
      REAL,INTENT(OUT),DIMENSION(:):: props
      INTEGER,INTENT(IN):: np
      INTEGER,INTENT(IN):: entry
      LOGICAL,INTENT(OUT):: vapor
      INTEGER,INTENT(OUT):: error
      INTEGER,INTENT(IN):: igoto
    END Subroutine Fluid
  END INTERFACE


!                -- UNITS --                                            
                                                                        
!       R = 0.21882 JOULES / GRAM - DEG. K      C(1)                    
!       TCRIT = 144.31 DEG. K                   C(2)                    
!       PCRIT = 5.215 MEGA-NEWTONS / METER**2   C(3)                    
!       DCRIT = 0.57375 GRAMS / CENTIMETER**3   C(4)                    
!       VISCOSITY = GRAMS / CENTIMETER - SEC.        PROP(7)            
!       CONDUCTIVITY = WATTS / CENTIMETER - DEG. K   PROP(8)            
                                                                        
!     DIMENSION G(19,4),TT(21),DD(28),GG(21,28,8),SAT(40,8),C(8),M(4)   
!********************************************************************** 
      DIMENSION G(29,4),TT(27),DD(30),GG(27,30,8),SAT(40,8),C(8),M(4) 
       INTEGER ERROR,ENTRY 
       DIMENSION PROPS(8) 
       LOGICAL VAPOR 
!********************************************************************** 
                                                                        
      DIMENSION X0001(100),X0101(100),X0201(100),X0301(100),X0401(100), &
     &          X0501(100),X0601(100),X0701(100),X0801(100),X0901(100), &
     &          X1001(100),X1101(100),X1201(100),X1301(100),X1401(100), &
     &          X1501(100),X1601(100),X1701(100),X1801(100),X1901(100), &
     &          X2001(100),X2101(100),X2201(100),X2301(100),X2401(100), &
     &          X2501(100),X2601(100),X2701(100),X2801(100),X2901(100), &
     &          X3001(100),X3101(100),X3201(100),X3301(100),X3401(100), &
     &          X3501(100),X3601(100),X3701(100),X3801(100),X3901(100), &
     &          X4001(100),X4101(100),X4201(100),X4301(100),X4401(100), &
     &          X4501(100),X4601(100),X4701(100),X4801(100),X4901(100), &
     &          X5001(100),X5101(57)                                    
                                                                        
      DIMENSION Z(5157) 
!********************************************************************** 
       COMMON /FLUDPC/ G,TT,DD,GG,SAT,C,M,NG,N1,N2,N3,NS 
!********************************************************************** 
      EQUIVALENCE (X0001,Z(0001)), (X0101,Z(0101)), (X0201,Z(0201)),    &
     &            (X0301,Z(0301)), (X0401,Z(0401)), (X0501,Z(0501)),    &
     &            (X0601,Z(0601)), (X0701,Z(0701)), (X0801,Z(0801)),    &
     &            (X0901,Z(0901)), (X1001,Z(1001)), (X1101,Z(1101)),    &
     &            (X1201,Z(1201)), (X1301,Z(1301)), (X1401,Z(1401)),    &
     &            (X1501,Z(1501)), (X1601,Z(1601)), (X1701,Z(1701)),    &
     &            (X1801,Z(1801)), (X1901,Z(1901)), (X2001,Z(2001)),    &
     &            (X2101,Z(2101)), (X2201,Z(2201)), (X2301,Z(2301)),    &
     &            (X2401,Z(2401)), (X2501,Z(2501)), (X2601,Z(2601)),    &
     &            (X2701,Z(2701)), (X2801,Z(2801)), (X2901,Z(2901)),    &
     &            (X3001,Z(3001)), (X3101,Z(3101)), (X3201,Z(3201)),    &
     &            (X3301,Z(3301)), (X3401,Z(3401)), (X3501,Z(3501)),    &
     &            (X3601,Z(3601)), (X3701,Z(3701)), (X3801,Z(3801)),    &
     &            (X3901,Z(3901)), (X4001,Z(4001)), (X4101,Z(4101)),    &
     &            (X4201,Z(4201)), (X4301,Z(4301)), (X4401,Z(4401)),    &
     &            (X4501,Z(4501)), (X4601,Z(4601)), (X4701,Z(4701)),    &
     &            (X4801,Z(4801)), (X4901,Z(4901)), (X5001,Z(5001)),    &
     &            (X5101,Z(5101))                                       
                                                                        
!********************************************************************** 
!********************************************************************** 
                                                                        
      DATA X0001/ 3.7500E-1, 4.0000E-1, 5.0000E-1, 6.0000E-1, 6.5000E-1,&
     & 7.0000E-1, 8.0000E-1, 8.5000E-1, 9.0000E-1, 9.5000E-1, 1.0000E+0,&
     & 1.2000E+0, 1.4000E+0, 1.8000E+0, 2.2000E+0, 2.6000E+0, 3.0000E+0,&
     & 3.2000E+0, 3.4600E+0, 2.2155E+1, 2.2317E+1, 2.2875E+1, 2.3331E+1,&
     & 2.3531E+1, 2.3716E+1, 2.4050E+1, 2.4202E+1, 2.4345E+1, 2.4482E+1,&
     & 2.4611E+1, 2.5074E+1, 2.5471E+1, 2.6135E+1, 2.6685E+1, 2.7162E+1,&
     & 2.7587E+1, 2.7783E+1, 2.8025E+1, 1.1983E+1, 1.2038E+1, 1.2258E+1,&
     & 1.2478E+1, 1.2587E+1, 1.2697E+1, 1.2917E+1, 1.3027E+1, 1.3138E+1,&
     & 1.3249E+1, 1.3360E+1, 1.3807E+1, 1.4262E+1, 1.5198E+1, 1.6175E+1,&
     & 1.7197E+1, 1.8263E+1, 1.8811E+1, 1.9538E+1, 2.5062E+0, 2.5042E+0,&
     & 2.4988E+0, 2.4974E+0, 2.4981E+0, 2.4997E+0, 2.5054E+0, 2.5094E+0,&
     & 2.5142E+0, 2.5197E+0, 2.5259E+0, 2.5568E+0, 2.5960E+0, 2.6923E+0,&
     & 2.8017E+0, 2.9135E+0, 3.0193E+0, 3.0681E+0, 3.1260E+0, 3.7500E-1,&
     & 4.8600E-1, 5.5700E-1, 6.7200E-1, 7.6900E-1, 8.5500E-1, 8.9300E-1,&
     & 9.2700E-1, 9.5000E-1, 9.6900E-1, 9.7900E-1, 9.9000E-1, 9.9800E-1,&
     & 1.0200E+0, 1.0800E+0, 1.2000E+0, 1.6000E+0, 2.0000E+0, 2.6000E+0,&
     & 3.0000E+0, 3.4600E+0, 1.0000E-6, 8.0000E-5, 4.0000E-5/           
      DATA X0101/ 1.4000E-3, 5.0000E-3, 2.3000E-2, 7.5000E-2, 1.6500E-1,&
     & 2.3000E-1, 3.0500E-1, 3.8500E-1, 4.8000E-1, 5.4500E-1, 6.6500E-1,&
     & 8.3600E-1, 1.1700E+0, 1.3400E+0, 1.4700E+0, 1.5500E+0, 1.6700E+0,&
     & 1.7900E+0, 1.9200E+0, 2.0500E+0, 2.2700E+0, 2.4900E+0, 2.7000E+0,&
     & 2.8100E+0, 2.9700E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0,&
     & 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0,&
     & 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0,&
     & 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3022E+0,&
     & 1.3024E+0, 1.3025E+0, 1.3026E+0, 1.3027E+0, 1.3027E+0, 1.3027E+0,&
     & 1.3027E+0, 1.3027E+0, 1.3027E+0, 1.3027E+0, 1.3027E+0, 1.3027E+0,&
     & 1.3027E+0, 1.3027E+0, 1.3027E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0,&
     & 1.3028E+0, 1.3028E+0, 1.3024E+0, 1.3026E+0, 1.3027E+0, 1.3027E+0,&
     & 1.3027E+0, 1.3027E+0, 1.3027E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0,&
     & 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0,&
     & 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.3028E+0, 1.2921E+0,&
     & 1.2963E+0, 1.2982E+0, 1.2999E+0, 1.3007E+0, 1.3012E+0, 1.3014E+0,&
     & 1.3015E+0, 1.3016E+0, 1.3016E+0, 1.3016E+0, 1.3017E+0/           
      DATA X0201/ 1.3017E+0, 1.3018E+0, 1.3019E+0, 1.3021E+0, 1.3025E+0,&
     & 1.3026E+0, 1.3028E+0, 1.3028E+0, 1.3029E+0, 1.2705E+0, 1.2810E+0,&
     & 1.2863E+0, 1.2925E+0, 1.2954E+0, 1.2971E+0, 1.2977E+0, 1.2981E+0,&
     & 1.2984E+0, 1.2986E+0, 1.2987E+0, 1.2988E+0, 1.2989E+0, 1.2991E+0,&
     & 1.2996E+0, 1.3003E+0, 1.3017E+0, 1.3023E+0, 1.3028E+0, 1.3030E+0,&
     & 1.3031E+0, 1.1835E+0, 1.2160E+0, 1.2334E+0, 1.2558E+0, 1.2692E+0,&
     & 1.2769E+0, 1.2796E+0, 1.2816E+0, 1.2828E+0, 1.2838E+0, 1.2842E+0,&
     & 1.2847E+0, 1.2851E+0, 1.2860E+0, 1.2882E+0, 1.2916E+0, 1.2976E+0,&
     & 1.3005E+0, 1.3028E+0, 1.3037E+0, 1.3045E+0, 9.7543E-1, 1.0551E+0,&
     & 1.0988E+0, 1.1576E+0, 1.1957E+0, 1.2207E+0, 1.2291E+0, 1.2356E+0,&
     & 1.2395E+0, 1.2425E+0, 1.2441E+0, 1.2457E+0, 1.2468E+0, 1.2497E+0,&
     & 1.2567E+0, 1.2674E+0, 1.2867E+0, 1.2958E+0, 1.3032E+0, 1.3062E+0,&
     & 1.3088E+0, 6.8118E-1, 8.2210E-1, 9.0059E-1, 1.0085E+0, 1.0811E+0,&
     & 1.1312E+0, 1.1491E+0, 1.1629E+0, 1.1713E+0, 1.1777E+0, 1.1809E+0,&
     & 1.1842E+0, 1.1866E+0, 1.1928E+0, 1.2075E+0, 1.2299E+0, 1.2704E+0,&
     & 1.2898E+0, 1.3056E+0, 1.3123E+0, 1.3179E+0, 5.2011E-1, 6.9046E-1,&
     & 7.8606E-1, 9.1899E-1, 1.0099E+0, 1.0744E+0, 1.0980E+0/           
      DATA X0301/ 1.1166E+0, 1.1278E+0, 1.1364E+0, 1.1407E+0, 1.1452E+0,&
     & 1.1484E+0, 1.1567E+0, 1.1764E+0, 1.2063E+0, 1.2606E+0, 1.2868E+0,&
     & 1.3085E+0, 1.3177E+0, 1.3256E+0, 3.7012E-1, 5.6689E-1, 6.7789E-1,&
     & 8.3290E-1, 9.4058E-1, 1.0181E+0, 1.0470E+0, 1.0701E+0, 1.0843E+0,&
     & 1.0950E+0, 1.1004E+0, 1.1061E+0, 1.1101E+0, 1.1205E+0, 1.1453E+0,&
     & 1.1829E+0, 1.2513E+0, 1.2849E+0, 1.3130E+0, 1.3250E+0, 1.3354E+0,&
     & 2.4512E-1, 4.6191E-1, 5.8569E-1, 7.5928E-1, 8.8077E-1, 9.6924E-1,&
     & 1.0025E+0, 1.0293E+0, 1.0459E+0, 1.0585E+0, 1.0648E+0, 1.0715E+0,&
     & 1.0762E+0, 1.0885E+0, 1.1176E+0, 1.1621E+0, 1.2436E+0, 1.2842E+0,&
     & 1.3188E+0, 1.3338E+0, 1.3468E+0, 1.5112E-1, 3.8306E-1, 5.1440E-1,&
     & 6.9995E-1, 8.3083E-1, 9.2659E-1, 9.6315E-1, 9.9279E-1, 1.0112E+0,&
     & 1.0253E+0, 1.0324E+0, 1.0400E+0, 1.0452E+0, 1.0591E+0, 1.0920E+0,&
     & 1.1425E+0, 1.2369E+0, 1.2851E+0, 1.3270E+0, 1.3454E+0, 1.3614E+0,&
     & 1.3696E-1, 3.6353E-1, 4.9438E-1, 6.7847E-1, 8.1006E-1, 9.0721E-1,&
     & 9.4452E-1, 9.7495E-1, 9.9397E-1, 1.0087E+0, 1.0161E+0, 1.0239E+0,&
     & 1.0295E+0, 1.0439E+0, 1.0785E+0, 1.1320E+0, 1.2335E+0, 1.2865E+0,&
     & 1.3332E+0, 1.3539E+0, 1.3720E+0, 2.1478E-1, 4.0955E-1/           
      DATA X0401/ 5.2216E-1, 6.8452E-1, 8.0228E-1, 8.9197E-1, 9.2717E-1,&
     & 9.5639E-1, 9.7493E-1, 9.8950E-1, 9.9690E-1, 1.0048E+0, 1.0104E+0,&
     & 1.0253E+0, 1.0611E+0, 1.1176E+0, 1.2295E+0, 1.2907E+0, 1.3460E+0,&
     & 1.3710E+0, 1.3929E+0, 3.1841E-1, 4.8021E-1, 5.7463E-1, 7.1227E-1,&
     & 8.1373E-1, 8.9246E-1, 9.2385E-1, 9.5022E-1, 9.6712E-1, 9.8051E-1,&
     & 9.8735E-1, 9.9471E-1, 9.9995E-1, 1.0139E+0, 1.0484E+0, 1.1053E+0,&
     & 1.2275E+0, 1.2995E+0, 1.3671E+0, 1.3982E+0, 1.4257E+0, 6.0110E-1,&
     & 6.8213E-1, 7.3175E-1, 8.0815E-1, 8.6879E-1, 9.1961E-1, 9.4118E-1,&
     & 9.6004E-1, 9.7255E-1, 9.8273E-1, 9.8804E-1, 9.9383E-1, 9.9802E-1,&
     & 1.0094E+0, 1.0395E+0, 1.0950E+0, 1.2354E+0, 1.3288E+0, 1.4216E+0,&
     & 1.4653E+0, 1.5044E+0, 6.4107E-1, 7.0781E-1, 7.4971E-1, 8.1599E-1,&
     & 8.7047E-1, 9.1758E-1, 9.3804E-1, 9.5619E-1, 9.6836E-1, 9.7836E-1,&
     & 9.8360E-1, 9.8935E-1, 9.9352E-1, 1.0049E+0, 1.0357E+0, 1.0940E+0,&
     & 1.2474E+0, 1.3524E+0, 1.4584E+0, 1.5086E+0, 1.5539E+0, 6.3232E-1,&
     & 6.9751E-1, 7.3853E-1, 8.0461E-1, 8.6015E-1, 9.0852E-1, 9.2984E-1,&
     & 9.4893E-1, 9.6179E-1, 9.7241E-1, 9.7799E-1, 9.8413E-1, 9.8858E-1,&
     & 1.0008E+0, 1.0338E+0, 1.0962E+0, 1.2613E+0, 1.3752E+0/           
      DATA X0501/ 1.4909E+0, 1.5460E+0, 1.5957E+0, 6.0376E-1, 6.7383E-1,&
     & 7.1826E-1, 7.8882E-1, 8.4839E-1, 9.0047E-1, 9.2334E-1, 9.4373E-1,&
     & 9.5747E-1, 9.6879E-1, 9.7474E-1, 9.8128E-1, 9.8603E-1, 9.9903E-1,&
     & 1.0339E+0, 1.0994E+0, 1.2720E+0, 1.3911E+0, 1.5125E+0, 1.5704E+0,&
     & 1.6226E+0, 5.2051E-1, 6.1230E-1, 6.6821E-1, 7.5610E-1, 8.2718E-1,&
     & 8.8789E-1, 9.1417E-1, 9.3735E-1, 9.5280E-1, 9.6547E-1, 9.7210E-1,&
     & 9.7936E-1, 9.8461E-1, 9.9895E-1, 1.0370E+0, 1.1075E+0, 1.2907E+0,&
     & 1.4171E+0, 1.5460E+0, 1.6077E+0, 1.6634E+0, 4.4287E-1, 5.5446E-1,&
     & 6.2224E-1, 7.2672E-1, 8.0995E-1, 8.7981E-1, 9.0950E-1, 9.3547E-1,&
     & 9.5272E-1, 9.6677E-1, 9.7409E-1, 9.8207E-1, 9.8783E-1, 1.0035E+0,&
     & 1.0445E+0, 1.1195E+0, 1.3118E+0, 1.4439E+0, 1.5789E+0, 1.6436E+0,&
     & 1.7021E+0, 3.5356E-1, 4.9214E-1, 5.7545E-1, 7.0137E-1, 7.9891E-1,&
     & 8.7873E-1, 9.1201E-1, 9.4075E-1, 9.5964E-1, 9.7490E-1, 9.8280E-1,&
     & 9.9140E-1, 9.9758E-1, 1.0143E+0, 1.0578E+0, 1.1363E+0, 1.3349E+0,&
     & 1.4708E+0, 1.6100E+0, 1.6768E+0, 1.7373E+0, 2.8653E-1, 4.5045E-1,&
     & 5.4742E-1, 6.9151E-1, 8.0052E-1, 8.8758E-1, 9.2318E-1, 9.5353E-1,&
     & 9.7330E-1, 9.8918E-1, 9.9737E-1, 1.0063E+0, 1.0126E+0/           
      DATA X0601/ 1.0299E+0, 1.0744E+0, 1.1540E+0, 1.3536E+0, 1.4901E+0,&
     & 1.6301E+0, 1.6974E+0, 1.7584E+0, 2.5848E-1, 4.4615E-1, 5.5486E-1,&
     & 7.1220E-1, 8.2694E-1, 9.1489E-1, 9.4963E-1, 9.7889E-1, 9.9779E-1,&
     & 1.0129E+0, 1.0207E+0, 1.0291E+0, 1.0352E+0, 1.0514E+0, 1.0932E+0,&
     & 1.1676E+0, 1.3534E+0, 1.4810E+0, 1.6124E+0, 1.6758E+0, 1.7332E+0,&
     & 3.2234E-1, 4.9985E-1, 6.0016E-1, 7.4072E-1, 8.3821E-1, 9.0852E-1,&
     & 9.3609E-1, 9.5928E-1, 9.7425E-1, 9.8621E-1, 9.9238E-1, 9.9905E-1,&
     & 1.0038E+0, 1.0167E+0, 1.0499E+0, 1.1090E+0, 1.2583E+0, 1.3620E+0,&
     & 1.4697E+0, 1.5219E+0, 1.5693E+0, 3.7578E-1, 5.0737E-1, 5.7824E-1,&
     & 6.7098E-1, 7.2802E-1, 7.6952E-1, 7.8594E-1, 7.9982E-1, 8.0882E-1,&
     & 8.1604E-1, 8.1976E-1, 8.2380E-1, 8.2670E-1, 8.3452E-1, 8.5479E-1,&
     & 8.9131E-1, 9.8559E-1, 1.0525E+0, 1.1228E+0, 1.1571E+0, 1.1884E+0,&
     & 3.3370E-1, 4.3223E-1, 4.8049E-1, 5.3419E-1, 5.6765E-1, 5.9240E-1,&
     & 6.0230E-1, 6.1072E-1, 6.1621E-1, 6.2062E-1, 6.2290E-1, 6.2538E-1,&
     & 6.2716E-1, 6.3198E-1, 6.4452E-1, 6.6734E-1, 7.2736E-1, 7.7065E-1,&
     & 8.1663E-1, 8.3917E-1, 8.5979E-1, 9.0352E-2, 1.0532E-1, 1.1080E-1,&
     & 1.1699E-1, 1.2105E-1, 1.2421E-1, 1.2552E-1, 1.2665E-1/           
      DATA X0701/ 1.2739E-1, 1.2799E-1, 1.2831E-1, 1.2865E-1, 1.2890E-1,&
     & 1.2957E-1, 1.3133E-1, 1.3463E-1, 1.4366E-1, 1.5041E-1, 1.5773E-1,&
     & 1.6137E-1, 1.6471E-1, 1.0000E+0, 1.0000E+0, 9.9999E-1, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 9.9999E-1, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0001E+0,&
     & 1.0000E+0, 9.9998E-1, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 9.9998E-1, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 9.9999E-1, 1.0000E+0, 9.9998E-1, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 9.9999E-1, 1.0000E+0, 1.0000E+0, 1.0000E+0, 9.9973E-1,&
     & 9.9977E-1, 9.9981E-1, 9.9990E-1, 9.9993E-1, 9.9995E-1, 9.9995E-1,&
     & 9.9996E-1, 9.9996E-1, 9.9996E-1, 9.9996E-1, 9.9997E-1, 9.9997E-1,&
     & 9.9996E-1, 9.9997E-1, 9.9998E-1, 9.9998E-1, 9.9997E-1, 9.9999E-1,&
     & 9.9999E-1, 9.9999E-1, 9.9860E-1, 9.9909E-1, 9.9933E-1/           
      DATA X0801/ 9.9961E-1, 9.9973E-1, 9.9980E-1, 9.9982E-1, 9.9983E-1,&
     & 9.9984E-1, 9.9985E-1, 9.9986E-1, 9.9986E-1, 9.9986E-1, 9.9987E-1,&
     & 9.9989E-1, 9.9991E-1, 9.9994E-1, 9.9994E-1, 9.9997E-1, 9.9997E-1,&
     & 9.9997E-1, 9.9480E-1, 9.9628E-1, 9.9708E-1, 9.9809E-1, 9.9868E-1,&
     & 9.9900E-1, 9.9911E-1, 9.9919E-1, 9.9924E-1, 9.9928E-1, 9.9930E-1,&
     & 9.9932E-1, 9.9933E-1, 9.9936E-1, 9.9945E-1, 9.9956E-1, 9.9974E-1,&
     & 9.9978E-1, 9.9983E-1, 9.9984E-1, 9.9984E-1, 9.8474E-1, 9.8868E-1,&
     & 9.9082E-1, 9.9363E-1, 9.9543E-1, 9.9658E-1, 9.9696E-1, 9.9724E-1,&
     & 9.9741E-1, 9.9754E-1, 9.9760E-1, 9.9767E-1, 9.9772E-1, 9.9783E-1,&
     & 9.9812E-1, 9.9851E-1, 9.9911E-1, 9.9929E-1, 9.9941E-1, 9.9944E-1,&
     & 9.9946E-1, 9.6840E-1, 9.7598E-1, 9.8013E-1, 9.8586E-1, 9.8963E-1,&
     & 9.9217E-1, 9.9305E-1, 9.9372E-1, 9.9411E-1, 9.9441E-1, 9.9455E-1,&
     & 9.9471E-1, 9.9482E-1, 9.9509E-1, 9.9574E-1, 9.9664E-1, 9.9797E-1,&
     & 9.9839E-1, 9.9863E-1, 9.9869E-1, 9.9873E-1, 9.5828E-1, 9.6771E-1,&
     & 9.7310E-1, 9.8048E-1, 9.8548E-1, 9.8893E-1, 9.9016E-1, 9.9112E-1,&
     & 9.9168E-1, 9.9211E-1, 9.9231E-1, 9.9254E-1, 9.9269E-1, 9.9308E-1,&
     & 9.9399E-1, 9.9527E-1, 9.9713E-1, 9.9770E-1, 9.9803E-1/           
      DATA X0901/ 9.9811E-1, 9.9816E-1, 9.4727E-1, 9.5918E-1, 9.6571E-1,&
     & 9.7461E-1, 9.8087E-1, 9.8525E-1, 9.8684E-1, 9.8811E-1, 9.8887E-1,&
     & 9.8945E-1, 9.8973E-1, 9.9003E-1, 9.9023E-1, 9.9076E-1, 9.9199E-1,&
     & 9.9369E-1, 9.9614E-1, 9.9689E-1, 9.9730E-1, 9.9740E-1, 9.9746E-1,&
     & 9.3311E-1, 9.4702E-1, 9.5581E-1, 9.6753E-1, 9.7556E-1, 9.8126E-1,&
     & 9.8334E-1, 9.8496E-1, 9.8593E-1, 9.8666E-1, 9.8702E-1, 9.8740E-1,&
     & 9.8766E-1, 9.8833E-1, 9.8988E-1, 9.9203E-1, 9.9507E-1, 9.9599E-1,&
     & 9.9647E-1, 9.9660E-1, 9.9667E-1, 9.2188E-1, 9.3945E-1, 9.4873E-1,&
     & 9.6191E-1, 9.7069E-1, 9.7704E-1, 9.7948E-1, 9.8144E-1, 9.8260E-1,&
     & 9.8349E-1, 9.8394E-1, 9.8440E-1, 9.8473E-1, 9.8556E-1, 9.8747E-1,&
     & 9.9010E-1, 9.9379E-1, 9.9489E-1, 9.9545E-1, 9.9559E-1, 9.9568E-1,&
     & 9.0845E-1, 9.2798E-1, 9.3994E-1, 9.5483E-1, 9.6631E-1, 9.7392E-1,&
     & 9.7679E-1, 9.7905E-1, 9.8042E-1, 9.8145E-1, 9.8195E-1, 9.8247E-1,&
     & 9.8283E-1, 9.8376E-1, 9.8590E-1, 9.8883E-1, 9.9291E-1, 9.9411E-1,&
     & 9.9471E-1, 9.9486E-1, 9.9495E-1, 9.1058E-1, 9.2821E-1, 9.3832E-1,&
     & 9.5268E-1, 9.6287E-1, 9.7034E-1, 9.7320E-1, 9.7552E-1, 9.7696E-1,&
     & 9.7808E-1, 9.7864E-1, 9.7923E-1, 9.7965E-1, 9.8073E-1/           
      DATA X1001/ 9.8320E-1, 9.8659E-1, 9.9127E-1, 9.9262E-1, 9.9328E-1,&
     & 9.9344E-1, 9.9354E-1, 8.9804E-1, 9.1794E-1, 9.2940E-1, 9.4559E-1,&
     & 9.5705E-1, 9.6548E-1, 9.6868E-1, 9.7129E-1, 9.7291E-1, 9.7416E-1,&
     & 9.7479E-1, 9.7545E-1, 9.7592E-1, 9.7714E-1, 9.7991E-1, 9.8370E-1,&
     & 9.8889E-1, 9.9035E-1, 9.9104E-1, 9.9120E-1, 9.9130E-1, 9.7734E-1,&
     & 9.7189E-1, 9.6951E-1, 9.6722E-1, 9.6688E-1, 9.6770E-1, 9.6840E-1,&
     & 9.6923E-1, 9.6988E-1, 9.7048E-1, 9.7082E-1, 9.7120E-1, 9.7150E-1,&
     & 9.7235E-1, 9.7505E-1, 9.7875E-1, 9.8382E-1, 9.8519E-1, 9.8579E-1,&
     & 9.8592E-1, 9.8600E-1, 9.8514E-1, 9.7707E-1, 9.7325E-1, 9.6898E-1,&
     & 9.6726E-1, 9.6708E-1, 9.6743E-1, 9.6797E-1, 9.6844E-1, 9.6890E-1,&
     & 9.6917E-1, 9.6949E-1, 9.6973E-1, 9.7046E-1, 9.7289E-1, 9.7624E-1,&
     & 9.8083E-1, 9.8204E-1, 9.8252E-1, 9.8261E-1, 9.8268E-1, 2.2852E-1,&
     & 4.6240E-1, 5.8887E-1, 7.5549E-1, 8.5886E-1, 9.2195E-1, 9.4139E-1,&
     & 9.5447E-1, 9.6093E-1, 9.6484E-1, 9.6638E-1, 9.6766E-1, 9.6831E-1,&
     & 9.6893E-1, 9.7111E-1, 9.7413E-1, 9.7826E-1, 9.7929E-1, 9.7966E-1,&
     & 9.7972E-1, 9.7977E-1, 7.5220E-1, 8.1567E-1, 8.5083E-1, 8.9648E-1,&
     & 9.2749E-1, 9.4765E-1, 9.5461E-1, 9.5976E-1, 9.6270E-1/           
      DATA X1101/ 9.6476E-1, 9.6573E-1, 9.6668E-1, 9.6731E-1, 9.6786E-1,&
     & 9.6988E-1, 9.7270E-1, 9.7652E-1, 9.7744E-1, 9.7773E-1, 9.7777E-1,&
     & 9.7780E-1, 1.2886E+0, 1.1748E+0, 1.1140E+0, 1.0378E+0, 9.9393E-1,&
     & 9.7075E-1, 9.6541E-1, 9.6311E-1, 9.6285E-1, 9.6345E-1, 9.6406E-1,&
     & 9.6496E-1, 9.6555E-1, 9.6600E-1, 9.6780E-1, 9.7031E-1, 9.7366E-1,&
     & 9.7438E-1, 9.7455E-1, 9.7454E-1, 9.7456E-1, 1.0068E+0, 9.8817E-1,&
     & 9.7824E-1, 9.6654E-1, 9.6101E-1, 9.5924E-1, 9.5938E-1, 9.6000E-1,&
     & 9.6069E-1, 9.6142E-1, 9.6198E-1, 9.6284E-1, 9.6340E-1, 9.6376E-1,&
     & 9.6536E-1, 9.6758E-1, 9.7046E-1, 9.7097E-1, 9.7099E-1, 9.7095E-1,&
     & 9.7095E-1, 9.1005E-1, 9.2473E-1, 9.3280E-1, 9.4359E-1, 9.5054E-1,&
     & 9.5498E-1, 9.5644E-1, 9.5749E-1, 9.5806E-1, 9.5871E-1, 9.5923E-1,&
     & 9.6005E-1, 9.6058E-1, 9.6085E-1, 9.6226E-1, 9.6420E-1, 9.6657E-1,&
     & 9.6683E-1, 9.6668E-1, 9.6659E-1, 9.6656E-1, 8.7854E-1, 9.0430E-1,&
     & 9.1795E-1, 9.3558E-1, 9.4603E-1, 9.5191E-1, 9.5350E-1, 9.5440E-1,&
     & 9.5488E-1, 9.5545E-1, 9.5594E-1, 9.5672E-1, 9.5723E-1, 9.5743E-1,&
     & 9.5868E-1, 9.6037E-1, 9.6221E-1, 9.6221E-1, 9.6187E-1, 9.6172E-1,&
     & 9.6167E-1, 8.9134E-1, 9.1017E-1, 9.2025E-1, 9.3333E-1/           
      DATA X1201/ 9.4128E-1, 9.4598E-1, 9.4734E-1, 9.4805E-1, 9.4841E-1,&
     & 9.4889E-1, 9.4934E-1, 9.5008E-1, 9.5056E-1, 9.5066E-1, 9.5167E-1,&
     & 9.5294E-1, 9.5385E-1, 9.5334E-1, 9.5264E-1, 9.5240E-1, 9.5230E-1,&
     & 9.0442E-1, 9.1489E-1, 9.2085E-1, 9.2928E-1, 9.3522E-1, 9.3958E-1,&
     & 9.4078E-1, 9.4134E-1, 9.4160E-1, 9.4200E-1, 9.4241E-1, 9.4311E-1,&
     & 9.4356E-1, 9.4356E-1, 9.4433E-1, 9.4515E-1, 9.4496E-1, 9.4382E-1,&
     & 9.4268E-1, 9.4231E-1, 9.4216E-1, 8.8948E-1, 9.0693E-1, 9.1591E-1,&
     & 9.2688E-1, 9.3269E-1, 9.3673E-1, 9.3775E-1, 9.3813E-1, 9.3826E-1,&
     & 9.3856E-1, 9.3892E-1, 9.3959E-1, 9.4000E-1, 9.3988E-1, 9.4035E-1,&
     & 9.4060E-1, 9.3901E-1, 9.3707E-1, 9.3532E-1, 9.3475E-1, 9.3448E-1,&
     & 8.8366E-1, 9.0869E-1, 9.2023E-1, 9.3154E-1, 9.3717E-1, 9.4094E-1,&
     & 9.4182E-1, 9.4205E-1, 9.4209E-1, 9.4232E-1, 9.4265E-1, 9.4328E-1,&
     & 9.4367E-1, 9.4346E-1, 9.4370E-1, 9.4352E-1, 9.4088E-1, 9.3831E-1,&
     & 9.3604E-1, 9.3527E-1, 9.3484E-1, 9.4589E-1, 9.7086E-1, 9.8330E-1,&
     & 9.9422E-1, 9.9877E-1, 1.0015E+0, 1.0018E+0, 1.0015E+0, 1.0012E+0,&
     & 1.0012E+0, 1.0014E+0, 1.0019E+0, 1.0022E+0, 1.0017E+0, 1.0012E+0,&
     & 9.9953E-1, 9.9308E-1, 9.8793E-1, 9.8307E-1, 9.8107E-1/           
      DATA X1301/ 9.7952E-1, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 9.9997E-1,&
     & 9.9998E-1, 9.9998E-1, 9.9999E-1, 9.9999E-1, 9.9999E-1, 9.9999E-1,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 9.9999E-1, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 9.9998E-1, 9.9999E-1, 9.9999E-1, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 9.9946E-1,&
     & 9.9963E-1, 9.9972E-1, 9.9981E-1, 9.9986E-1, 9.9989E-1, 9.9990E-1,&
     & 9.9990E-1, 9.9991E-1, 9.9991E-1, 9.9992E-1, 9.9992E-1, 9.9992E-1,&
     & 9.9992E-1, 9.9993E-1, 9.9995E-1, 9.9997E-1, 9.9997E-1, 9.9998E-1,&
     & 9.9998E-1, 9.9997E-1, 9.9820E-1, 9.9872E-1, 9.9898E-1, 9.9931E-1,&
     & 9.9948E-1, 9.9959E-1, 9.9963E-1, 9.9966E-1, 9.9968E-1, 9.9969E-1,&
     & 9.9970E-1, 9.9971E-1, 9.9971E-1, 9.9972E-1, 9.9976E-1/           
      DATA X1401/ 9.9980E-1, 9.9988E-1, 9.9990E-1, 9.9991E-1, 9.9991E-1,&
     & 9.9990E-1, 9.9264E-1, 9.9447E-1, 9.9547E-1, 9.9678E-1, 9.9760E-1,&
     & 9.9810E-1, 9.9828E-1, 9.9842E-1, 9.9850E-1, 9.9857E-1, 9.9860E-1,&
     & 9.9863E-1, 9.9866E-1, 9.9872E-1, 9.9887E-1, 9.9910E-1, 9.9946E-1,&
     & 9.9957E-1, 9.9960E-1, 9.9958E-1, 9.9955E-1, 9.7743E-1, 9.8268E-1,&
     & 9.8555E-1, 9.8942E-1, 9.9199E-1, 9.9370E-1, 9.9430E-1, 9.9476E-1,&
     & 9.9505E-1, 9.9526E-1, 9.9537E-1, 9.9549E-1, 9.9557E-1, 9.9578E-1,&
     & 9.9628E-1, 9.9703E-1, 9.9822E-1, 9.9856E-1, 9.9862E-1, 9.9857E-1,&
     & 9.9847E-1, 9.5146E-1, 9.6214E-1, 9.6806E-1, 9.7632E-1, 9.8188E-1,&
     & 9.8574E-1, 9.8713E-1, 9.8821E-1, 9.8887E-1, 9.8937E-1, 9.8962E-1,&
     & 9.8988E-1, 9.9007E-1, 9.9055E-1, 9.9169E-1, 9.9338E-1, 9.9597E-1,&
     & 9.9669E-1, 9.9677E-1, 9.9661E-1, 9.9639E-1, 9.3372E-1, 9.4777E-1,&
     & 9.5575E-1, 9.6683E-1, 9.7443E-1, 9.7981E-1, 9.8178E-1, 9.8334E-1,&
     & 9.8429E-1, 9.8500E-1, 9.8536E-1, 9.8574E-1, 9.8600E-1, 9.8669E-1,&
     & 9.8832E-1, 9.9070E-1, 9.9429E-1, 9.9524E-1, 9.9529E-1, 9.9505E-1,&
     & 9.9472E-1, 9.1309E-1, 9.3163E-1, 9.4168E-1, 9.5584E-1, 9.6579E-1,&
     & 9.7290E-1, 9.7554E-1, 9.7764E-1, 9.7893E-1, 9.7991E-1/           
      DATA X1501/ 9.8040E-1, 9.8091E-1, 9.8127E-1, 9.8220E-1, 9.8440E-1,&
     & 9.8759E-1, 9.9230E-1, 9.9348E-1, 9.9346E-1, 9.9310E-1, 9.9264E-1,&
     & 8.9038E-1, 9.1235E-1, 9.2554E-1, 9.4360E-1, 9.5630E-1, 9.6547E-1,&
     & 9.6887E-1, 9.7157E-1, 9.7322E-1, 9.7449E-1, 9.7511E-1, 9.7577E-1,&
     & 9.7623E-1, 9.7743E-1, 9.8023E-1, 9.8427E-1, 9.9012E-1, 9.9148E-1,&
     & 9.9134E-1, 9.9085E-1, 9.9022E-1, 8.6572E-1, 8.9404E-1, 9.0967E-1,&
     & 9.3091E-1, 9.4621E-1, 9.5703E-1, 9.6121E-1, 9.6457E-1, 9.6662E-1,&
     & 9.6820E-1, 9.6898E-1, 9.6981E-1, 9.7039E-1, 9.7190E-1, 9.7539E-1,&
     & 9.8039E-1, 9.8745E-1, 9.8896E-1, 9.8860E-1, 9.8792E-1, 9.8709E-1,&
     & 8.4912E-1, 8.7866E-1, 8.9697E-1, 9.2114E-1, 9.3896E-1, 9.5134E-1,&
     & 9.5610E-1, 9.5992E-1, 9.6228E-1, 9.6407E-1, 9.6497E-1, 9.6591E-1,&
     & 9.6656E-1, 9.6826E-1, 9.7220E-1, 9.7780E-1, 9.8557E-1, 9.8713E-1,&
     & 9.8658E-1, 9.8575E-1, 9.8477E-1, 8.3511E-1, 8.6688E-1, 8.8512E-1,&
     & 9.1098E-1, 9.2936E-1, 9.4295E-1, 9.4814E-1, 9.5240E-1, 9.5505E-1,&
     & 9.5710E-1, 9.5813E-1, 9.5922E-1, 9.6000E-1, 9.6201E-1, 9.6665E-1,&
     & 9.7319E-1, 9.8199E-1, 9.8349E-1, 9.8251E-1, 9.8138E-1, 9.8011E-1,&
     & 8.0693E-1, 8.4396E-1, 8.6522E-1, 8.9532E-1, 9.1668E-1/           
      DATA X1601/ 9.3244E-1, 9.3845E-1, 9.4336E-1, 9.4642E-1, 9.4878E-1,&
     & 9.4997E-1, 9.5122E-1, 9.5211E-1, 9.5441E-1, 9.5971E-1, 9.6708E-1,&
     & 9.7651E-1, 9.7761E-1, 9.7578E-1, 9.7418E-1, 9.7245E-1, 9.5850E-1,&
     & 9.4664E-1, 9.4119E-1, 9.3565E-1, 9.3418E-1, 9.3527E-1, 9.3647E-1,&
     & 9.3794E-1, 9.3913E-1, 9.4024E-1, 9.4086E-1, 9.4159E-1, 9.4214E-1,&
     & 9.4375E-1, 9.4892E-1, 9.5590E-1, 9.6345E-1, 9.6264E-1, 9.5859E-1,&
     & 9.5593E-1, 9.5331E-1, 9.7264E-1, 9.5595E-1, 9.4780E-1, 9.3846E-1,&
     & 9.3431E-1, 9.3342E-1, 9.3385E-1, 9.3470E-1, 9.3550E-1, 9.3631E-1,&
     & 9.3678E-1, 9.3734E-1, 9.3778E-1, 9.3911E-1, 9.4360E-1, 9.4951E-1,&
     & 9.5477E-1, 9.5255E-1, 9.4722E-1, 9.4404E-1, 9.4103E-1,-5.7153E-1,&
     &-9.4238E-2, 1.6333E-1, 5.0215E-1, 7.1243E-1, 8.4065E-1, 8.8006E-1,&
     & 9.0639E-1, 9.1937E-1, 9.2717E-1, 9.3021E-1, 9.3270E-1, 9.3396E-1,&
     & 9.3499E-1, 9.3881E-1, 9.4367E-1, 9.4681E-1, 9.4343E-1, 9.3716E-1,&
     & 9.3364E-1, 9.3039E-1, 5.1318E-1, 6.3647E-1, 7.0410E-1, 7.9443E-1,&
     & 8.5425E-1, 8.9346E-1, 9.0685E-1, 9.1675E-1, 9.2236E-1, 9.2629E-1,&
     & 9.2812E-1, 9.2993E-1, 9.3112E-1, 9.3196E-1, 9.3533E-1, 9.3949E-1,&
     & 9.4125E-1, 9.3716E-1, 9.3036E-1, 9.2667E-1, 9.2333E-1/           
      DATA X1701/ 1.5955E+0, 1.3604E+0, 1.2356E+0, 1.0781E+0, 9.8721E-1,&
     & 9.3878E-1, 9.2728E-1, 9.2201E-1, 9.2112E-1, 9.2203E-1, 9.2311E-1,&
     & 9.2478E-1, 9.2586E-1, 9.2641E-1, 9.2909E-1, 9.3219E-1, 9.3190E-1,&
     & 9.2680E-1, 9.1932E-1, 9.1546E-1, 9.1205E-1, 1.0161E+0, 9.7650E-1,&
     & 9.5589E-1, 9.3105E-1, 9.1840E-1, 9.1336E-1, 9.1298E-1, 9.1362E-1,&
     & 9.1456E-1, 9.1566E-1, 9.1661E-1, 9.1813E-1, 9.1911E-1, 9.1939E-1,&
     & 9.2142E-1, 9.2349E-1, 9.2127E-1, 9.1530E-1, 9.0736E-1, 9.0344E-1,&
     & 9.0006E-1, 8.2530E-1, 8.5135E-1, 8.6548E-1, 8.8391E-1, 8.9525E-1,&
     & 9.0202E-1, 9.0404E-1, 9.0534E-1, 9.0595E-1, 9.0679E-1, 9.0760E-1,&
     & 9.0898E-1, 9.0987E-1, 9.0989E-1, 9.1129E-1, 9.1239E-1, 9.0836E-1,&
     & 9.0170E-1, 8.9355E-1, 8.8970E-1, 8.8650E-1, 7.6591E-1, 8.1151E-1,&
     & 8.3543E-1, 8.6567E-1, 8.8292E-1, 8.9188E-1, 8.9394E-1, 8.9480E-1,&
     & 8.9515E-1, 8.9578E-1, 8.9648E-1, 8.9774E-1, 8.9854E-1, 8.9836E-1,&
     & 8.9925E-1, 8.9955E-1, 8.9416E-1, 8.8713E-1, 8.7912E-1, 8.7553E-1,&
     & 8.7265E-1, 7.8629E-1, 8.1656E-1, 8.3251E-1, 8.5269E-1, 8.6431E-1,&
     & 8.7047E-1, 8.7195E-1, 8.7237E-1, 8.7245E-1, 8.7285E-1, 8.7343E-1,&
     & 8.7453E-1, 8.7521E-1, 8.7483E-1, 8.7518E-1, 8.7465E-1/           
      DATA X1801/ 8.6818E-1, 8.6137E-1, 8.5441E-1, 8.5158E-1, 8.4949E-1,&
     & 7.9534E-1, 8.1089E-1, 8.1957E-1, 8.3149E-1, 8.3950E-1, 8.4504E-1,&
     & 8.4630E-1, 8.4659E-1, 8.4659E-1, 8.4691E-1, 8.4741E-1, 8.4838E-1,&
     & 8.4898E-1, 8.4857E-1, 8.4873E-1, 8.4797E-1, 8.4189E-1, 8.3623E-1,&
     & 8.3107E-1, 8.2926E-1, 8.2814E-1, 7.5353E-1, 7.7912E-1, 7.9220E-1,&
     & 8.0793E-1, 8.1597E-1, 8.2121E-1, 8.2239E-1, 8.2268E-1, 8.2270E-1,&
     & 8.2300E-1, 8.2344E-1, 8.2430E-1, 8.2483E-1, 8.2448E-1, 8.2462E-1,&
     & 8.2399E-1, 8.1911E-1, 8.1496E-1, 8.1172E-1, 8.1089E-1, 8.1068E-1,&
     & 7.3004E-1, 7.6531E-1, 7.8157E-1, 7.9746E-1, 8.0531E-1, 8.1030E-1,&
     & 8.1142E-1, 8.1171E-1, 8.1174E-1, 8.1202E-1, 8.1243E-1, 8.1322E-1,&
     & 8.1371E-1, 8.1339E-1, 8.1354E-1, 8.1299E-1, 8.0878E-1, 8.0540E-1,&
     & 8.0309E-1, 8.0271E-1, 8.0290E-1, 7.2101E-1, 7.5505E-1, 7.7090E-1,&
     & 7.8595E-1, 7.9307E-1, 7.9744E-1, 7.9841E-1, 7.9864E-1, 7.9865E-1,&
     & 7.9888E-1, 7.9923E-1, 7.9991E-1, 8.0033E-1, 8.0004E-1, 8.0014E-1,&
     & 7.9963E-1, 7.9622E-1, 7.9378E-1, 7.9256E-1, 7.9271E-1, 7.9334E-1,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0/           
      DATA X1901/ 1.0000E+0, 1.0000E+0, 1.0000E+0, 9.9999E-1, 1.0000E+0,&
     & 9.9996E-1, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0007E+0,&
     & 1.0004E+0, 1.0003E+0, 1.0002E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0,&
     & 1.0001E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0,&
     & 1.0001E+0, 1.0000E+0, 1.0000E+0, 9.9998E-1, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0004E+0, 1.0002E+0, 1.0002E+0, 1.0001E+0,&
     & 1.0001E+0, 1.0001E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 9.9997E-1, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0123E+0,&
     & 1.0077E+0, 1.0056E+0, 1.0035E+0, 1.0024E+0, 1.0018E+0, 1.0016E+0,&
     & 1.0014E+0, 1.0013E+0, 1.0012E+0, 1.0012E+0, 1.0012E+0, 1.0011E+0,&
     & 1.0011E+0, 1.0009E+0, 1.0006E+0, 1.0002E+0, 1.0001E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0395E+0, 1.0267E+0, 1.0201E+0, 1.0124E+0,&
     & 1.0086E+0, 1.0064E+0, 1.0056E+0, 1.0050E+0, 1.0047E+0, 1.0044E+0,&
     & 1.0043E+0, 1.0041E+0, 1.0040E+0, 1.0038E+0, 1.0032E+0, 1.0023E+0,&
     & 1.0009E+0, 1.0004E+0, 1.0001E+0, 1.0001E+0, 1.0000E+0, 1.1564E+0,&
     & 1.1122E+0, 1.0887E+0, 1.0583E+0, 1.0400E+0, 1.0295E+0/           
      DATA X2001/ 1.0260E+0, 1.0233E+0, 1.0216E+0, 1.0204E+0, 1.0198E+0,&
     & 1.0191E+0, 1.0186E+0, 1.0175E+0, 1.0146E+0, 1.0105E+0, 1.0041E+0,&
     & 1.0019E+0, 1.0007E+0, 1.0004E+0, 1.0002E+0, 1.4675E+0, 1.3469E+0,&
     & 1.2809E+0, 1.1924E+0, 1.1356E+0, 1.0988E+0, 1.0866E+0, 1.0773E+0,&
     & 1.0717E+0, 1.0674E+0, 1.0653E+0, 1.0631E+0, 1.0616E+0, 1.0575E+0,&
     & 1.0481E+0, 1.0344E+0, 1.0131E+0, 1.0059E+0, 1.0021E+0, 1.0011E+0,&
     & 1.0005E+0, 1.9980E+0, 1.7531E+0, 1.6174E+0, 1.4323E+0, 1.3095E+0,&
     & 1.2262E+0, 1.1970E+0, 1.1749E+0, 1.1617E+0, 1.1517E+0, 1.1468E+0,&
     & 1.1416E+0, 1.1379E+0, 1.1285E+0, 1.1067E+0, 1.0754E+0, 1.0279E+0,&
     & 1.0122E+0, 1.0041E+0, 1.0021E+0, 1.0010E+0, 2.3530E+0, 2.0312E+0,&
     & 1.8516E+0, 1.6042E+0, 1.4374E+0, 1.3214E+0, 1.2798E+0, 1.2475E+0,&
     & 1.2283E+0, 1.2139E+0, 1.2068E+0, 1.1993E+0, 1.1940E+0, 1.1805E+0,&
     & 1.1492E+0, 1.1045E+0, 1.0379E+0, 1.0163E+0, 1.0053E+0, 1.0026E+0,&
     & 1.0011E+0, 2.7549E+0, 2.3469E+0, 2.1182E+0, 1.8006E+0, 1.5841E+0,&
     & 1.4314E+0, 1.3756E+0, 1.3318E+0, 1.3054E+0, 1.2856E+0, 1.2758E+0,&
     & 1.2656E+0, 1.2584E+0, 1.2400E+0, 1.1974E+0, 1.1372E+0, 1.0487E+0,&
     & 1.0204E+0, 1.0064E+0, 1.0030E+0, 1.0011E+0, 3.1726E+0/           
      DATA X2101/ 2.6736E+0, 2.3943E+0, 2.0039E+0, 1.7362E+0, 1.5454E+0,&
     & 1.4750E+0, 1.4193E+0, 1.3855E+0, 1.3600E+0, 1.3474E+0, 1.3342E+0,&
     & 1.3250E+0, 1.3013E+0, 1.2468E+0, 1.1702E+0, 1.0591E+0, 1.0242E+0,&
     & 1.0071E+0, 1.0031E+0, 1.0010E+0, 3.6482E+0, 3.0457E+0, 2.7065E+0,&
     & 2.2332E+0, 1.9060E+0, 1.6718E+0, 1.5850E+0, 1.5160E+0, 1.4740E+0,&
     & 1.4420E+0, 1.4262E+0, 1.4097E+0, 1.3982E+0, 1.3685E+0, 1.3006E+0,&
     & 1.2057E+0, 1.0697E+0, 1.0277E+0, 1.0076E+0, 1.0029E+0, 1.0005E+0,&
     & 3.9028E+0, 3.2505E+0, 2.8811E+0, 2.3633E+0, 2.0051E+0, 1.7477E+0,&
     & 1.6515E+0, 1.5748E+0, 1.5279E+0, 1.4921E+0, 1.4744E+0, 1.4558E+0,&
     & 1.4428E+0, 1.4095E+0, 1.3333E+0, 1.2271E+0, 1.0758E+0, 1.0295E+0,&
     & 1.0076E+0, 1.0026E+0, 1.0001E+0, 4.0276E+0, 3.3786E+0, 3.0093E+0,&
     & 2.4861E+0, 2.1174E+0, 1.8459E+0, 1.7425E+0, 1.6586E+0, 1.6065E+0,&
     & 1.5663E+0, 1.5461E+0, 1.5248E+0, 1.5098E+0, 1.4709E+0, 1.3820E+0,&
     & 1.2587E+0, 1.0843E+0, 1.0316E+0, 1.0070E+0, 1.0017E+0, 9.9903E-1,&
     & 4.3744E+0, 3.6497E+0, 3.2372E+0, 2.6531E+0, 2.2415E+0, 1.9385E+0,&
     & 1.8231E+0, 1.7296E+0, 1.6714E+0, 1.6265E+0, 1.6041E+0, 1.5802E+0,&
     & 1.5635E+0, 1.5201E+0, 1.4211E+0, 1.2837E+0, 1.0897E+0/           
      DATA X2201/ 1.0314E+0, 1.0050E+0, 9.9943E-1, 9.9692E-1, 4.0737E+0,&
     & 3.4208E+0, 3.0489E+0, 2.5210E+0, 2.1480E+0, 1.8724E+0, 1.7671E+0,&
     & 1.6816E+0, 1.6283E+0, 1.5870E+0, 1.5663E+0, 1.5444E+0, 1.5290E+0,&
     & 1.4889E+0, 1.3967E+0, 1.2670E+0, 1.0789E+0, 1.0216E+0, 9.9675E-1,&
     & 9.9233E-1, 9.9094E-1, 3.5966E+0, 3.0530E+0, 2.7426E+0, 2.3014E+0,&
     & 1.9884E+0, 1.7561E+0, 1.6671E+0, 1.5944E+0, 1.5490E+0, 1.5139E+0,&
     & 1.4962E+0, 1.4774E+0, 1.4642E+0, 1.4297E+0, 1.3498E+0, 1.2355E+0,&
     & 1.0651E+0, 1.0125E+0, 9.9057E-1, 9.8732E-1, 9.8690E-1, 3.3389E+0,&
     & 2.8408E+0, 2.5574E+0, 2.1555E+0, 1.8729E+0, 1.6645E+0, 1.5852E+0,&
     & 1.5210E+0, 1.4811E+0, 1.4504E+0, 1.4350E+0, 1.4186E+0, 1.4072E+0,&
     & 1.3775E+0, 1.3080E+0, 1.2069E+0, 1.0522E+0, 1.0040E+0, 9.8495E-1,&
     & 9.8283E-1, 9.8333E-1, 3.1299E+0, 2.6760E+0, 2.4177E+0, 2.0513E+0,&
     & 1.7937E+0, 1.6050E+0, 1.5332E+0, 1.4750E+0, 1.4390E+0, 1.4111E+0,&
     & 1.3972E+0, 1.3824E+0, 1.3721E+0, 1.3452E+0, 1.2818E+0, 1.1886E+0,&
     & 1.0434E+0, 9.9815E-1, 9.8111E-1, 9.7978E-1, 9.8091E-1, 2.7910E+0,&
     & 2.4121E+0, 2.1973E+0, 1.8936E+0, 1.6783E+0, 1.5195E+0, 1.4590E+0,&
     & 1.4098E+0, 1.3792E+0, 1.3555E+0, 1.3437E+0, 1.3311E+0/           
      DATA X2301/ 1.3222E+0, 1.2991E+0, 1.2440E+0, 1.1613E+0, 1.0294E+0,&
     & 9.8859E-1, 9.7480E-1, 9.7477E-1, 9.7696E-1, 2.5295E+0, 2.2083E+0,&
     & 2.0254E+0, 1.7653E+0, 1.5818E+0, 1.4464E+0, 1.3947E+0, 1.3526E+0,&
     & 1.3265E+0, 1.3063E+0, 1.2961E+0, 1.2853E+0, 1.2776E+0, 1.2575E+0,&
     & 1.2091E+0, 1.1350E+0, 1.0146E+0, 9.7810E-1, 9.6781E-1, 9.6925E-1,&
     & 9.7263E-1, 2.2627E+0, 2.0039E+0, 1.8555E+0, 1.6439E+0, 1.4929E+0,&
     & 1.3801E+0, 1.3365E+0, 1.3008E+0, 1.2784E+0, 1.2609E+0, 1.2521E+0,&
     & 1.2426E+0, 1.2359E+0, 1.2182E+0, 1.1750E+0, 1.1078E+0, 9.9747E-1,&
     & 9.6566E-1, 9.5949E-1, 9.6267E-1, 9.6748E-1, 2.0510E+0, 1.8440E+0,&
     & 1.7242E+0, 1.5511E+0, 1.4251E+0, 1.3287E+0, 1.2907E+0, 1.2591E+0,&
     & 1.2390E+0, 1.2232E+0, 1.2151E+0, 1.2065E+0, 1.2004E+0, 1.1842E+0,&
     & 1.1443E+0, 1.0816E+0, 9.7924E-1, 9.5207E-1, 9.5035E-1, 9.5547E-1,&
     & 9.6186E-1,-1.5139E+0,-1.6266E-1, 4.7979E-1, 1.1530E+0, 1.3679E+0,&
     & 1.2881E+0, 1.1720E+0, 1.0802E+0, 1.1073E+0, 1.2830E+0, 1.3600E+0,&
     & 2.0718E+0, 4.7409E-1, 1.1340E+0, 1.0963E+0, 1.0373E+0, 9.4522E-1,&
     & 9.2629E-1, 9.3303E-1, 9.4187E-1, 9.5129E-1, 7.2639E-1, 1.0606E+0,&
     & 1.2067E+0, 1.3312E+0, 1.3284E+0, 1.2435E+0, 1.1257E+0/           
      DATA X2401/ 1.0327E+0, 1.0592E+0, 1.2344E+0, 1.3113E+0, 2.0229E+0,&
     & 4.2511E-1, 1.0848E+0, 1.0469E+0, 9.8898E-1, 9.0625E-1, 8.9672E-1,&
     & 9.1334E-1, 9.2649E-1, 9.3940E-1, 2.2041E+0, 1.7326E+0, 1.5197E+0,&
     & 1.3216E+0, 1.2957E+0, 1.1987E+0, 1.0775E+0, 9.8224E-1, 1.0075E+0,&
     & 1.1820E+0, 1.2585E+0, 1.9698E+0, 3.7173E-1, 1.0310E+0, 9.9241E-1,&
     & 9.3548E-1, 8.6356E-1, 8.6473E-1, 8.9231E-1, 9.1016E-1, 9.2684E-1,&
     & 1.7221E+0, 1.6394E+0, 1.5429E+0, 1.3146E+0, 1.2743E+0, 1.1705E+0,&
     & 1.0475E+0, 9.5109E-1, 9.7578E-1, 1.1499E+0, 1.2263E+0, 1.9374E+0,&
     & 3.3924E-1, 9.9829E-1, 9.5964E-1, 9.0374E-1, 8.3886E-1, 8.4645E-1,&
     & 8.8041E-1, 9.0096E-1, 9.1979E-1, 1.5052E+0, 1.7054E+0, 1.5687E+0,&
     & 1.2944E+0, 1.2338E+0, 1.1211E+0, 9.9580E-1, 8.9811E-1, 9.2223E-1,&
     & 1.0960E+0, 1.1723E+0, 1.8833E+0, 2.8508E-1, 9.4409E-1, 9.0588E-1,&
     & 8.5245E-1, 7.9994E-1, 8.1797E-1, 8.6203E-1, 8.8680E-1, 9.0897E-1,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0006E+0, 1.0004E+0/           
      DATA X2501/ 1.0003E+0, 1.0002E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0,&
     & 1.0001E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0, 1.0001E+0,&
     & 1.0001E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0004E+0, 1.0002E+0, 1.0001E+0, 1.0001E+0,&
     & 1.0001E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0116E+0,&
     & 1.0069E+0, 1.0048E+0, 1.0028E+0, 1.0020E+0, 1.0015E+0, 1.0013E+0,&
     & 1.0012E+0, 1.0011E+0, 1.0010E+0, 1.0010E+0, 1.0010E+0, 1.0010E+0,&
     & 1.0009E+0, 1.0008E+0, 1.0006E+0, 1.0003E+0, 1.0002E+0, 1.0001E+0,&
     & 1.0001E+0, 1.0001E+0, 1.0361E+0, 1.0237E+0, 1.0175E+0, 1.0104E+0,&
     & 1.0071E+0, 1.0053E+0, 1.0047E+0, 1.0042E+0, 1.0039E+0, 1.0037E+0,&
     & 1.0036E+0, 1.0035E+0, 1.0034E+0, 1.0032E+0, 1.0028E+0, 1.0021E+0,&
     & 1.0010E+0, 1.0006E+0, 1.0004E+0, 1.0003E+0, 1.0002E+0, 1.1524E+0,&
     & 1.1071E+0, 1.0831E+0, 1.0527E+0, 1.0351E+0, 1.0257E+0, 1.0226E+0,&
     & 1.0203E+0, 1.0189E+0, 1.0178E+0, 1.0173E+0, 1.0168E+0, 1.0164E+0,&
     & 1.0154E+0, 1.0131E+0, 1.0098E+0, 1.0046E+0, 1.0027E+0/           
      DATA X2601/ 1.0016E+0, 1.0013E+0, 1.0010E+0, 1.6114E+0, 1.4375E+0,&
     & 1.3439E+0, 1.2212E+0, 1.1457E+0, 1.1002E+0, 1.0864E+0, 1.0763E+0,&
     & 1.0705E+0, 1.0661E+0, 1.0639E+0, 1.0617E+0, 1.0601E+0, 1.0561E+0,&
     & 1.0469E+0, 1.0341E+0, 1.0154E+0, 1.0090E+0, 1.0053E+0, 1.0041E+0,&
     & 1.0033E+0, 3.4429E+0, 2.7280E+0, 2.3416E+0, 1.8330E+0, 1.5168E+0,&
     & 1.3228E+0, 1.2628E+0, 1.2226E+0, 1.2005E+0, 1.1847E+0, 1.1771E+0,&
     & 1.1693E+0, 1.1640E+0, 1.1505E+0, 1.1212E+0, 1.0834E+0, 1.0345E+0,&
     & 1.0196E+0, 1.0114E+0, 1.0089E+0, 1.0071E+0, 6.4163E+0, 4.8122E+0,&
     & 3.9429E+0, 2.7946E+0, 2.0756E+0, 1.6292E+0, 1.4892E+0, 1.3936E+0,&
     & 1.3448E+0, 1.3114E+0, 1.2958E+0, 1.2801E+0, 1.2694E+0, 1.2432E+0,&
     & 1.1888E+0, 1.1238E+0, 1.0477E+0, 1.0266E+0, 1.0154E+0, 1.0121E+0,&
     & 1.0098E+0, 1.4220E+1, 1.0234E+1, 8.0740E+0, 5.2182E+0, 3.4283E+0,&
     & 2.3151E+0, 1.9650E+0, 1.7255E+0, 1.6030E+0, 1.5257E+0, 1.4915E+0,&
     & 1.4578E+0, 1.4356E+0, 1.3829E+0, 1.2816E+0, 1.1731E+0, 1.0616E+0,&
     & 1.0337E+0, 1.0196E+0, 1.0155E+0, 1.0127E+0, 3.6870E+1, 2.5825E+1,&
     & 1.9849E+1, 1.1965E+1, 7.0441E+0, 4.0039E+0, 3.0565E+0, 2.4147E+0,&
     & 2.0907E+0, 1.8901E+0, 1.8089E+0, 1.7334E+0, 1.6857E+0/           
      DATA X2701/ 1.5787E+0, 1.3946E+0, 1.2244E+0, 1.0740E+0, 1.0401E+0,&
     & 1.0238E+0, 1.0191E+0, 1.0158E+0, 1.3060E+2, 8.9885E+1, 6.7893E+1,&
     & 3.8984E+1, 2.1051E+1, 1.0090E+1, 6.7246E+0, 4.4818E+0, 3.3759E+0,&
     & 2.7127E+0, 2.4546E+0, 2.2432E+0, 2.1219E+0, 1.8779E+0, 1.5323E+0,&
     & 1.2749E+0, 1.0850E+0, 1.0465E+0, 1.0284E+0, 1.0232E+0, 1.0196E+0,&
     & 2.8502E+2, 1.9557E+2, 1.4725E+2, 8.3697E+1, 4.4257E+1, 2.0124E+1,&
     & 1.2704E+1, 7.7507E+0, 5.3024E+0, 3.8293E+0, 3.2536E+0, 2.7793E+0,&
     & 2.5391E+0, 2.1129E+0, 1.6116E+0, 1.2974E+0, 1.0902E+0, 1.0503E+0,&
     & 1.0316E+0, 1.0262E+0, 1.0225E+0, 2.3006E+2, 1.6238E+2, 1.2530E+2,&
     & 7.5541E+1, 4.3463E+1, 2.2596E+1, 1.5643E+1, 1.0599E+1, 7.8181E+0,&
     & 5.9047E+0, 5.0372E+0, 4.1941E+0, 3.6540E+0, 2.4865E+0, 1.6694E+0,&
     & 1.3055E+0, 1.0966E+0, 1.0570E+0, 1.0380E+0, 1.0324E+0, 1.0283E+0,&
     & 1.1771E+3, 8.2269E+2, 6.2919E+2, 3.7070E+2, 2.0547E+2, 9.9381E+1,&
     & 6.4604E+1, 3.9774E+1, 2.6343E+1, 1.7297E+1, 1.3280E+1, 9.4548E+0,&
     & 7.0632E+0, 2.1808E+0, 1.4973E+0, 1.2596E+0, 1.1038E+0, 1.0684E+0,&
     & 1.0493E+0, 1.0430E+0, 1.0383E+0, 7.9414E+2, 5.5518E+2, 4.2471E+2,&
     & 2.5040E+2, 1.3898E+2, 6.7432E+1, 4.3976E+1, 2.7226E+1/           
      DATA X2801/ 1.8165E+1, 1.2061E+1, 9.3501E+0, 6.7683E+0, 5.1538E+0,&
     & 1.8564E+0, 1.3800E+0, 1.2346E+0, 1.1333E+0, 1.1022E+0, 1.0806E+0,&
     & 1.0722E+0, 1.0655E+0, 1.5192E+2, 1.0723E+2, 8.2755E+1, 4.9934E+1,&
     & 2.8799E+1, 1.5075E+1, 1.0511E+1, 7.2082E+0, 5.3913E+0, 4.1445E+0,&
     & 3.5807E+0, 3.0340E+0, 2.6849E+0, 1.9350E+0, 1.4571E+0, 1.2688E+0,&
     & 1.1582E+0, 1.1262E+0, 1.1025E+0, 1.0928E+0, 1.0847E+0, 1.2480E+2,&
     & 8.6704E+1, 6.6027E+1, 3.8640E+1, 2.1410E+1, 1.0625E+1, 7.2043E+0,&
     & 4.8426E+0, 3.6191E+0, 2.8362E+0, 2.5069E+0, 2.2106E+0, 2.0385E+0,&
     & 1.7536E+0, 1.4548E+0, 1.2906E+0, 1.1811E+0, 1.1484E+0, 1.1229E+0,&
     & 1.1121E+0, 1.1030E+0, 8.1738E+1, 5.6653E+1, 4.3070E+1, 2.5155E+1,&
     & 1.3970E+1, 7.0588E+0, 4.9041E+0, 3.4435E+0, 2.7057E+0, 2.2486E+0,&
     & 2.0633E+0, 1.9036E+0, 1.8165E+0, 1.6512E+0, 1.4403E+0, 1.3012E+0,&
     & 1.1969E+0, 1.1640E+0, 1.1375E+0, 1.1259E+0, 1.1160E+0, 2.8621E+1,&
     & 2.0204E+1, 1.5640E+1, 9.6057E+0, 5.8203E+0, 3.4631E+0, 2.7206E+0,&
     & 2.2115E+0, 1.9503E+0, 1.7852E+0, 1.7167E+0, 1.6560E+0, 1.6192E+0,&
     & 1.5403E+0, 1.4171E+0, 1.3151E+0, 1.2228E+0, 1.1903E+0, 1.1623E+0,&
     & 1.1496E+0, 1.1385E+0, 1.6862E+1, 1.1951E+1, 9.3047E+0/           
      DATA X2901/ 5.8405E+0, 3.7075E+0, 2.4203E+0, 2.0324E+0, 1.7792E+0,&
     & 1.6583E+0, 1.5890E+0, 1.5598E+0, 1.5321E+0, 1.5144E+0, 1.4736E+0,&
     & 1.4007E+0, 1.3290E+0, 1.2517E+0, 1.2204E+0, 1.1911E+0, 1.1773E+0,&
     & 1.1650E+0, 7.9351E+0, 5.8439E+0, 4.7205E+0, 3.2547E+0, 2.3591E+0,&
     & 1.8257E+0, 1.6681E+0, 1.5676E+0, 1.5214E+0, 1.4914E+0, 1.4780E+0,&
     & 1.4646E+0, 1.4558E+0, 1.4345E+0, 1.3928E+0, 1.3460E+0, 1.2865E+0,&
     & 1.2575E+0, 1.2273E+0, 1.2121E+0, 1.1984E+0, 4.4463E+0, 3.4545E+0,&
     & 2.9245E+0, 2.2389E+0, 1.8268E+0, 1.5884E+0, 1.5211E+0, 1.4807E+0,&
     & 1.4600E+0, 1.4458E+0, 1.4392E+0, 1.4325E+0, 1.4280E+0, 1.4169E+0,&
     & 1.3939E+0, 1.3661E+0, 1.3252E+0, 1.2997E+0, 1.2688E+0, 1.2523E+0,&
     & 1.2372E+0, 3.0861E+0, 2.4222E+0, 2.0872E+0, 1.6930E+0, 1.5033E+0,&
     & 1.4443E+0, 1.4510E+0, 1.4594E+0, 1.4431E+0, 1.3953E+0, 1.3767E+0,&
     & 1.2731E+0, 1.6878E+0, 1.4155E+0, 1.4120E+0, 1.4091E+0, 1.4011E+0,&
     & 1.3833E+0, 1.3522E+0, 1.3337E+0, 1.3160E+0, 1.9051E+0, 1.6789E+0,&
     & 1.5692E+0, 1.4494E+0, 1.4040E+0, 1.4064E+0, 1.4319E+0, 1.4558E+0,&
     & 1.4467E+0, 1.4003E+0, 1.3827E+0, 1.2734E+0, 1.7595E+0, 1.4374E+0,&
     & 1.4478E+0, 1.4660E+0, 1.4922E+0, 1.4840E+0, 1.4534E+0/           
      DATA X3001/ 1.4329E+0, 1.4127E+0, 1.3610E+0, 1.3598E+0, 1.3607E+0,&
     & 1.3649E+0, 1.3711E+0, 1.4029E+0, 1.4412E+0, 1.4768E+0, 1.4722E+0,&
     & 1.4237E+0, 1.4058E+0, 1.2862E+0, 1.8649E+0, 1.4758E+0, 1.4980E+0,&
     & 1.5354E+0, 1.5957E+0, 1.5975E+0, 1.5679E+0, 1.5455E+0, 1.5230E+0,&
     & 1.3971E+0, 1.3198E+0, 1.3054E+0, 1.3400E+0, 1.3644E+0, 1.4089E+0,&
     & 1.4535E+0, 1.4952E+0, 1.4926E+0, 1.4420E+0, 1.4235E+0, 1.2966E+0,&
     & 1.9362E+0, 1.5023E+0, 1.5305E+0, 1.5781E+0, 1.6570E+0, 1.6642E+0,&
     & 1.6351E+0, 1.6118E+0, 1.5880E+0, 1.2867E+0, 1.2334E+0, 1.2483E+0,&
     & 1.3154E+0, 1.3625E+0, 1.4242E+0, 1.4784E+0, 1.5294E+0, 1.5293E+0,&
     & 1.4745E+0, 1.4547E+0, 1.3154E+0, 2.0611E+0, 1.5475E+0, 1.5849E+0,&
     & 1.6478E+0, 1.7545E+0, 1.7698E+0, 1.7416E+0, 1.7171E+0, 1.6918E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 9.9959E-1, 9.9976E-1, 9.9984E-1,&
     & 9.9991E-1, 9.9994E-1, 9.9996E-1, 9.9996E-1, 9.9997E-1, 9.9997E-1,&
     & 9.9997E-1, 9.9997E-1, 9.9997E-1, 9.9997E-1, 9.9998E-1/           
      DATA X3101/ 9.9998E-1, 9.9999E-1, 1.0000E+0, 1.0000E+0, 1.0000E+0,&
     & 1.0000E+0, 1.0000E+0, 9.9976E-1, 9.9988E-1, 9.9992E-1, 9.9995E-1,&
     & 9.9997E-1, 9.9998E-1, 9.9998E-1, 9.9998E-1, 9.9999E-1, 9.9999E-1,&
     & 9.9999E-1, 9.9999E-1, 9.9999E-1, 9.9999E-1, 9.9999E-1, 9.9999E-1,&
     & 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 1.0000E+0, 9.9263E-1,&
     & 9.9573E-1, 9.9710E-1, 9.9833E-1, 9.9889E-1, 9.9921E-1, 9.9931E-1,&
     & 9.9939E-1, 9.9944E-1, 9.9948E-1, 9.9950E-1, 9.9952E-1, 9.9953E-1,&
     & 9.9957E-1, 9.9965E-1, 9.9977E-1, 9.9998E-1, 1.0001E+0, 1.0001E+0,&
     & 1.0002E+0, 1.0002E+0, 9.7773E-1, 9.8555E-1, 9.8945E-1, 9.9395E-1,&
     & 9.9600E-1, 9.9714E-1, 9.9752E-1, 9.9782E-1, 9.9799E-1, 9.9813E-1,&
     & 9.9819E-1, 9.9826E-1, 9.9831E-1, 9.9844E-1, 9.9874E-1, 9.9919E-1,&
     & 9.9994E-1, 1.0003E+0, 1.0005E+0, 1.0006E+0, 1.0006E+0, 9.1227E-1,&
     & 9.3859E-1, 9.5253E-1, 9.7031E-1, 9.8070E-1, 9.8637E-1, 9.8823E-1,&
     & 9.8966E-1, 9.9051E-1, 9.9115E-1, 9.9147E-1, 9.9181E-1, 9.9205E-1,&
     & 9.9267E-1, 9.9411E-1, 9.9625E-1, 9.9978E-1, 1.0013E+0, 1.0023E+0,&
     & 1.0027E+0, 1.0031E+0, 7.0021E-1, 7.8401E-1, 8.2943E-1, 8.8943E-1,&
     & 9.2705E-1, 9.5046E-1, 9.5782E-1, 9.6334E-1, 9.6660E-1/           
      DATA X3201/ 9.6905E-1, 9.7026E-1, 9.7153E-1, 9.7242E-1, 9.7471E-1,&
     & 9.8003E-1, 9.8767E-1, 9.9985E-1, 1.0047E+0, 1.0082E+0, 1.0096E+0,&
     & 1.0107E+0, 1.3759E-1, 3.7679E-1, 5.0746E-1, 6.8218E-1, 7.9401E-1,&
     & 8.6596E-1, 8.8960E-1, 9.0653E-1, 9.1623E-1, 9.2336E-1, 9.2684E-1,&
     & 9.3046E-1, 9.3297E-1, 9.3937E-1, 9.5378E-1, 9.7349E-1, 1.0023E+0,&
     & 1.0131E+0, 1.0206E+0, 1.0235E+0, 1.0258E+0,-4.7688E-1,-6.7566E-2,&
     & 1.5689E-1, 4.5851E-1, 6.5343E-1, 7.8067E-1, 8.2326E-1, 8.5428E-1,&
     & 8.7147E-1, 8.8385E-1, 8.8980E-1, 8.9595E-1, 9.0017E-1, 9.1082E-1,&
     & 9.3417E-1, 9.6469E-1, 1.0064E+0, 1.0211E+0, 1.0310E+0, 1.0348E+0,&
     & 1.0379E+0,-1.6006E+0,-8.7071E-1,-4.7052E-1, 6.7932E-2, 4.1664E-1,&
     & 6.4492E-1, 7.2159E-1, 7.7761E-1, 8.0878E-1, 8.3043E-1, 8.4060E-1,&
     & 8.5095E-1, 8.5799E-1, 8.7542E-1, 9.1214E-1, 9.5720E-1, 1.0135E+0,&
     & 1.0320E+0, 1.0443E+0, 1.0490E+0, 1.0528E+0,-3.7854E+0,-2.4109E+0,&
     &-1.6575E+0,-6.4777E-1, 2.8839E-3, 4.2546E-1, 5.6599E-1, 6.6774E-1,&
     & 7.2372E-1, 7.6215E-1, 7.7954E-1, 7.9681E-1, 8.0832E-1, 8.3609E-1,&
     & 8.9131E-1, 9.5362E-1, 1.0239E+0, 1.0454E+0, 1.0595E+0, 1.0649E+0,&
     & 1.0693E+0,-9.5000E+0,-6.3811E+0,-4.6804E+0,-2.4128E+0/           
      DATA X3301/-9.6802E-1,-4.5456E-2, 2.5504E-1, 4.6819E-1, 5.8253E-1,&
     & 6.5882E-1, 6.9238E-1, 7.2403E-1, 7.4427E-1, 7.9067E-1, 8.7414E-1,&
     & 9.5699E-1, 1.0393E+0, 1.0629E+0, 1.0784E+0, 1.0844E+0, 1.0894E+0,&
     &-1.6639E+1,-1.1327E+1,-8.4348E+0,-4.5874E+0,-2.1458E+0,-5.9671E-1,&
     &-9.6512E-2, 2.5528E-1, 4.4199E-1, 5.6501E-1, 6.1841E-1, 6.6813E-1,&
     & 6.9833E-1, 7.6369E-1, 8.7012E-1, 9.6471E-1, 1.0510E+0, 1.0753E+0,&
     & 1.0916E+0, 1.0979E+0, 1.1032E+0,-1.8401E+1,-1.2824E+1,-9.7542E+0,&
     &-5.6065E+0,-2.9003E+0,-1.1074E+0,-4.9681E-1,-4.4770E-2, 2.1050E-1,&
     & 3.9062E-1, 4.7425E-1, 5.5734E-1, 6.1192E-1, 7.3656E-1, 8.8692E-1,&
     & 9.8997E-1, 1.0736E+0, 1.0981E+0, 1.1156E+0, 1.1226E+0, 1.1285E+0,&
     &-7.7491E+1,-5.4014E+1,-4.1177E+1,-2.3994E+1,-1.2969E+1,-5.8505E+0,&
     &-3.4999E+0,-1.8098E+0,-8.8771E-1,-2.6059E-1, 2.0549E-2, 2.9082E-1,&
     & 4.6174E-1, 8.2041E-1, 9.6853E-1, 1.0372E+0, 1.1031E+0, 1.1286E+0,&
     & 1.1486E+0, 1.1570E+0, 1.1641E+0,-7.2119E+1,-5.0259E+1,-3.8304E+1,&
     &-2.2300E+1,-1.2029E+1,-5.3932E+0,-3.2010E+0,-1.6239E+0,-7.6283E-1,&
     &-1.7681E-1, 8.6090E-2, 3.3901E-1, 4.9909E-1, 8.3570E-1, 9.8130E-1,&
     & 1.0578E+0, 1.1432E+0, 1.1791E+0, 1.2082E+0, 1.2204E+0/           
      DATA X3401/ 1.2309E+0,-1.9586E+1,-1.3639E+1,-1.0367E+1,-5.9482E+0,&
     &-3.0686E+0,-1.1640E+0,-5.1664E-1,-3.8231E-2, 2.3138E-1, 4.2123E-1,&
     & 5.0919E-1, 5.9644E-1, 6.5363E-1, 7.8371E-1, 9.3577E-1, 1.0456E+0,&
     & 1.1568E+0, 1.1995E+0, 1.2336E+0, 1.2479E+0, 1.2601E+0,-1.5400E+1,&
     &-1.0541E+1,-7.8836E+0,-4.3263E+0,-2.0430E+0,-5.6778E-1,-8.0351E-2,&
     & 2.7041E-1, 4.6195E-1, 5.9234E-1, 6.5085E-1, 7.0715E-1, 7.4279E-1,&
     & 8.1778E-1, 9.3632E-1, 1.0443E+0, 1.1641E+0, 1.2106E+0, 1.2478E+0,&
     & 1.2636E+0, 1.2770E+0,-1.0966E+1,-7.4128E+0,-5.4714E+0,-2.8770E+0,&
     &-1.2150E+0,-1.4580E-1, 2.0586E-1, 4.5770E-1, 5.9443E-1, 6.8690E-1,&
     & 7.2814E-1, 7.6757E-1, 7.9234E-1, 8.4814E-1, 9.4658E-1, 1.0467E+0,&
     & 1.1665E+0, 1.2145E+0, 1.2533E+0, 1.2698E+0, 1.2838E+0,-5.1094E+0,&
     &-3.3372E+0,-2.3657E+0,-1.0581E+0,-2.1175E-1, 3.4242E-1, 5.2870E-1,&
     & 6.6488E-1, 7.4063E-1, 7.9328E-1, 8.1737E-1, 8.4100E-1, 8.5658E-1,&
     & 8.9380E-1, 9.6703E-1, 1.0518E+0, 1.1660E+0, 1.2149E+0, 1.2553E+0,&
     & 1.2726E+0, 1.2874E+0,-3.1521E+0,-1.9295E+0,-1.2616E+0,-3.6778E-1,&
     & 2.0552E-1, 5.7538E-1, 6.9737E-1, 7.8500E-1, 8.3275E-1, 8.6518E-1,&
     & 8.8027E-1, 8.9554E-1, 9.0588E-1, 9.3144E-1, 9.8544E-1/           
      DATA X3501/ 1.0544E+0, 1.1587E+0, 1.2068E+0, 1.2478E+0, 1.2656E+0,&
     & 1.2809E+0,-1.4185E+0,-7.1031E-1,-3.2291E-1, 1.9569E-1, 5.2848E-1,&
     & 7.4339E-1, 8.1438E-1, 8.6543E-1, 8.9329E-1, 9.1328E-1, 9.2288E-1,&
     & 9.3281E-1, 9.3964E-1, 9.5695E-1, 9.9557E-1, 1.0492E+0, 1.1403E+0,&
     & 1.1861E+0, 1.2264E+0, 1.2441E+0, 1.2595E+0,-4.7104E-1,-4.2557E-2,&
     & 1.9133E-1, 5.0372E-1, 7.0330E-1, 8.3133E-1, 8.7325E-1, 9.0315E-1,&
     & 9.2039E-1, 9.3318E-1, 9.3945E-1, 9.4603E-1, 9.5061E-1, 9.6243E-1,&
     & 9.8989E-1, 1.0308E+0, 1.1077E+0, 1.1497E+0, 1.1880E+0, 1.2051E+0,&
     & 1.2200E+0, 3.4004E-1, 5.1054E-1, 6.0360E-1, 7.2789E-1, 8.0733E-1,&
     & 8.5832E-1, 8.7502E-1, 8.8800E-1, 8.9593E-1, 9.0204E-1, 9.0511E-1,&
     & 9.0839E-1, 9.1071E-1, 9.1682E-1, 9.3179E-1, 9.5626E-1, 1.0099E+0,&
     & 1.0428E+0, 1.0745E+0, 1.0891E+0, 1.1020E+0, 5.8433E-1, 6.4345E-1,&
     & 6.7563E-1, 7.1841E-1, 7.4551E-1, 7.6268E-1, 7.6909E-1, 7.7439E-1,&
     & 7.7777E-1, 7.8046E-1, 7.8184E-1, 7.8333E-1, 7.8439E-1, 7.8725E-1,&
     & 7.9456E-1, 8.0747E-1, 8.3955E-1, 8.6136E-1, 8.8347E-1, 8.9395E-1,&
     & 9.0333E-1, 5.2701E-1, 5.3543E-1, 5.4017E-1, 5.4680E-1, 5.5139E-1,&
     & 5.5537E-1, 5.5713E-1, 5.5869E-1, 5.5974E-1, 5.6060E-1/           
      DATA X3601/ 5.6105E-1, 5.6155E-1, 5.6191E-1, 5.6289E-1, 5.6553E-1,&
     & 5.7059E-1, 5.8494E-1, 5.9576E-1, 6.0736E-1, 6.1304E-1, 6.1821E-1,&
     & 4.0028E-1, 3.9587E-1, 3.9394E-1, 3.9229E-1, 3.9228E-1, 3.9299E-1,&
     & 3.9345E-1, 3.9392E-1, 3.9426E-1, 3.9455E-1, 3.9471E-1, 3.9488E-1,&
     & 3.9501E-1, 3.9538E-1, 3.9642E-1, 3.9858E-1, 4.0554E-1, 4.1125E-1,&
     & 4.1764E-1, 4.2084E-1, 4.2379E-1, 8.1052E-2, 7.7253E-2, 7.5739E-2,&
     & 7.4224E-2, 7.3515E-2, 7.3152E-2, 7.3047E-2, 7.2975E-2, 7.2937E-2,&
     & 7.2911E-2, 7.2899E-2, 7.2887E-2, 7.2879E-2, 7.2862E-2, 7.2838E-2,&
     & 7.2864E-2, 7.3271E-2, 7.3772E-2, 7.4425E-2, 7.4777E-2, 7.5112E-2,&
     & 5.2389E-5, 6.6358E-5, 7.5490E-5, 9.0406E-5, 1.0296E-4, 1.1398E-4,&
     & 1.1880E-4, 1.2309E-4, 1.2597E-4, 1.2833E-4, 1.2958E-4, 1.3094E-4,&
     & 1.3193E-4, 1.3463E-4, 1.4194E-4, 1.5619E-4, 1.9999E-4, 2.3868E-4,&
     & 2.9039E-4, 3.2284E-4, 3.5600E-4, 5.0920E-5, 6.5078E-5, 7.4210E-5,&
     & 8.9126E-5, 1.0168E-4, 1.1270E-4, 1.1752E-4, 1.2181E-4, 1.2469E-4,&
     & 1.2705E-4, 1.2830E-4, 1.2966E-4, 1.3065E-4, 1.3335E-4, 1.4066E-4,&
     & 1.5491E-4, 1.9871E-4, 2.3740E-4, 2.8911E-4, 3.2156E-4, 3.5472E-4,&
     & 5.0751E-5, 6.4720E-5, 7.3851E-5, 8.8767E-5, 1.0132E-4/           
      DATA X3701/ 1.1235E-4, 1.1717E-4, 1.2145E-4, 1.2433E-4, 1.2670E-4,&
     & 1.2794E-4, 1.2930E-4, 1.3029E-4, 1.3300E-4, 1.4030E-4, 1.5455E-4,&
     & 1.9835E-4, 2.3704E-4, 2.8875E-4, 3.2121E-4, 3.5436E-4, 5.1427E-5,&
     & 6.5584E-5, 7.4716E-5, 8.9632E-5, 1.0219E-4, 1.1321E-4, 1.1803E-4,&
     & 1.2231E-4, 1.2519E-4, 1.2756E-4, 1.2880E-4, 1.3016E-4, 1.3115E-4,&
     & 1.3386E-4, 1.4117E-4, 1.5542E-4, 1.9921E-4, 2.3790E-4, 2.8961E-4,&
     & 3.2207E-4, 3.5523E-4, 5.1169E-5, 6.5616E-5, 7.4841E-5, 8.9757E-5,&
     & 1.0231E-4, 1.1333E-4, 1.1816E-4, 1.2244E-4, 1.2532E-4, 1.2768E-4,&
     & 1.2893E-4, 1.3029E-4, 1.3128E-4, 1.3399E-4, 1.4129E-4, 1.5554E-4,&
     & 1.9934E-4, 2.3803E-4, 2.8974E-4, 3.2219E-4, 3.5535E-4, 5.1641E-5,&
     & 6.6464E-5, 7.5856E-5, 9.0915E-5, 1.0347E-4, 1.1449E-4, 1.1931E-4,&
     & 1.2360E-4, 1.2648E-4, 1.2884E-4, 1.3008E-4, 1.3145E-4, 1.3244E-4,&
     & 1.3514E-4, 1.4245E-4, 1.5670E-4, 2.0049E-4, 2.3918E-4, 2.9090E-4,&
     & 3.2335E-4, 3.5651E-4, 5.2795E-5, 6.7913E-5, 7.7442E-5, 9.2655E-5,&
     & 1.0527E-4, 1.1629E-4, 1.2111E-4, 1.2540E-4, 1.2828E-4, 1.3064E-4,&
     & 1.3189E-4, 1.3325E-4, 1.3424E-4, 1.3694E-4, 1.4425E-4, 1.5850E-4,&
     & 2.0230E-4, 2.4099E-4, 2.9270E-4, 3.2515E-4, 3.5831E-4/           
      DATA X3801/ 5.5317E-5, 7.0624E-5, 8.0250E-5, 9.5586E-5, 1.0826E-4,&
     & 1.1930E-4, 1.2412E-4, 1.2841E-4, 1.3129E-4, 1.3365E-4, 1.3489E-4,&
     & 1.3626E-4, 1.3725E-4, 1.3995E-4, 1.4726E-4, 1.6151E-4, 2.0530E-4,&
     & 2.4400E-4, 2.9571E-4, 3.2816E-4, 3.6132E-4, 6.1594E-5, 7.7002E-5,&
     & 8.6695E-5, 1.0209E-4, 1.1481E-4, 1.2587E-4, 1.3069E-4, 1.3498E-4,&
     & 1.3785E-4, 1.4022E-4, 1.4146E-4, 1.4283E-4, 1.4381E-4, 1.4652E-4,&
     & 1.5383E-4, 1.6808E-4, 2.1187E-4, 2.5056E-4, 3.0228E-4, 3.3473E-4,&
     & 3.6789E-4, 7.2215E-5, 8.7775E-5, 9.7454E-5, 1.1288E-4, 1.2563E-4,&
     & 1.3670E-4, 1.4153E-4, 1.4581E-4, 1.4869E-4, 1.5106E-4, 1.5230E-4,&
     & 1.5367E-4, 1.5465E-4, 1.5736E-4, 1.6467E-4, 1.7892E-4, 2.2271E-4,&
     & 2.6140E-4, 3.1311E-4, 3.4557E-4, 3.7873E-4, 8.6248E-5, 1.0157E-4,&
     & 1.1146E-4, 1.2686E-4, 1.3964E-4, 1.5074E-4, 1.5557E-4, 1.5986E-4,&
     & 1.6274E-4, 1.6511E-4, 1.6635E-4, 1.6771E-4, 1.6870E-4, 1.7141E-4,&
     & 1.7871E-4, 1.9296E-4, 2.3676E-4, 2.7545E-4, 3.2716E-4, 3.5961E-4,&
     & 3.9277E-4, 1.0425E-4, 1.2016E-4, 1.2988E-4, 1.4544E-4, 1.5827E-4,&
     & 1.6930E-4, 1.7414E-4, 1.7843E-4, 1.8131E-4, 1.8368E-4, 1.8492E-4,&
     & 1.8628E-4, 1.8727E-4, 1.8998E-4, 1.9729E-4, 2.1153E-4/           
      DATA X3901/ 2.5533E-4, 2.9402E-4, 3.4573E-4, 3.7819E-4, 4.1135E-4,&
     & 1.1778E-4, 1.3345E-4, 1.4335E-4, 1.5873E-4, 1.7156E-4, 1.8261E-4,&
     & 1.8745E-4, 1.9173E-4, 1.9462E-4, 1.9699E-4, 1.9823E-4, 1.9959E-4,&
     & 2.0058E-4, 2.0329E-4, 2.1060E-4, 2.2484E-4, 2.6864E-4, 3.0733E-4,&
     & 3.5904E-4, 3.9150E-4, 4.2466E-4, 1.4247E-4, 1.5812E-4, 1.6797E-4,&
     & 1.8357E-4, 1.9642E-4, 2.0755E-4, 2.1239E-4, 2.1669E-4, 2.1957E-4,&
     & 2.2194E-4, 2.2318E-4, 2.2454E-4, 2.2553E-4, 2.2824E-4, 2.3555E-4,&
     & 2.4980E-4, 2.9359E-4, 3.3228E-4, 3.8399E-4, 4.1645E-4, 4.4961E-4,&
     & 1.7740E-4, 1.9313E-4, 2.0298E-4, 2.1860E-4, 2.3146E-4, 2.4259E-4,&
     & 2.4744E-4, 2.5173E-4, 2.5462E-4, 2.5699E-4, 2.5823E-4, 2.5959E-4,&
     & 2.6058E-4, 2.6329E-4, 2.7060E-4, 2.8484E-4, 3.2864E-4, 3.6733E-4,&
     & 4.1904E-4, 4.5150E-4, 4.8466E-4, 2.4351E-4, 2.5916E-4, 2.6900E-4,&
     & 2.8462E-4, 2.9746E-4, 3.0859E-4, 3.1343E-4, 3.1772E-4, 3.2061E-4,&
     & 3.2297E-4, 3.2422E-4, 3.2558E-4, 3.2657E-4, 3.2928E-4, 3.3658E-4,&
     & 3.5083E-4, 3.9463E-4, 4.3332E-4, 4.8503E-4, 5.1748E-4, 5.5064E-4,&
     & 2.7879E-4, 2.9447E-4, 3.0435E-4, 3.1993E-4, 3.3277E-4, 3.4390E-4,&
     & 3.4874E-4, 3.5304E-4, 3.5592E-4, 3.5829E-4, 3.5953E-4/           
      DATA X4001/ 3.6090E-4, 3.6189E-4, 3.6459E-4, 3.7190E-4, 3.8615E-4,&
     & 4.2994E-4, 4.6864E-4, 5.2035E-4, 5.5280E-4, 5.8596E-4, 3.0893E-4,&
     & 3.2479E-4, 3.3474E-4, 3.5027E-4, 3.6320E-4, 3.7423E-4, 3.7905E-4,&
     & 3.8335E-4, 3.8623E-4, 3.8860E-4, 3.8984E-4, 3.9121E-4, 3.9220E-4,&
     & 3.9490E-4, 4.0221E-4, 4.1646E-4, 4.6025E-4, 4.9894E-4, 5.5066E-4,&
     & 5.8311E-4, 6.1627E-4, 3.3092E-4, 3.4630E-4, 3.5620E-4, 3.7128E-4,&
     & 3.8415E-4, 3.9528E-4, 4.0010E-4, 4.0438E-4, 4.0728E-4, 4.0964E-4,&
     & 4.1089E-4, 4.1225E-4, 4.1324E-4, 4.1595E-4, 4.2325E-4, 4.3750E-4,&
     & 4.8130E-4, 5.1999E-4, 5.7170E-4, 6.0416E-4, 6.3731E-4, 3.6675E-4,&
     & 3.8278E-4, 3.9256E-4, 4.0817E-4, 4.2075E-4, 4.3187E-4, 4.3669E-4,&
     & 4.4098E-4, 4.4386E-4, 4.4623E-4, 4.4747E-4, 4.4883E-4, 4.4982E-4,&
     & 4.5253E-4, 4.5984E-4, 4.7409E-4, 5.1788E-4, 5.5657E-4, 6.0828E-4,&
     & 6.4074E-4, 6.7390E-4, 4.1234E-4, 4.2796E-4, 4.3768E-4, 4.5314E-4,&
     & 4.6591E-4, 4.7699E-4, 4.8182E-4, 4.8610E-4, 4.8898E-4, 4.9135E-4,&
     & 4.9259E-4, 4.9395E-4, 4.9494E-4, 4.9765E-4, 5.0496E-4, 5.1921E-4,&
     & 5.6300E-4, 6.0169E-4, 6.5340E-4, 6.8586E-4, 7.1902E-4, 4.7582E-4,&
     & 4.9126E-4, 5.0095E-4, 5.1629E-4, 5.2900E-4, 5.4006E-4/           
      DATA X4101/ 5.4488E-4, 5.4916E-4, 5.5204E-4, 5.5441E-4, 5.5565E-4,&
     & 5.5701E-4, 5.5800E-4, 5.6071E-4, 5.6802E-4, 5.8227E-4, 6.2606E-4,&
     & 6.6475E-4, 7.1646E-4, 7.4892E-4, 7.8208E-4, 5.6100E-4, 5.7637E-4,&
     & 5.8598E-4, 6.0133E-4, 6.1401E-4, 6.2506E-4, 6.2988E-4, 6.3416E-4,&
     & 6.3704E-4, 6.3941E-4, 6.4065E-4, 6.4201E-4, 6.4300E-4, 6.4571E-4,&
     & 6.5302E-4, 6.6727E-4, 7.1106E-4, 7.4975E-4, 8.0146E-4, 8.3392E-4,&
     & 8.6708E-4, 7.9022E-4, 8.0536E-4, 8.1490E-4, 8.3011E-4, 8.4272E-4,&
     & 8.5374E-4, 8.5857E-4, 8.6285E-4, 8.6573E-4, 8.6809E-4, 8.6934E-4,&
     & 8.7070E-4, 8.7169E-4, 8.7440E-4, 8.8170E-4, 8.9595E-4, 9.3975E-4,&
     & 9.7844E-4, 1.0301E-3, 1.0626E-3, 1.0958E-3, 1.2265E-3, 1.2413E-3,&
     & 1.2507E-3, 1.2658E-3, 1.2783E-3, 1.2894E-3, 1.2942E-3, 1.2985E-3,&
     & 1.3014E-3, 1.3037E-3, 1.3050E-3, 1.3063E-3, 1.3073E-3, 1.3100E-3,&
     & 1.3173E-3, 1.3316E-3, 1.3754E-3, 1.4141E-3, 1.4658E-3, 1.4982E-3,&
     & 1.5314E-3, 2.0662E-3, 2.0806E-3, 2.0898E-3, 2.1047E-3, 2.1173E-3,&
     & 2.1283E-3, 2.1331E-3, 2.1374E-3, 2.1403E-3, 2.1427E-3, 2.1439E-3,&
     & 2.1453E-3, 2.1463E-3, 2.1490E-3, 2.1563E-3, 2.1705E-3, 2.2143E-3,&
     & 2.2530E-3, 2.3047E-3, 2.3372E-3, 2.3703E-3, 2.8271E-3/           
      DATA X4201/ 2.8413E-3, 2.8504E-3, 2.8653E-3, 2.8779E-3, 2.8889E-3,&
     & 2.8937E-3, 2.8980E-3, 2.9009E-3, 2.9033E-3, 2.9045E-3, 2.9059E-3,&
     & 2.9068E-3, 2.9096E-3, 2.9169E-3, 2.9311E-3, 2.9749E-3, 3.0136E-3,&
     & 3.0653E-3, 3.0978E-3, 3.1309E-3, 4.6749E-3, 4.6889E-3, 4.6980E-3,&
     & 4.7129E-3, 4.7255E-3, 4.7365E-3, 4.7413E-3, 4.7456E-3, 4.7485E-3,&
     & 4.7508E-3, 4.7521E-3, 4.7535E-3, 4.7544E-3, 4.7571E-3, 4.7645E-3,&
     & 4.7787E-3, 4.8225E-3, 4.8612E-3, 4.9129E-3, 4.9454E-3, 4.9785E-3,&
     & 6.0133E-5, 7.8747E-5, 9.0575E-5, 1.0959E-4, 1.2548E-4, 1.3946E-4,&
     & 1.4560E-4, 1.5109E-4, 1.5479E-4, 1.5784E-4, 1.5944E-4, 1.6120E-4,&
     & 1.6249E-4, 1.6601E-4, 1.7557E-4, 1.9458E-4, 2.5688E-4, 3.1782E-4,&
     & 4.0697E-4, 4.6469E-4, 5.2853E-4, 6.0119E-5, 7.8747E-5, 9.0575E-5,&
     & 1.0959E-4, 1.2548E-4, 1.3946E-4, 1.4560E-4, 1.5109E-4, 1.5479E-4,&
     & 1.5784E-4, 1.5944E-4, 1.6120E-4, 1.6249E-4, 1.6601E-4, 1.7557E-4,&
     & 1.9458E-4, 2.5688E-4, 3.1782E-4, 4.0697E-4, 4.6469E-4, 5.2853E-4,&
     & 6.0133E-5, 7.8747E-5, 9.0575E-5, 1.0959E-4, 1.2548E-4, 1.3946E-4,&
     & 1.4560E-4, 1.5109E-4, 1.5479E-4, 1.5784E-4, 1.5944E-4, 1.6120E-4,&
     & 1.6249E-4, 1.6601E-4, 1.7557E-4, 1.9458E-4, 2.5688E-4/           
      DATA X4301/ 3.1782E-4, 4.0697E-4, 4.6469E-4, 5.2853E-4, 6.0119E-5,&
     & 7.8747E-5, 9.0575E-5, 1.0959E-4, 1.2548E-4, 1.3946E-4, 1.4560E-4,&
     & 1.5109E-4, 1.5479E-4, 1.5784E-4, 1.5944E-4, 1.6120E-4, 1.6249E-4,&
     & 1.6601E-4, 1.7557E-4, 1.9458E-4, 2.5688E-4, 3.1782E-4, 4.0697E-4,&
     & 4.6469E-4, 5.2853E-4, 6.0108E-5, 7.8745E-5, 9.0575E-5, 1.0959E-4,&
     & 1.2548E-4, 1.3946E-4, 1.4560E-4, 1.5109E-4, 1.5479E-4, 1.5784E-4,&
     & 1.5944E-4, 1.6120E-4, 1.6249E-4, 1.6601E-4, 1.7557E-4, 1.9458E-4,&
     & 2.5688E-4, 3.1782E-4, 4.0697E-4, 4.6469E-4, 5.2853E-4, 6.0119E-5,&
     & 7.8750E-5, 9.0578E-5, 1.0959E-4, 1.2548E-4, 1.3946E-4, 1.4561E-4,&
     & 1.5109E-4, 1.5479E-4, 1.5784E-4, 1.5944E-4, 1.6121E-4, 1.6249E-4,&
     & 1.6601E-4, 1.7558E-4, 1.9459E-4, 2.5688E-4, 3.1782E-4, 4.0697E-4,&
     & 4.6469E-4, 5.2854E-4, 6.8042E-5, 8.6667E-5, 9.8488E-5, 1.1749E-4,&
     & 1.3338E-4, 1.4736E-4, 1.5350E-4, 1.5899E-4, 1.6269E-4, 1.6574E-4,&
     & 1.6734E-4, 1.6910E-4, 1.7039E-4, 1.7391E-4, 1.8347E-4, 2.0248E-4,&
     & 2.6478E-4, 3.2572E-4, 4.1487E-4, 4.7259E-4, 5.3643E-4, 7.8343E-5,&
     & 9.6943E-5, 1.0875E-4, 1.2775E-4, 1.4364E-4, 1.5761E-4, 1.6376E-4,&
     & 1.6924E-4, 1.7294E-4, 1.7599E-4, 1.7760E-4, 1.7936E-4/           
      DATA X4401/ 1.8064E-4, 1.8416E-4, 1.9373E-4, 2.1274E-4, 2.7504E-4,&
     & 3.3598E-4, 4.2513E-4, 4.8284E-4, 5.4669E-4, 8.9735E-5, 1.0826E-4,&
     & 1.2008E-4, 1.3906E-4, 1.5495E-4, 1.6893E-4, 1.7507E-4, 1.8055E-4,&
     & 1.8425E-4, 1.8731E-4, 1.8891E-4, 1.9067E-4, 1.9195E-4, 1.9547E-4,&
     & 2.0504E-4, 2.2405E-4, 2.8635E-4, 3.4729E-4, 4.3644E-4, 4.9416E-4,&
     & 5.5800E-4, 1.0484E-4, 1.2355E-4, 1.3535E-4, 1.5425E-4, 1.7013E-4,&
     & 1.8411E-4, 1.9025E-4, 1.9573E-4, 1.9943E-4, 2.0248E-4, 2.0409E-4,&
     & 2.0585E-4, 2.0713E-4, 2.1065E-4, 2.2022E-4, 2.3923E-4, 3.0153E-4,&
     & 3.6247E-4, 4.5161E-4, 5.0933E-4, 5.7318E-4, 1.2273E-4, 1.4102E-4,&
     & 1.5295E-4, 1.7184E-4, 1.8774E-4, 2.0172E-4, 2.0787E-4, 2.1335E-4,&
     & 2.1705E-4, 2.2010E-4, 2.2170E-4, 2.2347E-4, 2.2475E-4, 2.2827E-4,&
     & 2.3784E-4, 2.5685E-4, 3.1914E-4, 3.8008E-4, 4.6923E-4, 5.2695E-4,&
     & 5.9080E-4, 1.4418E-4, 1.6308E-4, 1.7488E-4, 1.9389E-4, 2.0975E-4,&
     & 2.2370E-4, 2.2985E-4, 2.3535E-4, 2.3904E-4, 2.4209E-4, 2.4370E-4,&
     & 2.4546E-4, 2.4674E-4, 2.5026E-4, 2.5983E-4, 2.7884E-4, 3.4114E-4,&
     & 4.0208E-4, 4.9123E-4, 5.4894E-4, 6.1279E-4, 1.6016E-4, 1.7864E-4,&
     & 1.9050E-4, 2.0927E-4, 2.2513E-4, 2.3920E-4, 2.4536E-4/           
      DATA X4501/ 2.5084E-4, 2.5455E-4, 2.5760E-4, 2.5920E-4, 2.6097E-4,&
     & 2.6225E-4, 2.6577E-4, 2.7534E-4, 2.9435E-4, 3.5664E-4, 4.1758E-4,&
     & 5.0673E-4, 5.6445E-4, 6.2829E-4, 1.8969E-4, 2.0817E-4, 2.1994E-4,&
     & 2.3889E-4, 2.5476E-4, 2.6873E-4, 2.7487E-4, 2.8035E-4, 2.8405E-4,&
     & 2.8710E-4, 2.8870E-4, 2.9047E-4, 2.9175E-4, 2.9527E-4, 3.0484E-4,&
     & 3.2385E-4, 3.8614E-4, 4.4708E-4, 5.3623E-4, 5.9395E-4, 6.5779E-4,&
     & 2.3411E-4, 2.5266E-4, 2.6442E-4, 2.8336E-4, 2.9923E-4, 3.1320E-4,&
     & 3.1934E-4, 3.2482E-4, 3.2852E-4, 3.3157E-4, 3.3318E-4, 3.3494E-4,&
     & 3.3622E-4, 3.3974E-4, 3.4931E-4, 3.6832E-4, 4.3062E-4, 4.9156E-4,&
     & 5.8070E-4, 6.3842E-4, 7.0227E-4, 3.3445E-4, 3.5290E-4, 3.6474E-4,&
     & 3.8365E-4, 3.9953E-4, 4.1349E-4, 4.1963E-4, 4.2511E-4, 4.2881E-4,&
     & 4.3186E-4, 4.3347E-4, 4.3523E-4, 4.3651E-4, 4.4003E-4, 4.4960E-4,&
     & 4.6861E-4, 5.3091E-4, 5.9185E-4, 6.8100E-4, 7.3871E-4, 8.0256E-4,&
     & 3.9576E-4, 4.1420E-4, 4.2601E-4, 4.4495E-4, 4.6082E-4, 4.7479E-4,&
     & 4.8093E-4, 4.8641E-4, 4.9011E-4, 4.9316E-4, 4.9476E-4, 4.9653E-4,&
     & 4.9781E-4, 5.0133E-4, 5.1090E-4, 5.2991E-4, 5.9220E-4, 6.5314E-4,&
     & 7.4229E-4, 8.0001E-4, 8.6386E-4, 4.4912E-4, 4.6724E-4/           
      DATA X4601/ 4.7922E-4, 4.9812E-4, 5.1406E-4, 5.2801E-4, 5.3410E-4,&
     & 5.3959E-4, 5.4329E-4, 5.4634E-4, 5.4794E-4, 5.4971E-4, 5.5099E-4,&
     & 5.5451E-4, 5.6408E-4, 5.8309E-4, 6.4539E-4, 7.0633E-4, 7.9547E-4,&
     & 8.5319E-4, 9.1704E-4, 4.8542E-4, 5.0449E-4, 5.1618E-4, 5.3406E-4,&
     & 5.4997E-4, 5.6386E-4, 5.7002E-4, 5.7550E-4, 5.7920E-4, 5.8226E-4,&
     & 5.8386E-4, 5.8563E-4, 5.8691E-4, 5.9043E-4, 6.0000E-4, 6.1901E-4,&
     & 6.8131E-4, 7.4224E-4, 8.3139E-4, 8.8911E-4, 9.5296E-4, 5.4169E-4,&
     & 5.6291E-4, 5.7453E-4, 5.9319E-4, 6.0898E-4, 6.2295E-4, 6.2910E-4,&
     & 6.3460E-4, 6.3830E-4, 6.4135E-4, 6.4295E-4, 6.4471E-4, 6.4600E-4,&
     & 6.4951E-4, 6.5908E-4, 6.7809E-4, 7.4039E-4, 8.0133E-4, 8.9048E-4,&
     & 9.4820E-4, 1.0120E-3, 6.0987E-4, 6.2859E-4, 6.4033E-4, 6.5925E-4,&
     & 6.7518E-4, 6.8913E-4, 6.9528E-4, 7.0076E-4, 7.0446E-4, 7.0751E-4,&
     & 7.0911E-4, 7.1087E-4, 7.1216E-4, 7.1567E-4, 7.2524E-4, 7.4425E-4,&
     & 8.0655E-4, 8.6749E-4, 9.5664E-4, 1.0144E-3, 1.0782E-3, 6.9070E-4,&
     & 7.0924E-4, 7.2110E-4, 7.4011E-4, 7.5600E-4, 7.6997E-4, 7.7612E-4,&
     & 7.8160E-4, 7.8530E-4, 7.8835E-4, 7.8996E-4, 7.9172E-4, 7.9300E-4,&
     & 7.9652E-4, 8.0609E-4, 8.2510E-4, 8.8740E-4, 9.4834E-4/           
      DATA X4701/ 1.0375E-3, 1.0952E-3, 1.1590E-3, 7.8249E-4, 8.0112E-4,&
     & 8.1292E-4, 8.3191E-4, 8.4781E-4, 8.6179E-4, 8.6793E-4, 8.7341E-4,&
     & 8.7711E-4, 8.8017E-4, 8.8177E-4, 8.8353E-4, 8.8481E-4, 8.8833E-4,&
     & 8.9790E-4, 9.1691E-4, 9.7921E-4, 1.0402E-3, 1.1293E-3, 1.1870E-3,&
     & 1.2509E-3, 9.6760E-4, 9.8620E-4, 9.9803E-4, 1.0170E-3, 1.0329E-3,&
     & 1.0469E-3, 1.0530E-3, 1.0585E-3, 1.0622E-3, 1.0653E-3, 1.0669E-3,&
     & 1.0686E-3, 1.0699E-3, 1.0734E-3, 1.0830E-3, 1.1020E-3, 1.1643E-3,&
     & 1.2253E-3, 1.3144E-3, 1.3721E-3, 1.4360E-3, 1.1984E-3, 1.2171E-3,&
     & 1.2289E-3, 1.2479E-3, 1.2638E-3, 1.2778E-3, 1.2839E-3, 1.2894E-3,&
     & 1.2931E-3, 1.2962E-3, 1.2978E-3, 1.2995E-3, 1.3008E-3, 1.3043E-3,&
     & 1.3139E-3, 1.3329E-3, 1.3952E-3, 1.4561E-3, 1.5453E-3, 1.6030E-3,&
     & 1.6668E-3, 1.4724E-3, 1.4911E-3, 1.5029E-3, 1.5219E-3, 1.5378E-3,&
     & 1.5518E-3, 1.5579E-3, 1.5634E-3, 1.5671E-3, 1.5701E-3, 1.5717E-3,&
     & 1.5735E-3, 1.5748E-3, 1.5783E-3, 1.5879E-3, 1.6069E-3, 1.6692E-3,&
     & 1.7301E-3, 1.8193E-3, 1.8770E-3, 1.9408E-3, 1.6411E-3, 1.6597E-3,&
     & 1.6716E-3, 1.6906E-3, 1.7065E-3, 1.7204E-3, 1.7266E-3, 1.7321E-3,&
     & 1.7358E-3, 1.7388E-3, 1.7404E-3, 1.7422E-3, 1.7435E-3/           
      DATA X4801/ 1.7470E-3, 1.7566E-3, 1.7756E-3, 1.8379E-3, 1.8988E-3,&
     & 1.9880E-3, 2.0457E-3, 2.1095E-3, 1.9229E-3, 1.9415E-3, 1.9533E-3,&
     & 1.9723E-3, 1.9882E-3, 2.0022E-3, 2.0083E-3, 2.0138E-3, 2.0175E-3,&
     & 2.0206E-3, 2.0222E-3, 2.0239E-3, 2.0252E-3, 2.0287E-3, 2.0383E-3,&
     & 2.0573E-3, 2.1196E-3, 2.1806E-3, 2.2697E-3, 2.3274E-3, 2.3913E-3,&
     & 3.7500E-1, 4.3300E-1, 4.8600E-1, 5.3500E-1, 5.7900E-1, 6.1900E-1,&
     & 6.5500E-1, 6.8800E-1, 7.1800E-1, 7.4500E-1, 7.6900E-1, 7.9200E-1,&
     & 8.3900E-1, 8.6200E-1, 8.8200E-1, 8.9900E-1, 9.0900E-1, 9.1900E-1,&
     & 9.2700E-1, 9.3100E-1, 9.3800E-1, 9.5300E-1, 9.5600E-1, 9.6100E-1,&
     & 9.6300E-1, 9.6700E-1, 9.7100E-1, 9.7400E-1, 9.7800E-1, 9.8100E-1,&
     & 9.8400E-1, 9.8700E-1, 9.8900E-1, 9.9100E-1, 9.9300E-1, 9.9500E-1,&
     & 9.9600E-1, 9.9700E-1, 9.9800E-1, 1.0000E+0, 5.8930E-5, 5.3254E-4,&
     & 2.4148E-3, 7.2895E-3, 1.6509E-2, 3.1120E-2, 5.1303E-2, 7.7303E-2,&
     & 1.0848E-1, 1.4368E-1, 1.8139E-1, 2.2378E-1, 3.3177E-1, 3.9626E-1,&
     & 4.5925E-1, 5.1825E-1, 5.5545E-1, 5.9461E-1, 6.2741E-1, 6.4432E-1,&
     & 6.7477E-1, 7.4383E-1, 7.5831E-1, 7.8294E-1, 7.9298E-1, 8.1338E-1,&
     & 8.3422E-1, 8.5015E-1, 8.7180E-1, 8.8835E-1, 9.0518E-1/           
      DATA X4901/ 9.2230E-1, 9.3387E-1, 9.4557E-1, 9.5740E-1, 9.6937E-1,&
     & 9.7541E-1, 9.8148E-1, 9.8759E-1, 1.0000E+0, 2.9656E+0, 2.8756E+0,&
     & 2.7908E+0, 2.7100E+0, 2.6348E+0, 2.5637E+0, 2.4968E+0, 2.4327E+0,&
     & 2.3715E+0, 2.3137E+0, 2.2597E+0, 2.2052E+0, 2.0830E+0, 2.0161E+0,&
     & 1.9528E+0, 1.8941E+0, 1.8569E+0, 1.8172E+0, 1.7834E+0, 1.7657E+0,&
     & 1.7331E+0, 1.6551E+0, 1.6378E+0, 1.6072E+0, 1.5943E+0, 1.5672E+0,&
     & 1.5380E+0, 1.5144E+0, 1.4802E+0, 1.4518E+0, 1.4206E+0, 1.3854E+0,&
     & 1.3590E+0, 1.3294E+0, 1.2954E+0, 1.2547E+0, 1.2304E+0, 1.2021E+0,&
     & 1.1672E+0, 1.0000E+0, 4.5251E-5, 3.5482E-4, 1.4406E-3, 3.9868E-3,&
     & 8.4542E-3, 1.5161E-2, 2.4095E-2, 3.5353E-2, 4.8718E-2, 6.3813E-2,&
     & 8.0120E-2, 9.8748E-2, 1.4834E-1, 1.7996E-1, 2.1276E-1, 2.4561E-1,&
     & 2.6763E-1, 2.9211E-1, 3.1382E-1, 3.2550E-1, 3.4749E-1, 4.0309E-1,&
     & 4.1600E-1, 4.3926E-1, 4.4926E-1, 4.7067E-1, 4.9429E-1, 5.1379E-1,&
     & 5.4276E-1, 5.6731E-1, 5.9503E-1, 6.2697E-1, 6.5143E-1, 6.7933E-1,&
     & 7.1197E-1, 7.5168E-1, 7.7550E-1, 8.0331E-1, 8.3711E-1, 1.0000E+0,&
     & 1.6628E+1, 1.7557E+1, 1.8341E+1, 1.8999E+1, 1.9536E+1, 1.9985E+1,&
     & 2.0366E+1, 2.0701E+1, 2.1000E+1, 2.1265E+1, 2.1501E+1/           
      DATA X5001/ 2.1726E+1, 2.2188E+1, 2.2415E+1, 2.2614E+1, 2.2785E+1,&
     & 2.2888E+1, 2.2993E+1, 2.3079E+1, 2.3123E+1, 2.3201E+1, 2.3382E+1,&
     & 2.3421E+1, 2.3488E+1, 2.3516E+1, 2.3575E+1, 2.3637E+1, 2.3686E+1,&
     & 2.3757E+1, 2.3814E+1, 2.3877E+1, 2.3946E+1, 2.3997E+1, 2.4053E+1,&
     & 2.4117E+1, 2.4191E+1, 2.4234E+1, 2.4283E+1, 2.4344E+1, 2.5469E+1,&
     & 3.3257E+1, 3.1555E+1, 3.0437E+1, 2.9649E+1, 2.9081E+1, 2.8646E+1,&
     & 2.8305E+1, 2.8022E+1, 2.7785E+1, 2.7584E+1, 2.7412E+1, 2.7251E+1,&
     & 2.6925E+1, 2.6762E+1, 2.6615E+1, 2.6483E+1, 2.6401E+1, 2.6315E+1,&
     & 2.6242E+1, 2.6203E+1, 2.6134E+1, 2.5968E+1, 2.5931E+1, 2.5866E+1,&
     & 2.5838E+1, 2.5781E+1, 2.5718E+1, 2.5668E+1, 2.5595E+1, 2.5534E+1,&
     & 2.5467E+1, 2.5392E+1, 2.5335E+1, 2.5272E+1, 2.5200E+1, 2.5115E+1,&
     & 2.5065E+1, 2.5007E+1, 2.4939E+1, 2.5469E+1, 6.2357E+0, 6.6105E+0,&
     & 6.9709E+0, 7.3070E+0, 7.6065E+0, 7.8773E+0, 8.1221E+0, 8.3504E+0,&
     & 8.5638E+0, 8.7624E+0, 8.9453E+0, 9.1268E+0, 9.5180E+0, 9.7202E+0,&
     & 9.9028E+0, 1.0064E+1, 1.0163E+1, 1.0265E+1, 1.0349E+1, 1.0393E+1,&
     & 1.0471E+1, 1.0654E+1, 1.0694E+1, 1.0763E+1, 1.0791E+1, 1.0852E+1,&
     & 1.0915E+1, 1.0967E+1, 1.1040E+1, 1.1099E+1, 1.1164E+1/           
      DATA X5101/ 1.1236E+1, 1.1288E+1, 1.1346E+1, 1.1412E+1, 1.1488E+1,&
     & 1.1533E+1, 1.1584E+1, 1.1645E+1, 1.1935E+1, 1.2471E+1, 1.2672E+1,&
     & 1.2849E+1, 1.3005E+1, 1.3133E+1, 1.3239E+1, 1.3322E+1, 1.3387E+1,&
     & 1.3436E+1, 1.3470E+1, 1.3491E+1, 1.3502E+1, 1.3493E+1, 1.3468E+1,&
     & 1.3432E+1, 1.3388E+1, 1.3356E+1, 1.3317E+1, 1.3281E+1, 1.3261E+1,&
     & 1.3222E+1, 1.3118E+1, 1.3093E+1, 1.3047E+1, 1.3027E+1, 1.2984E+1,&
     & 1.2937E+1, 1.2897E+1, 1.2837E+1, 1.2786E+1, 1.2729E+1, 1.2663E+1,&
     & 1.2612E+1, 1.2555E+1, 1.2488E+1, 1.2408E+1, 1.2360E+1, 1.2305E+1,&
     & 1.2239E+1, 1.1935E+1, 2.1882E-1, 1.4431E+2, 5.2150E+0, 5.7375E-1,&
     & 1.0000E-3, 2.0000E-3, 1.0000E-3, 1.0000E-3/                      
                                                                        
!----------------------------------------------------------------------------

       NG = 19 
       N1 = 21 
       N2 = 28 
       N3 = 8 
       NS = 40 
       DO 20 I=1,4 
         DO 10 J=1,19 
           G(J,I) = Z(J+(I-1)*19) 
   10    CONTINUE 
   20  CONTINUE 

       DO 30 I=1,21
         TT(I) = Z(I+76) 
   30 END DO 

       DO 40 I=1,28
         DD(I) = Z(I+97) 
   40  CONTINUE 

       KK=125
       DO 70 I=1,8 
         DO 60 J=1,28 
           DO 50 K=1,21 
             KK=KK+1 
             GG(K,J,I) = Z(KK) 
   50      CONTINUE 
   60    CONTINUE 
   70  CONTINUE 

       DO 90 I=1,8
         DO 80 J=1,40 
           SAT(J,I) = Z(J+(I-1)*40+4829) 
   80    CONTINUE 
   90  CONTINUE 

      DO 100 I=1,8
        C(I) = Z(I+5149) 
  100 CONTINUE 


      IGOTO = 4
      CALL FLUID(TEMP,PRES,DENS,PROPS,NP,ENTRY,VAPOR,ERROR,IGOTO) 

      RETURN
      END Subroutine F2
