MODULE strings_consts
! String Lengths of Resulting Variables of Character Functions
  INTEGER(4), PARAMETER :: ncresults = 250
END MODULE strings_consts

MODULE strings_interfaces
 INTERFACE
  FUNCTION ru_doswin( string, dos_win )
   USE strings_consts
   CHARACTER(ncresults) :: ru_doswin
   CHARACTER(*), INTENT(IN) :: string
   LOGICAL(4), INTENT(IN) :: dos_win
  END FUNCTION ru_doswin
 END INTERFACE
END MODULE strings_interfaces

FUNCTION ru_doswin( string, dos_win )
 USE strings_consts
 CHARACTER(ncresults) :: ru_doswin
 CHARACTER(*), INTENT(IN) :: string
 LOGICAL(4), INTENT(IN) :: dos_win	  ! DOS-Win (.true.) or
                                      ! Win-DOS (.false.) Coverting Flag
 INTEGER(2) :: i, dos_win_code, dif

 ru_doswin = string
 DO i = 1, LEN_TRIM( ru_doswin )
  dos_win_code = IACHAR( ru_doswin( i:i ) )	  ! Get DOS or Windows Code
  dif = 0                                     ! dif > 0 if this is
                                              !   Russian Letter
  IF( dos_win ) THEN			      ! 'DOS-Windows' Converting
   SELECT CASE( dos_win_code )
    CASE( 128:175 )
	 dif = 64
    CASE( 224:239 )
	 dif = 16
   END SELECT
  ELSE                                        ! 'Windows-DOS' Converting
   SELECT CASE( dos_win_code )
    CASE( 192:239 )
	 dif = -64
    CASE( 240:255 )
	 dif = -16
   END SELECT
  END IF
  ! If This is Russian Letter then Perform Converting
  IF( dif /= 0 )  ru_doswin( i:i ) = CHAR( dos_win_code + dif )
 END DO
END FUNCTION ru_doswin
