      PROGRAM VisGeom
! ******************************************************************************
! ****   This program originally was created in 1999 for visualization of HABP 
! **** MARK-4 generated geometry and in 2004 was added by LaWGS format. Program
! **** allows aircraft rotation on pitching, yawing and rolling.
! ****   If opened file has '.wgs' extension then program use LaWGS format, 
! **** otherwise use HABP MARK-4 Unit 4 format.
! ******************************************************************************
!
!    ***  Program was written by Igor Polyakov  ***
!                   Ukraine, 1999.
!    ***  April 2004 - added LaWGS format       ***

      REAL (8) xmin, xmax, AL
      REAL  NX(10000), NY(10000), NZ(10000), NXO(10000)
      REAL(8) X1(10000), X2(10000), X3(10000), X4(10000),
     +        Y1(10000), Y2(10000), Y3(10000), Y4(10000),
     +        Z1(10000), Z2(10000), Z3(10000), Z4(10000),
     +        XS1(10000), XS2(10000), XS3(10000), XS4(10000),
     +        YS1(10000), YS2(10000), YS3(10000), YS4(10000),
     +        ZS1(10000), ZS2(10000), ZS3(10000), ZS4(10000),
     +        tmp(10000)
      Character *60 CONFIG
      COMMON /elemgeom/ nel, NX, NY, NZ, NXO, X1, X2, X3, X4, Y1, Y2,
     +                  Y3, Y4, Z1, Z2, Z3, Z4, XS1, XS2, XS3, XS4, YS1,
     +                  YS2, YS3, YS4, ZS1, ZS2, ZS3, ZS4, CONFIG, AL
      CHARACTER*100 fname

      OPEN( 4, ACCESS='DIRECT', FILE = ' ' , RECL=100 )

!     INQUIRE about file name:
      INQUIRE( 4, NAME = fname )

! Point position in file name
      iFnPoint = INDEX( fname, '.' )

      IF( iFnPoint /= 0 .AND. (fname((iFnPoint+1):(iFnPoint+3)) == 'wgs' 
     +           .OR. fname((iFnPoint+1):(iFnPoint+3)) == 'WGS' ) ) THEN
! Read LaWGS file and generate Geometry Element Data like MARK-IV
          CLOSE( 4 )
          OPEN( 4, FILE = fname )
          CALL Get_Geom_LaWGS
      ELSE
! Read Geometry Element Data from MARK-IV UNIT4
          CALL Get_Geom_Unit4
      ENDIF

! Get Initial X Coordinates
      tmp = MIN( -X1, -X2, -X3, -X4 )
      xmin = MINVAL( tmp )
      tmp = MAX( -X1, -X2, -X3, -X4 )
      xmax = MAXVAL( tmp )
! Initial ViewPort X Length
      AL = xmax - xmin

      CALL set_video_mode()
      CALL DoDialog( )
! Suppress Opening of Message Box on Dialog Box Button 
! 'CANCEL' Clicking
      DO WHILE (.TRUE.)
      ENDDO

      STOP
      END



      SUBROUTINE DoDialog( )
      USE DIALOGM
      IMPLICIT NONE
      INCLUDE 'RESOURCE.FD'

      INTEGER retint
      LOGICAL retlog
      TYPE (dialog) dlg
      EXTERNAL  UpdateTemp
! Initialize.
      IF ( .not. DlgInit( idd_dialog1, dlg ) ) THEN
         WRITE (*,*) "Error: dialog not found"
      ELSE
! Set up controls.
         ! Following 3 lines used with MS Fortran PowerStation 4 
         ! and Digital Visual Fortran 5
         retlog = DlgSet( dlg, IDC_SCROLLBAR_PITCHING, 181, dlg_range )
         retlog = DlgSet( dlg, IDC_SCROLLBAR_YAWING, 181, dlg_range )
         retlog = DlgSet( dlg, IDC_SCROLLBAR_ROLLING, 181, dlg_range )
         ! Following 3 lines used with Compaq Visual Fortran 6.x
!        retlog = DlgSet( dlg, IDC_SCROLLBAR_PITCHING, 190, dlg_range )
!        retlog = DlgSet( dlg, IDC_SCROLLBAR_YAWING, 190, dlg_range )
!        retlog = DlgSet( dlg, IDC_SCROLLBAR_ROLLING, 190, dlg_range )

         retlog = DlgSet( dlg, IDC_EDIT_PITCHING, '0' )
         retlog = DlgSet( dlg, IDC_EDIT_YAWING, '0' )
         retlog = DlgSet( dlg, IDC_EDIT_ROLLING, '0' )

         retlog = DLGSET( dlg, IDC_RADIO_2D, .TRUE. )
         retlog = DLGSET( dlg, IDC_RADIO_3D, .FALSE. )

         retlog = DlgSetSub( dlg, IDC_SCROLLBAR_PITCHING, UpdateTemp )
         retlog = DlgSetSub( dlg, IDC_SCROLLBAR_YAWING, UpdateTemp )
         retlog = DlgSetSub( dlg, IDC_SCROLLBAR_ROLLING, UpdateTemp )
         retlog = DlgSetSub( dlg, IDOK, UpdateTemp )
         retlog = DlgSetSub( dlg, IDC_RADIO_2D, UpdateTemp )
         retlog = DlgSetSub( dlg, IDC_RADIO_3D, UpdateTemp )

! Activate the dialog.
         retint = DlgModal( dlg )
! Release dialog resources.
         CALL DlgUninit( dlg )
      END IF
      END SUBROUTINE DoDialog



      SUBROUTINE UpdateTemp( dlg, control_name, callbacktype )
! This is CallBack Routine for Dialog IDD_DIALOG1
      USE DIALOGM
      IMPLICIT NONE
      TYPE (dialog) dlg
      INTEGER control_name
      INTEGER callbacktype
      INCLUDE 'RESOURCE.FD'
      CHARACTER(256)  text
      INTEGER cel, far
      INTEGER pitch, yaw, roll 
      LOGICAL retlog, image_3d
      REAL pi, deginrad
      COMMON /view_type/ image_3d
! Suppress compiler warnings for unreferenced arguments.
      INTEGER local_callbacktype
      local_callbacktype = callbacktype
      pi = atan(1.0)*4.0
      deginrad = 180.0 / pi

      SELECT CASE (control_name)
         CASE (IDC_SCROLLBAR_PITCHING)
         ! Scroll bar PITCHING value was modified by the user so
         ! update EDIT Box PITCHING value.
            retlog = DlgGet( dlg, IDC_SCROLLBAR_PITCHING, cel,           
     +                       dlg_position )
           far = cel - 1      !  Because SCROLLBAR always begins with 1.
           WRITE (text,*) far
           retlog = DlgSet( dlg, IDC_EDIT_PITCHING, TRIM(ADJUSTL(text)))
         CASE (IDC_SCROLLBAR_YAWING)
         ! Scroll bar YAWING value was modified by the user so
         ! update EDIT Box YAWINGG value.
            retlog = DlgGet( dlg, IDC_SCROLLBAR_YAWING, cel,            
     +                       dlg_position )
           far = cel - 1
           WRITE (text,*) far
           retlog = DlgSet( dlg, IDC_EDIT_YAWING, TRIM(ADJUSTL(text)))
         CASE (IDC_SCROLLBAR_ROLLING)
         ! Scroll bar ROLLING value was modified by the user so
         ! update EDIT Box ROLLING value.
            retlog = DlgGet( dlg, IDC_SCROLLBAR_ROLLING, cel,        
     +                       dlg_position )
           far = cel - 1
           WRITE (text,*) far
           retlog = DlgSet( dlg, IDC_EDIT_ROLLING, TRIM(ADJUSTL(text)))
         CASE (IDOK)
         ! OK Button was Clicked by the User so Redraw the Picture
            retlog = DlgGet( dlg, IDC_SCROLLBAR_PITCHING, pitch,       
     +                       dlg_position )
            retlog = DlgGet( dlg, IDC_SCROLLBAR_YAWING, yaw,       
     +                       dlg_position )
            retlog = DlgGet( dlg, IDC_SCROLLBAR_ROLLING, roll,       
     +                       dlg_position )
            retlog = DlgGet( dlg, IDC_RADIO_3D, image_3d )
            CALL Rotate_Geom( -DBLE(pitch-1)/deginrad, 
     +	                       DBLE(yaw-1-90)/deginrad, 
     +                        -DBLE(roll-1)/deginrad )
            CALL draw_shape()
         CASE (IDC_RADIO_2D)
            retlog = DLGSET (dlg, IDC_RADIO_2D, .TRUE.)
         CASE (IDC_RADIO_3D)
            retlog = DLGSET (dlg, IDC_RADIO_3D, .TRUE.)

      END SELECT
      END SUBROUTINE UpdateTemp



      SUBROUTINE Get_Geom_Unit4
***  This Routine is Used for Reading Geometry Element Data
***  Obtained in HABP MARK-IV. Data are Stored on UNIT4.

      Integer E(25), EP(25)
      DIMENSION ELEM(25)
C
      REAL  NX(10000), NY(10000), NZ(10000), NXO(10000)
      REAL(8) X1(10000), X2(10000), X3(10000), X4(10000),
     +        Y1(10000), Y2(10000), Y3(10000), Y4(10000),
     +        Z1(10000), Z2(10000), Z3(10000), Z4(10000),
     +        XS1(10000), XS2(10000), XS3(10000), XS4(10000),
     +        YS1(10000), YS2(10000), YS3(10000), YS4(10000),
     +        ZS1(10000), ZS2(10000), ZS3(10000), ZS4(10000),
     +        AL

      INTEGER SYMFCT
!      Character *4 CONFIG(15)
      Character *60 CONFIG
      COMMON /elemgeom/ nel, NX, NY, NZ, NXO, X1, X2, X3, X4, Y1, Y2,
     +                  Y3, Y4, Z1, Z2, Z3, Z4, XS1, XS2, XS3, XS4, YS1,
     +                  YS2, YS3, YS4, ZS1, ZS2, ZS3, ZS4, CONFIG, AL

      ne = 0                            !  Elements Counter

      IG4=1
      READ( 4, REC=IG4 )  CONFIG

C   OBTAIN POINTER INFO FROM UNIT 4
      IG4=2
      READ( 4, REC=IG4 ) E
      NP=E(2)                           !  Number of Panels
      NREM=E(4)
C   START PANEL DO LOOP
      DO 100 I = 1, NP
        IG4 = I * 5
        READ( 4, REC=IG4 ) EP
        ISTART=EP(3)-NREM
        N=EP(4)                           !  Number of Elements in the Panel
        SYMFCT = EP(6)                    !  Vertical Symmetry Flag
        iReflect = 1

C   START ELEMENT DO LOOP WITHIN A PANEL
        DO 99 II=1,N

          IG4=ISTART+NREM*II
   98     ne = ne + 1
          READ( 4, REC=IG4 ) ELEM

          NX(ne) = ELEM(4)
          NY(ne) = iReflect * ELEM(5)
          NZ(ne) = ELEM(6)
          X1(ne) = ELEM(11)
          X2(ne) = ELEM(12)
          X3(ne) = ELEM(13)
          X4(ne) = ELEM(14)
          Y1(ne) = iReflect * ELEM(15)
          Y2(ne) = iReflect * ELEM(16)
          Y3(ne) = iReflect * ELEM(17)
          Y4(ne) = iReflect * ELEM(18)
          Z1(ne) = ELEM(19)
          Z2(ne) = ELEM(20)
          Z3(ne) = ELEM(21)
          Z4(ne) = ELEM(22)
          IF( SYMFCT .EQ. 0 .AND. iReflect .EQ. 1 ) THEN
            iReflect = -1
            GOTO 98
          ENDIF
          iReflect = 1

   99   CONTINUE
  100 CONTINUE
      nel = ne

      END



      SUBROUTINE Get_Geom_LaWGS
***  This Routine is Used for Reading Geometry Data in LaWGS format and also
***  for generating Geometry Element Data like in HABP MARK-IV.

      Integer E(25), EP(25)
      DIMENSION ELEM(25)
C
      REAL  NX(10000), NY(10000), NZ(10000), NXO(10000)
      REAL(8) X1(10000), X2(10000), X3(10000), X4(10000),
     +        Y1(10000), Y2(10000), Y3(10000), Y4(10000),
     +        Z1(10000), Z2(10000), Z3(10000), Z4(10000),
     +        XS1(10000), XS2(10000), XS3(10000), XS4(10000),
     +        YS1(10000), YS2(10000), YS3(10000), YS4(10000),
     +        ZS1(10000), ZS2(10000), ZS3(10000), ZS4(10000),
     +        AL
      REAL(8) Xl(100,100), Yl(100,100), Zl(100,100),
     +        Xg(100,100), Yg(100,100), Zg(100,100)
      REAL(8)  NXX, NYY, NZZ
      INTEGER SYMFCT
!      Character *4 CONFIG(15)
      Character *60 CONFIG
      COMMON /elemgeom/ nel, NX, NY, NZ, NXO, X1, X2, X3, X4, Y1, Y2,
     +                  Y3, Y4, Z1, Z2, Z3, Z4, XS1, XS2, XS3, XS4, YS1,
     +                  YS2, YS3, YS4, ZS1, ZS2, ZS3, ZS4, CONFIG, AL
      ne = 0                            !  Elements Counter
! Read LaWGS file 
      READ( 4, '(a)' )  CONFIG
      ! Loop on objects
      DO WHILE( .NOT. EOF(4) )
         READ( 4, * ) 
         READ( 4, * )  NOBJ, NLINE, NPNT, ISYML, RX, RY, RZ, TX, TY, TZ, 
     +                 XSCALE, YSCALE, ZSCALE, ISYMG
         READ( 4, * )  ((Xl(m,n),Yl(m,n),Zl(m,n), m=1,NPNT), n=1,NLINE )
         KSimOXZ = 1
         KSimOXY = 1
         KSimOYZ = 1
         IF( ISYML /= 0 ) THEN
            ! Local symmetry transformation
            SELECT CASE (ISYML)
              Case (1)
                KSimOXZ = -1
              Case (2) 	 
                KSimOXY = -1
              Case (3) 	 
                KSimOYZ = -1
            END SELECT
            DO n=1,NLINE
              DO m=1, NPNT-1
                Xl(NPNT+m,n) = KSimOYZ * Xl(NPNT-m,n)
                Yl(NPNT+m,n) = KSimOXZ * Yl(NPNT-m,n)
                Zl(NPNT+m,n) = KSimOXY * Zl(NPNT-m,n)
              ENDDO
            ENDDO
            NPNT = 2*NPNT - 1
         ENDIF
         ! Local rotations, translations, and scale factors
         ! SET UP CONSTANTS FOR ROTATION EQUATIONS
         pi = atan(1.0)*4.0
         deginrad = 180.0 / pi
         THETA = RY / deginrad
         PHI   = RX / deginrad
         PSI   = RZ / deginrad
         SINTH=SIN(THETA)
         COSTH=COS(THETA)
         SINPSI=SIN(PSI)
         COSPSI=COS(PSI)
         SINPHI=SIN(PHI)
         COSPHI=COS(PHI)
         A1=COSTH*SINPSI
         A2=(COSPSI*COSPHI)+SINTH*(SINPSI*SINPHI)
         A3=-(COSPSI*SINPHI)+SINTH*(SINPSI*COSPHI)
         A4=-SINTH
         A5=COSTH*SINPHI
         A6=COSTH*COSPHI
         A7=COSTH*COSPSI
         A8=-(SINPSI*COSPHI)+SINTH*(COSPSI*SINPHI)
         A9=(SINPSI*SINPHI)+SINTH*(COSPSI*COSPHI)
      
         ! APPLY rotations, translations, and scale factors
         Xg = ( (Xl*A7 + Yl*A8 + Zl*A9) + TX ) * XSCALE
         Yg = ( (Xl*A1 + Yl*A2 + Zl*A3) + TY ) * YSCALE
         Zg = ( (Xl*A4 + Yl*A5 + Zl*A6) + TZ ) * ZSCALE
         ! End of local CS to global CS transformation.

         ! Now we have one object geometry in global CS.
         ! All need to make is creating of quadrilateral vertices and normals.
         KSimOXZ = 1
         KSimOXY = 1
         KSimOYZ = 1
         DO n=1,NLINE-1
           DO m=1, NPNT-1
             ne = ne + 1
             X1(ne) = -Xg(m,n)       !  Because of negative X in MARK-4
             X2(ne) = -Xg(m+1,n)
             X3(ne) = -Xg(m+1,n+1)
             X4(ne) = -Xg(m,n+1)
             Y1(ne) = Yg(m,n)
             Y2(ne) = Yg(m+1,n)
             Y3(ne) = Yg(m+1,n+1)
             Y4(ne) = Yg(m,n+1)
             Z1(ne) = Zg(m,n)
             Z2(ne) = Zg(m+1,n)
             Z3(ne) = Zg(m+1,n+1)
             Z4(ne) = Zg(m,n+1)
             !  FORM DIAGONAL VECTORS
             T1X=X3(ne)-X1(ne)
             T2X=X4(ne)-X2(ne)
             T1Y=Y3(ne)-Y1(ne)
             T2Y=Y4(ne)-Y2(ne)
             T1Z=Z3(ne)-Z1(ne)
             T2Z=Z4(ne)-Z2(ne)
             !  FORM CROSS PRODUCT  N=T2*T1
             NXX=T2Y*T1Z-T1Y*T2Z            
             NYY=T1X*T2Z-T2X*T1Z            
             NZZ=T2X*T1Y-T1X*T2Y            
             VN=dsqrt(NXX*NXX+NYY*NYY+NZZ*NZZ)   
             IF (VN .EQ. 0.0) VN = 1.0      
             !  FORM UNIT NORMAL VECTOR    
             NX(ne)=NXX/VN                      
             NY(ne)=NYY/VN                      
             NZ(ne)=NZZ/VN                      
             IF( ISYMG /= 0 ) THEN
             ! Global symmetry transformation
                ne = ne + 1
                SELECT CASE (ISYMG)
                   Case (1)
                      KSimOXZ = -1
                   Case (2) 	 
                      KSimOXY = -1
                   Case (3) 	 
                      KSimOYZ = -1
                END SELECT
                X1(ne) = KSimOYZ * X1(ne-1)
                X2(ne) = KSimOYZ * X2(ne-1)
                X3(ne) = KSimOYZ * X3(ne-1)
                X4(ne) = KSimOYZ * X4(ne-1)
                NX(ne) = KSimOYZ * NX(ne-1)
                Y1(ne) = KSimOXZ * Y1(ne-1)
                Y2(ne) = KSimOXZ * Y2(ne-1)
                Y3(ne) = KSimOXZ * Y3(ne-1)
                Y4(ne) = KSimOXZ * Y4(ne-1)
                NY(ne) = KSimOXZ * NY(ne-1)
                Z1(ne) = KSimOXY * Z1(ne-1)
                Z2(ne) = KSimOXY * Z2(ne-1)
                Z3(ne) = KSimOXY * Z3(ne-1)
                Z4(ne) = KSimOXY * Z4(ne-1)
                NZ(ne) = KSimOXY * NZ(ne-1)
                KSimOXZ = 1
                KSimOXY = 1
                KSimOYZ = 1
             ENDIF
           ENDDO
         ENDDO
      ENDDO
      nel = ne
      END



      SUBROUTINE Rotate_Geom( THETA, PSI, PHI )
***  This Routine is Used for Projecting Geometry Element Data
***  Generated in HABP MARK-IV onto Viewing Direction.
      REAL  NX(10000), NY(10000), NZ(10000), NXO(10000)
      REAL(8) X1(10000), X2(10000), X3(10000), X4(10000),
     +        Y1(10000), Y2(10000), Y3(10000), Y4(10000),
     +        Z1(10000), Z2(10000), Z3(10000), Z4(10000),
     +        XS1(10000), XS2(10000), XS3(10000), XS4(10000),
     +        YS1(10000), YS2(10000), YS3(10000), YS4(10000),
     +        ZS1(10000), ZS2(10000), ZS3(10000), ZS4(10000), AL,
     +        tmp(10000)
      REAL(8) THETA, PSI, PHI
      REAL(8) xmax, xeye, yeye, zeye, xvpln

      Character *60 CONFIG
      LOGICAL image_3d
      COMMON /elemgeom/ nel, NX, NY, NZ, NXO, X1, X2, X3, X4, Y1, Y2,
     +                  Y3, Y4, Z1, Z2, Z3, Z4, XS1, XS2, XS3, XS4, YS1,
     +                  YS2, YS3, YS4, ZS1, ZS2, ZS3, ZS4, CONFIG, AL
      COMMON /view_type/ image_3d

C   SET UP CONSTANTS FOR ROTATION EQUATIONS
      SINTH=SIN(THETA)
      COSTH=COS(THETA)
      SINPSI=SIN(PSI)
      COSPSI=COS(PSI)
      SINPHI=SIN(PHI)
      COSPHI=COS(PHI)
      A1=COSTH*SINPSI
      A2=(COSPSI*COSPHI)+SINTH*(SINPSI*SINPHI)
      A3=-(COSPSI*SINPHI)+SINTH*(SINPSI*COSPHI)
      A4=-SINTH
      A5=COSTH*SINPHI
      A6=COSTH*COSPHI
      A7=COSTH*COSPSI
      A8=-(SINPSI*COSPHI)+SINTH*(COSPSI*SINPHI)
      A9=(SINPSI*SINPHI)+SINTH*(COSPSI*COSPHI)

C   APPLY ROTATION MATRIX TO ELEMENT
      NXO = NX*A7 + NY*A8 + NZ*A9
      XS1 = X1*A7 + Y1*A8 + Z1*A9
      XS2 = X2*A7 + Y2*A8 + Z2*A9
      XS3 = X3*A7 + Y3*A8 + Z3*A9
      XS4 = X4*A7 + Y4*A8 + Z4*A9
      YS1 = X1*A1 + Y1*A2 + Z1*A3
      YS2 = X2*A1 + Y2*A2 + Z2*A3
      YS3 = X3*A1 + Y3*A2 + Z3*A3
      YS4 = X4*A1 + Y4*A2 + Z4*A3
      ZS1 = X1*A4 + Y1*A5 + Z1*A6
      ZS2 = X2*A4 + Y2*A5 + Z2*A6
      ZS3 = X3*A4 + Y3*A5 + Z3*A6
      ZS4 = X4*A4 + Y4*A5 + Z4*A6

      IF( image_3d ) THEN
       ! Get Perspective Image
         tmp = MIN( XS1, XS2, XS3, XS4 )
         xmax = MINVAL( tmp )
         xeye = xmax * 4.0
         yeye = xmax * 0.01
         zeye = xmax * 0.01
         xvpln = xmax * 1.0
         YS1 = YS1 + (YS1 - yeye) / (XS1 - xeye) * (xvpln - XS1)
         YS2 = YS2 + (YS2 - yeye) / (XS2 - xeye) * (xvpln - XS2)
         YS3 = YS3 + (YS3 - yeye) / (XS3 - xeye) * (xvpln - XS3)
         YS4 = YS4 + (YS4 - yeye) / (XS4 - xeye) * (xvpln - XS4)
         ZS1 = ZS1 + (ZS1 - zeye) / (XS1 - xeye) * (xvpln - XS1)
         ZS2 = ZS2 + (ZS2 - zeye) / (XS2 - xeye) * (xvpln - XS2)
         ZS3 = ZS3 + (ZS3 - zeye) / (XS3 - xeye) * (xvpln - XS3)
         ZS4 = ZS4 + (ZS4 - zeye) / (XS4 - xeye) * (xvpln - XS4)
      ENDIF

      END



      SUBROUTINE set_video_mode()
      USE MSFLIB
      USE strings_interfaces
      LOGICAL             statusmode
      TYPE (windowconfig) myscreen
      TYPE (qwinfo) winfo
      COMMON  myscreen

      REAL  NX(10000), NY(10000), NZ(10000), NXO(10000)
      REAL(8) X1(10000), X2(10000), X3(10000), X4(10000),
     +        Y1(10000), Y2(10000), Y3(10000), Y4(10000),
     +        Z1(10000), Z2(10000), Z3(10000), Z4(10000),
     +        XS1(10000), XS2(10000), XS3(10000), XS4(10000),
     +        YS1(10000), YS2(10000), YS3(10000), YS4(10000),
     +        ZS1(10000), ZS2(10000), ZS3(10000), ZS4(10000), AL
      Character *60 CONFIG
      COMMON /elemgeom/ nel, NX, NY, NZ, NXO, X1, X2, X3, X4, Y1, Y2,
     +                  Y3, Y4, Z1, Z2, Z3, Z4, XS1, XS2, XS3, XS4, YS1,
     +                  YS2, YS3, YS4, ZS1, ZS2, ZS3, ZS4, CONFIG, AL

!
!     Set the screen to the best resolution and maximum number of
!     available colors.
      myscreen.numxpixels   = -1
      myscreen.numypixels   = -1
      myscreen.numtextcols  = -1
      myscreen.numtextrows  = -1
      myscreen.numcolors    = -1
      myscreen.fontsize     = -1
      myscreen.title = TRIM( ru_doswin( CONFIG, .TRUE. ) ) // ""C
      statusmode =ABOUTBOXQQ('Geometry Visualization in HABP MARK-4.\n\n
     +       Author -  Igor Polyakov\n\n            Ukraine, 1999.'C)
      statusmode = SETWINDOWCONFIG(myscreen)
      IF(.NOT. statusmode) statusmode = SETWINDOWCONFIG(myscreen)

      statusmode = GETWINDOWCONFIG( myscreen )

      ! QuickWin - Maximize frame window
      winfo.TYPE = QWIN$MAX
      result = SETWSIZEQQ(QWIN$FRAMEWINDOW, winfo)
      ! QuickWin - Maximize child window
      result = SETWSIZEQQ(0, winfo)
      ! Set Foreground Color
      result = SETCOLORRGB( #000000 )     !  Black
      ! Set Background Color
      result = SETBKCOLORRGB( #FFFFFF )   !  White
      CALL CLEARSCREEN( $GCLEARSCREEN )

      END



      SUBROUTINE draw_shape()
      USE MSFLIB
      INTEGER(2)            status, halfx, halfy
      INTEGER(2)            xwidth, yheight, cols, rows
      INTEGER(2)            xo_vp, yo_vp, xk_vp, yk_vp
      TYPE (windowconfig)   myscreen
      COMMON                myscreen
      TYPE (wxycoord)       wxy
      REAL (8) xmin, xmax, zmin, zmax, AL
      REAL  NX(10000), NY(10000), NZ(10000), NXO(10000)
      REAL(8) X1(10000), X2(10000), X3(10000), X4(10000),
     +        Y1(10000), Y2(10000), Y3(10000), Y4(10000),
     +        Z1(10000), Z2(10000), Z3(10000), Z4(10000),
     +        XS1(10000), XS2(10000), XS3(10000), XS4(10000),
     +        YS1(10000), YS2(10000), YS3(10000), YS4(10000),
     +        ZS1(10000), ZS2(10000), ZS3(10000), ZS4(10000),
     +        tmp(10000)
      Character *60 CONFIG
      COMMON /elemgeom/ nel, NX, NY, NZ, NXO, X1, X2, X3, X4, Y1, Y2,
     +                  Y3, Y4, Z1, Z2, Z3, Z4, XS1, XS2, XS3, XS4, YS1,
     +                  YS2, YS3, YS4, ZS1, ZS2, ZS3, ZS4, CONFIG, AL

      CALL CLEARSCREEN( $GCLEARSCREEN )

      xwidth  = myscreen.numxpixels
      yheight = myscreen.numypixels
      cols    = myscreen.numtextcols
      rows    = myscreen.numtextrows
      halfx   = xwidth / 2
      halfy   = (yheight / rows) * ( rows / 2 )

! Get Scale Window Coordinates
      tmp = MIN( YS1, YS2, YS3, YS4 )
      xmin = MINVAL( tmp )
      tmp = MAX( YS1, YS2, YS3, YS4 )
      xmax = MAXVAL( tmp )
      tmp = MIN( ZS1, ZS2, ZS3, ZS4 )
      zmin = MINVAL( tmp )
      tmp = MAX( ZS1, ZS2, ZS3, ZS4 )
      zmax = MAXVAL( tmp )
!
!     Set window
!
      delx = xwidth * 0.7 * (xmax - xmin) / AL
!      xo_vp = ( xwidth - delx ) / 2
      xo_vp = ( xwidth - delx ) / 1.5
      xk_vp = xo_vp + delx
      del_yvp = delx * ( zmax - zmin ) /
     +                 ( xmax - xmin )
      yo_vp = ( yheight - del_yvp ) / 2 - 2*yheight/rows
      yk_vp = yo_vp + del_yvp

!      status = RECTANGLE( $GBORDER, xo_vp, yo_vp, xk_vp, yk_vp )

      CALL SETVIEWPORT( xo_vp, yo_vp, xk_vp, yk_vp )
      CALL SETTEXTWINDOW( INT2(1), INT2(1), rows / 2, cols / 2 )
      status = SETWINDOW( .TRUE., xmin, zmin, xmax, zmax )

! Draw Aircraft Shape
      DO i = 1, nel
         IF( NXO(i) .GT. 0.0 ) THEN

            CALL MOVETO_W( YS1(i), ZS1(i), wxy )
            status = LINETO_W( YS2(i), ZS2(i) )
            status = LINETO_W( YS3(i), ZS3(i) )
            status = LINETO_W( YS4(i), ZS4(i) )
            status = LINETO_W( YS1(i), ZS1(i) )

         ENDIF
      ENDDO

      END
